--
-- Fran Font definitions
--

-- Last modified Sat Sep 07 23:23:11 1996
module Font
       (
        Font(..),   
        Family(..),

        system,     -- :: Font
        timesRoman, -- :: Font
        courier,    -- :: Font
        arial,      -- :: Font 
        symbol,     -- :: Font

        bold,       -- :: Font -> Font
        italic      -- :: Font -> Font

       ) where

data Font
 = Font { 
     family   :: Family, 
     isBold   :: Bool,
     isItalic :: Bool
   }
   deriving Show

system     :: Font
timesRoman :: Font
courier    :: Font
arial      :: Font
symbol     :: Font
bold       :: Font -> Font
italic     :: Font -> Font

system     = Font { family = System,     isBold = False, isItalic = False }
timesRoman = Font { family = TimesRoman, isBold = False, isItalic = False }
courier    = Font { family = Courier,    isBold = False, isItalic = False }
arial      = Font { family = Arial,      isBold = False, isItalic = False }
symbol     = Font { family = Symbol,     isBold = False, isItalic = False }

{- Font operators, adding attributes -}

bold   f = f { isBold   = True }
italic f = f { isItalic = True }

{-
 Representation of font families differs from the AxA type,
 in that we specify concretely the name of the family rather
 than its properties (
-}

{- The standard TrueType collection supplied with 95/NT 
   System isn't TrueType, but I'll toss it in for now.
 -}

data Family
 = System     -- default
 | TimesRoman
 | Courier
 | Arial
 | Symbol
   deriving Show
