--
-- Fran Lifted 2D Vector operations
--
-- Last modified Thu Nov 07 14:33:02 1996

module Vector2B (
	Vector2B, Vector2,
	xVector2,     yVector2, 
	vector2XY,    vector2XYCoords,
	vector2Polar, vector2PolarCoords
	) where
import qualified Vector2 as V
import Vector2(Vector2)
import Fuzzy
import Behavior
import BaseTypes

type Vector2B = Behavior V.Vector2

xVector2, yVector2 :: Vector2B   -- unit vectors
vector2XY          :: Behavior RealVal -> Behavior RealVal -> Vector2B
vector2Polar       :: Behavior Length  -> Behavior Radians -> Vector2B
vector2XYCoords    :: Vector2B -> Behavior (RealVal, RealVal)
vector2PolarCoords :: Vector2B -> Behavior (Length,  Radians)

xVector2           = lift0 V.xVector2
yVector2           = lift0 V.yVector2
vector2XY          = lift2 V.vector2XY (noI "vector2XY")
vector2Polar       = lift2 V.vector2Polar (noI "vector2Polar")
vector2XYCoords    = lift1 V.vector2XYCoords (noI "vector2XYCoords")
vector2PolarCoords = lift1 V.vector2PolarCoords (noI "vector2PolarCoords")

-- Vector space operations lifted in VectorSpaceB.hs
