\begin{code}

module MutableArray
	( MutableArray
	  -- instance Eq (MutableArray s ix elt)

	, newArray
	, boundsOfArray
	, readArray
	, writeArray
	, freezeArray

	-- Omissions:
	-- - unsafeFreezeArray
	-- - thawArray
	-- - MutableByteArrays

	, ST
	, Ix
	) where

import STArray( MutArr, newArr, readArr, writeArr, freezeArr, boundsOfArr )
import Array( Array )

newtype MutableArray s ix elt = MutableArray (MutArr s ix elt)
 deriving (Eq)

unA :: MutableArray s ix elt -> MutArr s ix elt
unA (MutableArray a) = a

newArray            :: Ix ix => (ix,ix) -> elt -> ST s (MutableArray s ix elt)
boundsOfArray       :: Ix ix => MutableArray s ix elt -> (ix, ix)
readArray           :: Ix ix => MutableArray s ix elt -> ix -> ST s elt
writeArray          :: Ix ix => MutableArray s ix elt -> ix -> elt -> ST s ()
freezeArray         :: Ix ix => MutableArray s ix elt -> ST s (Array ix elt)
--unsafeFreezeArray :: Ix ix => MutableArray s ix elt -> ST s (Array ix elt)
--thawArray         :: Ix ix => Array ix elt -> ST s (MutableArray s ix elt)

newArray bs e        = map MutableArray (newArr bs e)
readArray a i 	     = readArr (unA a) i
writeArray a i e     = writeArr (unA a) i e
freezeArray a        = freezeArr (unA a)
boundsOfArray a      = boundsOfArr (unA a)

--unsafeFreezeArray -- not supported
--thawArray         -- not supported

\end{code}
