################################################################
# Bitsets
#
# Copyright (c) The University of Nottingham and Yale University, 1994-1997.
# All rights reserved. See NOTICE for details and conditions of use etc...
# Hugs version 1.4, March 1997
#
# $RCSfile: BitSet.ss,v $
# $Revision: 1.4 $
# $Date: 1997/03/17 18:40:47 $
################################################################

# ToDo: develop into full library of bitset operations

{{%
class BitSet a where
 toWord32 :: a -> Word32
 fromWord32 :: Word32 -> a

-- really want a Word32 instance - but that's a synonym for Int so...
instance BitSet Int where
 toWord32   = id
 fromWord32 = id

orb, andb :: BitSet a => a -> a -> a
orb x y = fromWord32 (orWord32 (toWord32 x) (toWord32 y))
andb x y = fromWord32 (andWord32 (toWord32 x) (toWord32 y))

notb :: BitSet a => a -> a
notb x = fromWord32 (notWord32 (toWord32 x))

emptyb, fullb :: BitSet a => a
emptyb = fromWord32 emptyWord32
fullb  = fromWord32 fullWord32

{- Sigh, I ought to know better by now... not legal Haskell
instance BitSet a => Eq a where
  x == y = toWord32 x == toWord32 y
-}

eqb :: BitSet a => a -> a -> Bool
x `eqb` y =  toWord32 x `eqWord32` toWord32 y

isEmptyb :: BitSet a => a -> Bool
isEmptyb x = x `eqb` emptyb

elemb :: BitSet a => Int -> a -> Bool
x `elemb` y = x `elemWord32` toWord32 y

shiftl, shiftr :: BitSet a => a -> Int -> a
shiftl x y = fromWord32 (shiftlWord32 (toWord32 x) y)
shiftr x y = fromWord32 (shiftrWord32 (toWord32 x) y)

orbs, andbs :: BitSet a => [a] -> a
orbs  = foldl orb  emptyb
andbs = foldl andb fullb
%}}

%prim orWord32 :: Word32 -> Word32 -> Word32
%return($0 | $1);

%prim andWord32 :: Word32 -> Word32 -> Word32
%return($0 & $1);

%prim notWord32 :: Word32 -> Word32
%return(~$0);

%const Word32 emptyWord32 = 0
%const Word32 fullWord32  = ~0

%prim eqWord32 :: Word32 -> Word32 -> Bool
%return($0 == $1);

%prim elemWord32 :: Int -> Word32 -> Bool
%return((1 << $0) & $1);

%prim shiftlWord32 :: Word32 -> Int -> Word32
%return($0 << $1);

%prim shiftrWord32 :: Word32 -> Int -> Word32
%return($0 >> $1);

################################################################
# End of bitset ops
################################################################

