################################################################
# Pointer types
#
# Copyright (c) The University of Nottingham and Yale University, 1994-1997.
# All rights reserved. See NOTICE for details and conditions of use etc...
# Hugs version 1.4, March 1997
#
# $RCSfile: Pointers.ss,v $
# $Revision: 1.4 $
# $Date: 1997/03/17 18:40:49 $
################################################################

{{%
class Pointer a where
  toPtr   :: a -> Ptr
  fromPtr :: Ptr -> a 
  alloc   :: IO a          -- never returns NULL ptr, may raise error.
  plus    :: a -> Int -> a
  minus   :: a -> a -> Int

free :: Pointer a => a -> IO ()
free p = freePtr (toPtr p)

cast :: (Pointer a, Pointer b) => a -> b
cast = fromPtr . toPtr

malloc :: Pointer a => Int -> IO a
malloc sz = primMalloc sz >>= \ p -> return (fromPtr p)

instance Pointer Ptr where
  toPtr   = id
  fromPtr = id
  alloc   = primMalloc 0
  plus    = plusPtr
  minus   = minusPtr
%}}

%constructor HeapExhaustion :: IOError
%error : HeapExhaustion : LPVOID $0 : !($0) : %constructor(HeapExhaustion);%

%prim freePtr :: Ptr -> IO ()
free($0);
%return();

%prim primMalloc :: Int -> IO Ptr
Ptr p = malloc($0);
%errreturn(HeapExhaustion,p,p);

# End of Pointers.ss