################################################################
# Dialog box creation
#
# Copyright (c) The University of Nottingham and Yale University, 1994-1997.
# All rights reserved. See NOTICE for details and conditions of use etc...
# Hugs version 1.4, March 1997
#
# $RCSfile: WinCommDlg.ss,v $
# $Revision: 1.4 $
# $Date: 1997/03/17 18:40:53 $
################################################################

%newtype : DialogBoxStyle : Int : (Eq)

# Dialog Box Styles
# Choose any combination of these
%const DialogBoxStyle DS_ABSALIGN         
%const DialogBoxStyle DS_SYSMODAL         
%const DialogBoxStyle DS_LOCALEDIT        # 16-bit applications only
%const DialogBoxStyle DS_SETFONT          
%const DialogBoxStyle DS_MODALFRAME       
%const DialogBoxStyle DS_NOIDLEMSG        

# ToDo: need a way to specify the callback routine - see what I did
# with genericWndProc.

%prim createDialogBox :: String -> WindowStyle -> DialogBoxStyle -> MbPos -> MbPos -> MbPos -> MbPos -> HWND -> MbHMENU -> HANDLE -> IO HWND
HWND r = CreateWindow("DIALOG", $0, $1|$2, $3,$4,$5,$6, $7, $8, $9, NULL);
%errreturn(NullHANDLE,r,r);


################################################################
# Common dialogue boxes
################################################################

%newtype : CommDlgError : DWORD : (Show)

%constructor CommDlgError :: CommDlgError -> IOError
%error CommDlgFalse : BOOL $0 : !($0) : %constructor(CommDlgError,CommDlgExtendedError());

%const CommDlgError CDERR_DIALOGFAILURE    

%const CommDlgError CDERR_GENERALCODES     
%const CommDlgError CDERR_STRUCTSIZE       
%const CommDlgError CDERR_INITIALIZATION   
%const CommDlgError CDERR_NOTEMPLATE       
%const CommDlgError CDERR_NOHINSTANCE      
%const CommDlgError CDERR_LOADSTRFAILURE   
%const CommDlgError CDERR_FINDRESFAILURE   
%const CommDlgError CDERR_LOADRESFAILURE   
%const CommDlgError CDERR_LOCKRESFAILURE   
%const CommDlgError CDERR_MEMALLOCFAILURE  
%const CommDlgError CDERR_MEMLOCKFAILURE   
%const CommDlgError CDERR_NOHOOK           
%const CommDlgError CDERR_REGISTERMSGFAIL  

%const CommDlgError PDERR_PRINTERCODES     
%const CommDlgError PDERR_SETUPFAILURE     
%const CommDlgError PDERR_PARSEFAILURE     
%const CommDlgError PDERR_RETDEFFAILURE    
%const CommDlgError PDERR_LOADDRVFAILURE   
%const CommDlgError PDERR_GETDEVMODEFAIL   
%const CommDlgError PDERR_INITFAILURE      
%const CommDlgError PDERR_NODEVICES        
%const CommDlgError PDERR_NODEFAULTPRN     
%const CommDlgError PDERR_DNDMMISMATCH     
%const CommDlgError PDERR_CREATEICFAILURE  
%const CommDlgError PDERR_PRINTERNOTFOUND  
%const CommDlgError PDERR_DEFAULTDIFFERENT 

%const CommDlgError CFERR_CHOOSEFONTCODES  
%const CommDlgError CFERR_NOFONTS          
%const CommDlgError CFERR_MAXLESSTHANMIN   

%const CommDlgError FNERR_FILENAMECODES    
%const CommDlgError FNERR_SUBCLASSFAILURE  
%const CommDlgError FNERR_INVALIDFILENAME  
%const CommDlgError FNERR_BUFFERTOOSMALL   

%const CommDlgError FRERR_FINDREPLACECODES 
%const CommDlgError FRERR_BUFFERLENGTHZERO 

%const CommDlgError CCERR_CHOOSECOLORCODES 



################################################################
# The ChooseFont common dialog box
################################################################

# Wow, this is really intricate!
# ToDo:
# * Maybe create a data type for building the input structure:
#   data ChooseFontFlag
#     = CF_APPPLY
#     | CF_ANSIONLY
#     | CF_BOTH
#     | CF_TTONLY
#     | CF_EFFECTS Bool Bool COLORREF
#     | CF_ENABLEHOOK ChooseFontHook
#     | CF_ENABLETEMPLATE HINSTANCE
#     ...
# * Use the usual generic callback trick to implement the hook
# * Separate into two parts: input arguments and output arguments
#   Use Maybes where appropriate
# 
# 
# these are extra nFontType bits that are added to what is returned to the
# EnumFonts callback routine
# 
# %const FontType SIMULATED_FONTTYPE
# %const FontType PRINTER_FONTTYPE  
# %const FontType SCREEN_FONTTYPE   
# %const FontType BOLD_FONTTYPE     
# %const FontType ITALIC_FONTTYPE   
# %const FontType REGULAR_FONTTYPE  
#
#
# %newtype : ChooseFontFlag : DWORD : ()
# 
# %const ChooseFontFlag CF_SCREENFONTS               
# %const ChooseFontFlag CF_PRINTERFONTS              
# %const ChooseFontFlag CF_BOTH                  # == CF_SCREENFONTS | CF_PRINTERFONTS
# %const ChooseFontFlag CF_SHOWHELP              # hwndOwner must not be null
# %const ChooseFontFlag CF_ENABLEHOOK            
# %const ChooseFontFlag CF_ENABLETEMPLATE        
# %const ChooseFontFlag CF_ENABLETEMPLATEHANDLE  
# %const ChooseFontFlag CF_INITTOLOGFONTSTRUCT   
# %const ChooseFontFlag CF_USESTYLE              
# %const ChooseFontFlag CF_EFFECTS               # use rgbColors, lfStrikOut and lfUnderline fields
# %const ChooseFontFlag CF_APPLY                 
# %const ChooseFontFlag CF_ANSIONLY              
# %const ChooseFontFlag CF_NOVECTORFONTS         
# %const ChooseFontFlag CF_NOOEMFONTS            # == CF_NOVECTORFONTS
# %const ChooseFontFlag CF_NOSIMULATIONS         
# %const ChooseFontFlag CF_LIMITSIZE             
# %const ChooseFontFlag CF_FIXEDPITCHONLY        
# %const ChooseFontFlag CF_WYSIWYG               # must also have CF_SCREENFONTS & CF_PRINTERFONTS
# %const ChooseFontFlag CF_FORCEFONTEXIST            
# %const ChooseFontFlag CF_SCALABLEONLY              
# %const ChooseFontFlag CF_TTONLY                    
# %const ChooseFontFlag CF_NOFACESEL                 
# %const ChooseFontFlag CF_NOSTYLESEL                
# %const ChooseFontFlag CF_NOSIZESEL                 
# 
# %synonym : ChooseFontHook : UINT (CALLBACK* : lpfnHook)(HWND, UINT, WPARAM, LPARAM)
# 
# %maybe : MbChooseFontHook : ChooseFontHook : $0 : (ChooseFontHook) 0
# 
# %struct : CHOOSEFONT : CHOOSEFONT $0
#     DWORD           : lStructSize
#     MbHWND          : hwndOwner;          # caller's window handle
#     MbHDC           : hDC;                # printer DC/IC or NULL 
#     LOGFONT FAR*    : lpLogFont;          # ptr. to a LOGFONT struct
#     INT             : iPointSize;         # 10 * size in points of selected font
#     ChooseFontFlag  : Flags;              # enum. type flags       
#     COLORREF        : rgbColors;          # returned text color    
#     LPARAM          : lCustData;          # data passed to hook fn.
#     MbChooseFontHook : lpfnHook           # ptr. to hook function
#     LPCSTR          : lpTemplateName;     # custom template name     
#     HINSTANCE       : hInstance;          # instance handle of.EXE that contains cust. dlg. template
#     LPSTR           : lpszStyle;          # return the style field here must be LF_FACESIZE or bigger */
#     UINT            : nFontType;          # same value reported to the EnumFonts call back with the extra FONTTYPE_ bits added 
#     int             : nSizeMin;           # minimum pt size allowed & 
#     int             : nSizeMax;           # max pt size allowed if CF_LIMITSIZE is used
# 

