################################################################
# Miscellaneous Win32 functions
#
# Copyright (c) The University of Nottingham and Yale University, 1994-1997.
# All rights reserved. See NOTICE for details and conditions of use etc...
# Hugs version 1.4, March 1997
#
# $RCSfile: WinMisc.ss,v $
# $Revision: 1.3 $
# $Date: 1997/03/10 18:46:14 $
################################################################

%fun CreateBMPFile :: String -> HBITMAP -> HDC -> IO ()

#
# Simplified font creation
#

{%
#include "EzFont.h"
%}

%synonym : EZATTR : DWORD

%const EZATTR EZ_ATTR_BOLD
%const EZATTR EZ_ATTR_ITALIC
%const EZATTR EZ_ATTR_UNDERLINE
%const EZATTR EZ_ATTR_STRIKEOUT

%fun EzCreateFont :: HDC -> String -> Int -> Int -> EZATTR -> Bool -> IO HFONT


%prim loWord :: LPARAM -> Int
%return(LOWORD((LONG)$0));

%prim hiWord :: LPARAM -> Int
%return(HIWORD((LONG)$0));

# Shameful hack.  Just like timeGetTime, but taking a bogus integer
# argument, just to trick dependency analysis.  The second part of the
# hack is to do unsafePerformIO (or, equivalently, 

{%
MilliSeconds reallyTimeGetTime (int bogus) { return timeGetTime(); }
%}

%fun reallyTimeGetTime :: Int -> IO MilliSeconds

# Under NT, these functions improve the time resolution greatly.  I
# wonder, however, whether they make NT perform worse overall.

%fun timeBeginPeriod :: UINT -> IO UINT
%fun timeEndPeriod   :: UINT -> IO UINT
