################################################################
# Machine independent types for Win32
#
# Copyright (c) The University of Nottingham and Yale University, 1994-1997.
# All rights reserved. See NOTICE for details and conditions of use etc...
# Hugs version 1.4, March 1997
#
# $RCSfile: WinPlatform.ss,v $
# $Revision: 1.5 $
# $Date: 1997/03/17 18:40:59 $
################################################################

# ToDo: try to eliminate all use of these types

# The following mappings apply for the 32-bit Borland C compiler.
# Under the 16-bit compiler, UINT and INT should be Word16 and Int16 
# respectively. 

# ToDo: is this definition portable?
%synonym : FLOAT     : Float  : notypedef
		     	      
%synonym : BYTE      : Word8  : notypedef
%synonym : USHORT    : Word16 : notypedef
%synonym : UINT      : Word32 : notypedef
%synonym : INT       : Int32  : notypedef
%synonym : WORD      : Word16 : notypedef
%synonym : DWORD     : Word32 : notypedef
%synonym : LONG      : Int32  : notypedef
%synonym : ATOM      : UINT   : notypedef
%synonym : WPARAM    : UINT   : notypedef
%synonym : LPARAM    : LONG   : notypedef
%synonym : LRESULT   : LONG   : notypedef
%synonym : LPVOID    : Ptr    : notypedef
%synonym : LPBYTE    : Ptr    : notypedef
			      
%maybe   : MbString  : String : $0 : (String) 0
%maybe   : MbINT     : INT    : $0 : (INT)    0
%maybe   : MbFLOAT   : FLOAT  : $0 : (FLOAT)  0
%maybe   : MbLPVOID  : LPVOID : $0 : (LPVOID) 0
%maybe   : MbDWORD   : DWORD  : $0 : (DWORD)  0

%array   : ListINT   : INT    : INT
%array   : ListFLOAT : FLOAT  : FLOAT
{{%
type ListINT   = [INT]
type ListFLOAT = [FLOAT]
%}}

# We have much less use for the other pointer types - so we don't
# have as rich a set of operations on them.

%type : NearPtr : NearPtr $0 : %pack(Ptr,$0); : %unpack(Ptr,$0,$1)
%type : FarPtr  : FarPtr  $0 : %pack(Ptr,$0); : %unpack(Ptr,$0,$1)
{{%
newtype NearPtr = NearPtr Ptr deriving (Eq)
newtype FarPtr  = FarPtr  Ptr deriving (Eq)
%}}
{%
typedef void near* NearPtr;
typedef void far*  FarPtr;
%}



