################################################################
# X types and constants
# This file is %included into Xlib.ss
#
# First attempt at writing a plugin - needs cleaned up
#
# Copyright (c) The University of Nottingham and Yale University, 1994-1997.
# All rights reserved. See NOTICE for details and conditions of use etc...
# Hugs version 1.4, March 1997
#
# $RCSfile: X.ss,v $
# $Revision: 1.6 $
# $Date: 1997/07/03 22:26:18 $
################################################################

################################################################
# Basic types
################################################################

# the following types are defined in X.h

%newtype : XID      : Word32   : () : notypedef
%newtype : Atom     : Int      : () : notypedef
%newtype : VisualID : Int      : () : notypedef
%newtype : Time     : Int      : () : notypedef
%newtype : Drawable : XID      : () : notypedef
%newtype : Cursor   : XID      : () : notypedef
%newtype : Colormap : XID      : () : notypedef
%newtype : KeySym   : XID      : () : notypedef
%newtype : Font     : XID      : () : notypedef

%synonym : Pixmap   : Drawable : notypedef
%synonym : Window   : Drawable : notypedef
%synonym : KeyCode  : CHAR     : notypedef

# it's sometimes useful to treat a GContext as a Font (ie the Font it
# contains) - but we'll ignore that for now.
%newtype : GContext : XID : () : notypedef


################################################################
# Event Masks
################################################################

{{%
--infixr 3 `andMask`
--infixr 2 `orMask`
%}}

%newtype : Mask : Int : (Eq) : notypedef

%prim orMask :: Mask -> Mask -> Mask
%return($0|$1);

%prim andMask :: Mask -> Mask -> Mask
%return($0&$1);

%prim notMask :: Mask -> Mask
%return(~$0);

%const EventMask emptyMask = 0

################################################################
# Event Masks
################################################################

%synonym : EventMask : Mask

%const EventMask	NoEventMask
%const EventMask	KeyPressMask
%const EventMask	KeyReleaseMask
%const EventMask	ButtonPressMask
%const EventMask	ButtonReleaseMask
%const EventMask	EnterWindowMask
%const EventMask	LeaveWindowMask
%const EventMask	PointerMotionMask
%const EventMask	PointerMotionHintMask
%const EventMask	Button1MotionMask
%const EventMask	Button2MotionMask
%const EventMask	Button3MotionMask
%const EventMask	Button4MotionMask
%const EventMask	Button5MotionMask
%const EventMask	ButtonMotionMask
%const EventMask	KeymapStateMask
%const EventMask	ExposureMask
%const EventMask	VisibilityChangeMask
%const EventMask	StructureNotifyMask
%const EventMask	ResizeRedirectMask
%const EventMask	SubstructureNotifyMask
%const EventMask	SubstructureRedirectMask
%const EventMask	FocusChangeMask
%const EventMask	PropertyChangeMask
%const EventMask	ColormapChangeMask
%const EventMask	OwnerGrabButtonMask


################################################################
# Event Types
################################################################

%newtype : EventType : Int : (Eq)

%const EventType	KeyPress
%const EventType	KeyRelease
%const EventType	ButtonPress
%const EventType	ButtonRelease
%const EventType	MotionNotify
%const EventType	EnterNotify
%const EventType	LeaveNotify
%const EventType	FocusIn
%const EventType	FocusOut
%const EventType	KeymapNotify
%const EventType	Expose
%const EventType	GraphicsExpose
%const EventType	NoExpose
%const EventType	VisibilityNotify
%const EventType	CreateNotify
%const EventType	DestroyNotify
%const EventType	UnmapNotify
%const EventType	MapNotify
%const EventType	MapRequest
%const EventType	ReparentNotify
%const EventType	ConfigureNotify
%const EventType	ConfigureRequest
%const EventType	GravityNotify
%const EventType	ResizeRequest
%const EventType	CirculateNotify
%const EventType	CirculateRequest
%const EventType	PropertyNotify
%const EventType	SelectionClear
%const EventType	SelectionRequest
%const EventType	SelectionNotify
%const EventType	ColormapNotify
%const EventType	ClientMessage
%const EventType	MappingNotify
%const EventType	LASTEvent


################################################################
# Modifiers
################################################################

%newtype : Modifier : Mask : ()

%const Modifier	ShiftMapIndex
%const Modifier	LockMapIndex
%const Modifier	ControlMapIndex
%const Modifier	Mod1MapIndex
%const Modifier	Mod2MapIndex
%const Modifier	Mod3MapIndex
%const Modifier	Mod4MapIndex
%const Modifier	Mod5MapIndex
%const Modifier	AnyModifier


################################################################
# Key masks
################################################################

%synonym : KeyMask : Modifier

%const KeyMask	ShiftMask
%const KeyMask	LockMask
%const KeyMask	ControlMask
%const KeyMask	Mod1Mask
%const KeyMask	Mod2Mask
%const KeyMask	Mod3Mask
%const KeyMask	Mod4Mask
%const KeyMask	Mod5Mask


################################################################
# Button Masks
################################################################

%synonym : ButtonMask : Modifier

%const ButtonMask	Button1Mask
%const ButtonMask	Button2Mask
%const ButtonMask	Button3Mask
%const ButtonMask	Button4Mask
%const ButtonMask	Button5Mask


################################################################
# Button
################################################################

%newtype : Button : Int : ()

%const Button	Button1
%const Button	Button2
%const Button	Button3
%const Button	Button4
%const Button	Button5


################################################################
# Notify Modes
################################################################

%newtype : NotifyMode : Int : (Eq)

# NotifyNormal and NotifyHint are used as detail in XMotionEvents
%const NotifyMode	NotifyNormal
%const NotifyMode	NotifyGrab
%const NotifyMode	NotifyUngrab
%const NotifyMode	NotifyWhileGrabbed
%const NotifyMode	NotifyHint

################################################################
# Notify Details
################################################################

%newtype : NotifyDetail : Int : ()

%const NotifyDetail	NotifyAncestor
%const NotifyDetail	NotifyVirtual
%const NotifyDetail	NotifyInferior
%const NotifyDetail	NotifyNonlinear
%const NotifyDetail	NotifyNonlinearVirtual
%const NotifyDetail	NotifyPointer
%const NotifyDetail	NotifyPointerRoot
%const NotifyDetail	NotifyDetailNone


################################################################
# Visibility Notify
################################################################

%newtype : Visibility : Int : ()

%const Visibility	VisibilityUnobscured
%const Visibility	VisibilityPartiallyObscured
%const Visibility	VisibilityFullyObscured


################################################################
# Window's place relative to siblings (used in Circulation requests/events)
################################################################

%newtype : Place : Int : ()

%const Place	PlaceOnTop
%const Place	PlaceOnBottom


################################################################
# Protocols
################################################################

%newtype : Protocol : Int : ()

%const Protocol	FamilyInternet
%const Protocol	FamilyDECnet
%const Protocol	FamilyChaos


################################################################
# Property Notification
################################################################

%newtype : PropertyNotification : Int : ()

%const PropertyNotification	PropertyNewValue
%const PropertyNotification	PropertyDelete


################################################################
# Colormap Notification
################################################################

%newtype : ColormapNotification : Int : ()

%const ColormapNotification	ColormapUninstalled
%const ColormapNotification	ColormapInstalled


################################################################
# Grab{Pointer,Button,Keyboard,Key} Modes
################################################################

%newtype : GrabMode : Int : ()

%const GrabMode	GrabModeSync
%const GrabMode	GrabModeAsync


################################################################
# Grab{Pointer,Keyboard} reply status
################################################################

%newtype : GrabStatus : Int : ()

%const GrabStatus	GrabSuccess
%const GrabStatus	AlreadyGrabbed
%const GrabStatus	GrabInvalidTime
%const GrabStatus	GrabNotViewable
%const GrabStatus	GrabFrozen

################################################################
# AllowEvents modes
################################################################

%newtype : AllowEvents : Int : ()

%const AllowEvents	AsyncPointer
%const AllowEvents	SyncPointer
%const AllowEvents	ReplayPointer
%const AllowEvents	AsyncKeyboard
%const AllowEvents	SyncKeyboard
%const AllowEvents	ReplayKeyboard
%const AllowEvents	AsyncBoth
%const AllowEvents	SyncBoth


################################################################
# {Set,Get}InputFocus Modes
################################################################

%newtype : FocusMode : Int : ()

%const FocusMode	RevertToNone
%const FocusMode	RevertToPointerRoot
%const FocusMode	RevertToParent


################################################################
# Error codes
################################################################

%newtype : Status : Int : () : notypedef

%const Status	Success
%const Status	BadRequest
%const Status	BadValue
%const Status	BadWindow
%const Status	BadPixmap
%const Status	BadAtom
%const Status	BadCursor
%const Status	BadFont
%const Status	BadMatch
%const Status	BadDrawable
%const Status	BadAccess
%const Status	BadAlloc
%const Status	BadColor
%const Status	BadGC
%const Status	BadIDChoice
%const Status	BadName
%const Status	BadLength
%const Status	BadImplementation
%const Status	FirstExtensionError
%const Status	LastExtensionError

################################################################
# Window definitions
################################################################

################################################################
# Window Class
################################################################

%newtype : WindowClass : Int : ()

%const WindowClass	CopyFromParent
%const WindowClass	InputOutput
%const WindowClass	InputOnly

################################################################
# Window attributes mask
################################################################

%synonym : AttributeMask : Mask 

%const AttributeMask	CWBackPixmap
%const AttributeMask	CWBackPixel
%const AttributeMask	CWBorderPixmap
%const AttributeMask	CWBorderPixel
%const AttributeMask	CWBitGravity
%const AttributeMask	CWWinGravity
%const AttributeMask	CWBackingStore
%const AttributeMask	CWBackingPlanes
%const AttributeMask	CWBackingPixel
%const AttributeMask	CWOverrideRedirect
%const AttributeMask	CWSaveUnder
%const AttributeMask	CWEventMask
%const AttributeMask	CWDontPropagate
%const AttributeMask	CWColormap
%const AttributeMask	CWCursor

################################################################
# Bit gravity and Window gravity
################################################################

# All gravities except UnmapGravity and ForgetGravity are valid for both
%newtype : Gravity : Int : (Eq)
%synonym : BitGravity    : Gravity
%synonym : WindowGravity : Gravity

# NB: only valid for WindowGravity
%const WindowGravity	UnmapGravity

# NB: only valid for BitGravity
%const BitGravity	ForgetGravity

%const Gravity	NorthWestGravity
%const Gravity	NorthGravity
%const Gravity	NorthEastGravity
%const Gravity	WestGravity
%const Gravity	CenterGravity
%const Gravity	EastGravity
%const Gravity	SouthWestGravity
%const Gravity	SouthGravity
%const Gravity	SouthEastGravity
%const Gravity	StaticGravity

################################################################
# Backing Store control
################################################################

# used in CreateWindow for backing-store hint
%newtype : BackingStore : Int : (Eq)

%const BackingStore	NotUseful
%const BackingStore	WhenMapped
%const BackingStore	Always

################################################################
# Coordinate Modes (argument to drawLines and drawPoints)
################################################################

%newtype : CoordinateMode : Int : (Eq)

%const CoordinateMode	CoordModeOrigin
%const CoordinateMode	CoordModePrevious

################################################################
# Polygon Shape (used as argument to fillPolygon)
################################################################

%newtype : PolygonShape : Int : (Eq)
	   
%const PolygonShape	Complex
%const PolygonShape	Nonconvex
%const PolygonShape	Convex

################################################################
# QueryBestSize Class
################################################################

%newtype : QueryBestSizeClass : Int : (Eq)
	   
%const QueryBestSizeClass	CursorShape
%const QueryBestSizeClass	TileShape
%const QueryBestSizeClass	StippleShape

################################################################
# Colormap Allocation control (used by XCreateColormap)
################################################################

%newtype : ColormapAlloc : Int : (Eq)
	   
%const ColormapAlloc	AllocNone
%const ColormapAlloc	AllocAll

################################################################
# Access Control
################################################################

%newtype : Access : Int : (Eq)
	   
%const Access	EnableAccess
%const Access	DisableAccess

################################################################
# CloseDownMode
################################################################

%newtype : CloseDownMode : Int : (Eq)
	   
%const CloseDownMode	DestroyAll
%const CloseDownMode	RetainPermanent
%const CloseDownMode	RetainTemporary

################################################################
# ChangeSaveSet mode
################################################################

%newtype : ChangeSaveSetMode : Int : (Eq)
	   
%const ChangeSaveSetMode	SetModeInsert
%const ChangeSaveSetMode	SetModeDelete

################################################################
# WindowStackingMethod (used in configureWindow)
################################################################

%newtype : WindowStackingMethod : Int : (Eq)

%const WindowStackingMethod	Above
%const WindowStackingMethod	Below
%const WindowStackingMethod	TopIf
%const WindowStackingMethod	BottomIf
%const WindowStackingMethod	Opposite

################################################################
# CirculationDirection
################################################################

%newtype : CirculationDirection : Int : (Eq)
	   
%const CirculationDirection	RaiseLowest
%const CirculationDirection	LowerHighest

################################################################
# Clip Rectangle Ordering (used in SetClipRectangles)
################################################################

%newtype : RectangleOrdering : Int : (Eq)
	   
%const RectangleOrdering	Unsorted
%const RectangleOrdering	YSorted
%const RectangleOrdering	YXSorted
%const RectangleOrdering	YXBanded

################################################################
# Imaging
################################################################

%newtype : ImageFormat : Int : (Eq)
	   
%const ImageFormat	XYBitmap
%const ImageFormat	XYPixmap
%const ImageFormat	ZPixmap

################################################################
# Keyboard/Pointer stuff
################################################################

# Auto repeat mode
%newtype : AutoRepeatMode : Int : (Eq)

%const AutoRepeatMode	AutoRepeatModeOff
%const AutoRepeatMode	AutoRepeatModeOn
%const AutoRepeatMode	AutoRepeatModeDefault

# Led mode
%newtype : LedMode : Int : (Eq)

%const LedMode	LedModeOff
%const LedMode	LedModeOn

################################################################
# Byte Order  (used in imageByteOrder and bitmapBitOrder)
################################################################

%newtype : ByteOrder : Int : (Eq)

%const ByteOrder	LSBFirst
%const ByteOrder	MSBFirst

################################################################
# Visual Class
################################################################

%newtype : VisualClass : Int : (Eq)

%const VisualClass	StaticGray
%const VisualClass	GrayScale
%const VisualClass	StaticColor
%const VisualClass	PseudoColor
%const VisualClass	TrueColor
%const VisualClass	DirectColor

################################################################
# Mapping Request (used in getMappingEvent)
################################################################

%newtype : MappingRequest : Int : (Eq)

%const MappingRequest	MappingModifier
%const MappingRequest	MappingKeyboard
%const MappingRequest	MappingPointer

################################################################
# PrimaryMask (used in storeNamedColor and storeColors)
################################################################

%newtype : PrimaryMask : Mask : (Eq)

%const PrimaryMask	DoRed
%const PrimaryMask	DoGreen
%const PrimaryMask	DoBlue

################################################################
# Unfinished constants
################################################################

{{%
{-

#define MappingSuccess     	0
#define MappingBusy        	1
#define MappingFailed		2


/* ConfigureWindow structure */

#define CWX			(1<<0)
#define CWY			(1<<1)
#define CWWidth			(1<<2)
#define CWHeight		(1<<3)
#define CWBorderWidth		(1<<4)
#define CWSibling		(1<<5)
#define CWStackMode		(1<<6)

/* Used in GetWindowAttributes reply */

#define IsUnmapped		0
#define IsUnviewable		1
#define IsViewable		2

/* Property modes */

#define PropModeReplace         0
#define PropModePrepend         1
#define PropModeAppend          2

/* GC components: masks used in CreateGC, CopyGC, ChangeGC, OR'ed into
   GC.stateChanges */

#define GCFunction              (1L<<0)
#define GCPlaneMask             (1L<<1)
#define GCForeground            (1L<<2)
#define GCBackground            (1L<<3)
#define GCLineWidth             (1L<<4)
#define GCLineStyle             (1L<<5)
#define GCCapStyle              (1L<<6)
#define GCJoinStyle		(1L<<7)
#define GCFillStyle		(1L<<8)
#define GCFillRule		(1L<<9) 
#define GCTile			(1L<<10)
#define GCStipple		(1L<<11)
#define GCTileStipXOrigin	(1L<<12)
#define GCTileStipYOrigin	(1L<<13)
#define GCFont 			(1L<<14)
#define GCSubwindowMode		(1L<<15)
#define GCGraphicsExposures     (1L<<16)
#define GCClipXOrigin		(1L<<17)
#define GCClipYOrigin		(1L<<18)
#define GCClipMask		(1L<<19)
#define GCDashOffset		(1L<<20)
#define GCDashList		(1L<<21)
#define GCArcMode		(1L<<22)

#define GCLastBit		22





/* masks for ChangeKeyboardControl */

#define KBKeyClickPercent	(1L<<0)
#define KBBellPercent		(1L<<1)
#define KBBellPitch		(1L<<2)
#define KBBellDuration		(1L<<3)
#define KBLed			(1L<<4)
#define KBLedMode		(1L<<5)
#define KBKey			(1L<<6)
#define KBAutoRepeatMode	(1L<<7)


/*****************************************************************
 * FONTS 
 *****************************************************************/

/* used in QueryFont -- draw direction */

#define FontLeftToRight		0
#define FontRightToLeft		1

#define FontChange		255

/*****************************************************************
 * HOSTS AND CONNECTIONS
 *****************************************************************/

/* for ChangeHosts */

#define HostInsert		0
#define HostDelete		1



#endif /* X_H */
-}
%}}