################################################################
# Xlib plugin
#
# First attempt at writing a plugin - needs cleaned up
#
# Copyright (c) The University of Nottingham and Yale University, 1994-1997.
# All rights reserved. See NOTICE for details and conditions of use etc...
# Hugs version 1.4, March 1997
#
# $RCSfile: Xlib.ss,v $
# $Revision: 1.5 $
# $Date: 1997/07/03 22:26:19 $
################################################################

{%
/* Standard X imports */
#include <X11/X.h>
#include <X11/Xlib.h>

/* Standard HUGS imports - these come second so's we can overcome
 * duplicate definitions.
 */
#include "HUGS.h"
%}

{{%
module Xlib where
%}}


%include StdTypes.ss
%include Pointers.ss

%maybe : MbString : String : $0 : (String) 0

%array : ListInt : Int : int
{{%
type ListInt = [Int]
%}}

# Array of array doesn't work.
#%array : ListString : String : String
#{{%
#type ListString = [String]
#%}}

################################################################
# Raw X types and constants
################################################################

%include X.ss

################################################################
# The X library
################################################################

# MODULE = Xlib
# MANGLER = $prim_name =~ s/^X(.*)/$1/; substr($prim_name,0,1) =~ tr/A-Z/a-z/;

################################################################
# Basic types
################################################################

%synonym : Pixel : Word32
%synonym : Position : Int32
%synonym : Dimension : Word
%synonym : ScreenNumber : Word32
%synonym : Byte : CHAR : notypedef
%synonym : Buffer : Int

# These are not newtypes because we have to declare them the right way
# in C and %newtype doesn't support that.
{{%
type Display    = Ptr in rtsDummy
type Screen      = Ptr in rtsDummy
type Visual      = Ptr in rtsDummy
type XFontStruct = Ptr in rtsDummy
%}}
%type : Display     : Display     *$0  : %pack(Ptr,$0);% : %unpack(Ptr,$0,$1);%
%type : Screen      : Screen      *$0  : %pack(Ptr,$0);% : %unpack(Ptr,$0,$1);%
%type : Visual      : Visual      *$0  : %pack(Ptr,$0);% : %unpack(Ptr,$0,$1);%
%type : XFontStruct : XFontStruct *$0  : %pack(Ptr,$0);% : %unpack(Ptr,$0,$1);%

# Not right: XHostAddress is a structure
# %synonym : XHostAddress : Ptr : notypedef
#  in rtsDummy
# 
# %array : ListXHostAddress : XHostAddress : XHostAddress
# {{%
# type ListXHostAddress = [XHostAddress]
# %}}

# GCs are distinct from GContexts
%newtype : GC : Ptr : () : notypedef

%struct : XPoint : XPoint $0
  Position : x
  Position : y

%array : ListXPoint : XPoint : XPoint
{{%
type ListXPoint = [XPoint]
%}}

%struct : XSegment : XSegment $0
  Position : x1
  Position : y1
  Position : x2
  Position : y2

%array : ListXSegment : XSegment : XSegment
{{%
type ListXSegment = [XSegment]
%}}

%struct : XRectangle : XRectangle $0
  Position  : x
  Position  : y
  Dimension : width
  Dimension : height

%array : ListXRectangle : XRectangle : XRectangle
{{%
type ListXRectangle = [XRectangle]
%}}

%struct : XArc : XArc $0
  Position  : x
  Position  : y
  Dimension : width
  Dimension : height
  Int       : angle1
  Int       : angle2

%array : ListXArc : XArc : XArc
{{%
type ListXArc = [XArc]
%}}

%array : ListWindow : Window : Window
{{%
type ListWindow = [Window]
%}}

%array : ListColormap : Colormap : Colormap
{{%
type ListColormap = [Colormap]
%}}

%array : ListPixel : Pixel : Pixel
{{%
type ListPixel = [Pixel]
%}}

%struct : XColor : XColor $0
  Pixel : pixel
  Word8 : red
  Word8 : green
  Word8 : blue
  Word8 : flags

%array : ListXColor : XColor : XColor
{{%
type ListXColor = [XColor]
%}}

%newtype : Shape : Int : ()

%constructor NullPtr :: IOError
%error : NullPtr : void* $0 : !($0) : %constructor(NullPtr);

%constructor BadStatus :: Status -> IOError
%error : BadStatus : Status $0 : (Success != ($0)) : %constructor(BadStatus,$0);

%constructor Zero :: IOError
%error : Zero : Status $0 : !($0) : %constructor(Zero);

%constructor False :: IOError
%error : False : Bool $0 : !($0) : %constructor(False);

################################################################
# Display
################################################################

# All default values are assumed to be side-effect free.

%fun XAllPlanes              :: Pixel
%fun XBlackPixel             :: Display -> ScreenNumber -> Pixel
%fun XWhitePixel             :: Display -> ScreenNumber -> Pixel

# This may vary from one execution to another but I believe it 
# is constant during any given execution and so it can be made PURE
# without breaking referential transparency.
%fun ConnectionNumber        :: Display -> Int

%fun XDefaultColormap        :: Display -> ScreenNumber -> Colormap

%fun XListDepths :: Display -> ScreenNumber -> ListInt using $r0 = XListDepths($0,$1,&$r0_size)

%fun XDefaultGC              :: Display -> ScreenNumber -> GC
%fun XDefaultDepth           :: Display -> ScreenNumber -> Int
%fun XDefaultScreen          :: Display -> ScreenNumber
%fun XDefaultScreenOfDisplay :: Display -> Screen
%fun DisplayHeight          :: Display -> ScreenNumber -> Int
%fun DisplayHeightMM        :: Display -> ScreenNumber -> Int
%fun DisplayWidth           :: Display -> ScreenNumber -> Int
%fun DisplayWidthMM         :: Display -> ScreenNumber -> Int
%fun XMaxRequestSize         :: Display -> Int
%fun XDisplayMotionBufferSize :: Display -> Int
#Disnae exist in X11R5 %fun XExtendedMaxRequestSize :: Display -> Int
%fun XResourceManagerString  :: Display -> String
%fun XScreenResourceString   :: Screen   -> String
%fun DisplayString          :: Display -> String
%fun XImageByteOrder         :: Display -> Int   
%fun XProtocolRevision       :: Display -> Int   
%fun XProtocolVersion        :: Display -> Int
%fun XServerVendor           :: Display -> String
#Disnae exist: %fun XServerRelease          :: Display -> Int    
%fun XScreenCount            :: Display -> Int    
%fun XDefaultVisual          :: Display -> ScreenNumber -> Visual
%fun DisplayCells           :: Display -> ScreenNumber -> Int
%fun DisplayPlanes          :: Display -> ScreenNumber -> Int
%fun XScreenOfDisplay        :: Display -> ScreenNumber -> Screen
%fun XDefaultRootWindow      :: Display -> Window

# The following are believed to be order dependent

%fun  		XRootWindow   :: Display -> ScreenNumber -> IO Window
%fun  		XQLength      :: Display -> IO Int

%fun  		XNoOp         :: Display -> IO ()

%errfun NullPtr XOpenDisplay  :: String -> IO Display
%fun            XCloseDisplay :: Display -> IO ()

# I'm not sure why I added this since I don't have any of the related
# functions.
%fun XrmInitialize :: IO ()

# %fun XGetDefault :: Display -> String -> String -> IO ()

%fun XAutoRepeatOff    :: Display -> IO ()
%fun XAutoRepeatOn     :: Display -> IO ()
%fun XBell             :: Display -> Int -> IO ()
%fun XSetCloseDownMode :: Display -> CloseDownMode -> IO ()
%fun XLastKnownRequestProcessed :: Display -> IO Int

%fun XGetInputFocus :: Display -> IO (Window, FocusMode) using XGetInputFocus($0,&$r0,&$r1)
%fun XSetInputFocus   :: Display -> Window -> FocusMode -> Time -> IO ()

# XAllocID omitted
# XKillClient omitted
# XFetchName omitted
# XGetKeyboardControl omitted
# XChangeKeyboardControl omitted
# XChangeKeyboardMapping omitted
# XChangePointerControl omitted

%fun XGrabButton     :: Display -> Button -> ButtonMask -> Window -> Bool -> EventMask -> GrabMode -> GrabMode -> Window -> Cursor -> IO ()
%fun XUngrabButton   :: Display -> Button -> ButtonMask -> Window -> IO ()

%fun XGrabPointer    :: Display -> Window -> Bool -> EventMask -> GrabMode -> GrabMode -> Window -> Cursor -> Time -> IO GrabStatus
%fun XUngrabPointer  :: Display -> Time -> IO ()

%fun XGrabKey        :: Display -> KeyCode -> ButtonMask -> Window -> Bool -> GrabMode -> GrabMode -> IO ()
%fun XUngrabKey      :: Display -> KeyCode -> ButtonMask -> Window -> IO ()

%fun XGrabKeyboard   :: Display -> Window -> Bool -> GrabMode -> GrabMode -> Time -> IO GrabStatus
%fun XUngrabKeyboard :: Display -> Time -> IO ()

%fun XGrabServer   :: Display -> IO ()
%fun XUngrabServer :: Display -> IO ()

# XChangeActivePointerGrab omitted

# XFree omitted
# XFreeStringList omitted

%errfun BadStatus XQueryBestTile    :: Display -> Drawable ->                       Dimension -> Dimension -> IO (Dimension, Dimension) using $err = XQueryBestTile($0,$1,$2,$3,&$r0,&$r1)    
%errfun BadStatus XQueryBestStipple :: Display -> Drawable ->                       Dimension -> Dimension -> IO (Dimension, Dimension) using $err = XQueryBestStipple($0,$1,$2,$3,&$r0,&$r1) 
%errfun BadStatus XQueryBestCursor  :: Display -> Drawable ->                       Dimension -> Dimension -> IO (Dimension, Dimension) using $err = XQueryBestCursor($0,$1,$2,$3,&$r0,&$r1)  
%errfun BadStatus XQueryBestSize    :: Display -> Drawable -> QueryBestSizeClass -> Dimension -> Dimension -> IO (Dimension, Dimension) using $err = XQueryBestSize($0,$1,$2,$3,$4,&$r0,&$r1) 

# Note: Returns false if pointer not in window w (and win_x = win_y = 0)
# ToDo: more effective use of Maybes?
%fun XQueryPointer :: Display -> Window -> IO (Bool, Window, Window, Int, Int, Int, Int, Modifier) using $r0 = XQueryPointer($0,$1,&$r1,&$r2,&$r3,&$r4,&$r5,&$r6,&$r7) 

# XSetSelectionOwner omitted

# XOpenOM omitted
# XCloseOM omitted
# XSetOMValues omitted
# XGetOMValues omitted
# DisplayOfOM omitted
# XLocaleOfOM omitted

# XCreateOC omitted
# XDestroyOC omitted
# XOMOfOC omitted
# XSetOCValues omitted
# XGetOCValues omitted

# XVaCreateNestedList omitted

################################################################
# Error reporting
################################################################

%fun XDisplayName :: String -> String 

# XGetErrorDatabaseText omitted
# XGetErrorText omitted
# XSetIOrrorHandler omitted
# XSetErrorHandler omitted

################################################################
# Buffers
################################################################

# OLD: Would arrays be more appropriate?
#
# IMPURE void	XStoreBytes(display, bytes, nbytes)
# IN Display*		display
# VAR Int			nbytes
# IN list[nbytes] Byte	bytes
# 
# IMPURE list[nbytes] Byte	XFetchBytes(display, &nbytes)
# IN Display*	display
# VAR Int		nbytes
# 
# IMPURE void	XStoreBuffer(display, bytes, nbytes, buffer)
# IN Display*		display
# VAR Int			nbytes
# IN list[nbytes] Byte	bytes
# IN Buffer		buffer
# 
# IMPURE list[nbytes] Byte	XFetchBuffer(display, &nbytes, buffer)
# IN Display*	display
# VAR Int		nbytes
# IN Buffer	buffer
# 
# IMPURE void	XRotateBuffers(display, rotate)
# IN Display*	display
# VAR Int		rotate

################################################################
# Extensions
################################################################

# ToDo: Use XFreeExtensionList
#%fun XListExtensions :: Display -> IO ListString using $r0 = XListExtensions($0,&$r0_size)

# %errfun False XQueryExtension :: Display -> String -> IO (Int,Int,Int) using $r3 = XQueryExtension($0,$1,&$r0,&$r1,&$r2)->($r0,$r1,$r2)
# %fun XInitExtensions :: Display -> String -> IO XExtCodes
# %fun XAddExtensions  :: Display ->           IO XExtCodes

# XAddToExtensionList omitted
# XFindOnExtensionList omitted
# XEHeadOfExtensionList omitted

################################################################
# Hosts
################################################################

# ToDo: operations to construct and destruct an XHostAddress

# %fun XAddHost :: Display -> XHostAddress -> IO ()
# %fun XRemoveHost :: Display -> XHostAddress -> IO ()
# 
# %fun XAddHosts    :: Display -> ListXHostAddress -> IO () using XAddHosts($0,$1,$1_size) 
# %fun XRemoveHosts :: Display -> ListXHostAddress -> IO () using XRemoveHosts($0,$1,$1_size) 
# 
# # Uses %prim to let us call XFree
# %prim XListHosts :: Display -> IO (ListXHostAddress, Bool)
# Bool state;
# Int r_size;
# XHostAddress* r = XListHosts($0,&r_size,&state);
# %update(r,state);
# XFree(r);
# return;

%fun XEnableAccessControl  :: Display -> IO ()
%fun XDisableAccessControl :: Display -> IO ()
%fun XSetAccessControl     :: Display -> Access -> IO ()


################################################################
# Events
################################################################

%newtype : QueuedMode : Int : (Eq)

%const QueuedMode QueuedAlready
%const QueuedMode QueuedAfterFlush
%const QueuedMode QueuedAfterReading

# Because of the way the corresponding C types are defined,
# These "structs" are somewhat unusual - they omit fields which can
# be found in more general structs.
# For example, XAnyEvent omits type since it is in XEvent.
# Therefore, to get the complete contents of an event one typically
# writes:
#   do
#     ty <- get_XEvent e
#     (serial,send_event,display,window) <- get_XAnyEvent
#     window' <- get_XDestroyWindowEvent

%struct : XEvent : XEvent $0
  EventType : type

{%
typedef XEvent* XEventPtr;
%}
%ptr : XEventPtr : XEvent

%struct : XAnyEvent : XAnyEvent $0
  Int32     : serial            # # of last request processed by server
  Bool      : send_event        # true if this came from a SendEvent request
  Display  : display           # Display the event was read from
  Window    : window            # window on which event was requested in event mask

%struct : XKeyEvent : XKeyEvent $0
  Window    : root 	        # root window that the event occured on 
  Window    : subwindow 	# child window 
  Time      : time 		# milliseconds 
  Int       : x 		# pointer x, y coordinates in event window 
  Int       : y
  Int       : x_root	 	# coordinates relative to root 
  Int       : y_root
  Modifier  : state 	        # key or button mask 
  KeyCode   : keycode 	        # detail 
  Bool      : same_screen 	# same screen flag 

{%
typedef XKeyEvent* XKeyEventPtr;
%}
%ptr : XKeyEventPtr : XKeyEvent

%struct : XButtonEvent : XButtonEvent $0
  Window    : root 	        # root window that the event occured on 
  Window    : subwindow 	# child window 
  Time      : time 		# milliseconds 
  Int       : x 		# pointer x, y coordinates in event window 
  Int       : y
  Int       : x_root	 	# coordinates relative to root 
  Int       : y_root
  Modifier  : state 	        # key or button mask 
  Button    : button 	        # detail 
  Bool      : same_screen 	# same screen flag 

%struct : XMotionEvent : XMotionEvent $0
  Window    : root 	        # root window that the event occured on 
  Window    : subwindow 	# child window 
  Time      : time 		# milliseconds 
  Int       : x 		# pointer x, y coordinates in event window 
  Int       : y
  Int       : x_root	 	# coordinates relative to root 
  Int       : y_root
  Modifier  : state 	        # key or button mask 
  NotifyMode: is_hint 	        # detail 
  Bool      : same_screen 	# same screen flag 

%struct : XCrossingEvent : XCrossingEvent $0
  Window       : root 	        # root window that the event occured on 
  Window       : subwindow 	# child window 
  Time         : time 		# milliseconds 
  Int          : x 		# pointer x, y coordinates in event window 
  Int          : y
  Int          : x_root	 	# coordinates relative to root 
  Int          : y_root
  NotifyMode   : mode              
  NotifyDetail : detail
  Bool         : same_screen	# same screen flag
  Bool         : focus		# boolean focus
  Modifier     : state	        # key or button mask 

%struct : XFocusChangeEvent : XFocusChangeEvent $0
  NotifyMode   : mode
  NotifyDetail : detail

# omitted: should be translated into bitmaps
# PURE void	getKeymapEvent(event)
# IN XEvent*	event
# OUT Window	window	 	= ((XKeymapEvent*)event)->window
# OUT array[32] Char key_vector 	= ((XKeymapEvent*)event)->key_vector
# RESULT: 

%struct : XExposeEvent : XExposeEvent $0
  Position	: x	 	
  Position	: y	 	
  Dimension	: width	 	
  Dimension	: height	
  Int		: count	 	

%struct : XGraphicsExposeEvent : XGraphicsExposeEvent $0
  Position	: x	 	
  Position	: y	 	
  Dimension	: width	 	
  Dimension	: height	
  Int		: count	 	
  Int		: major_code 	
  Int		: minor_code 	

%struct : XCirculateEvent : XCirculateEvent $0
  Window	: window	 	
  Place		: place		

%struct : XConfigureEvent : XConfigureEvent $0
  Window	: window	
  Position	: x	 	
  Position	: y	 	
  Dimension	: width	 	
  Dimension	: height	
  Dimension	: border_width 	
  Window	: above	 	
  Bool	        : override_redirect

%struct : XCreateWindowEvent : XCreateWindowEvent $0
  Window	: window	 	
  Position	: x	 	
  Position	: y	 	
  Dimension	: width	 	
  Dimension	: height	 	
  Dimension	: border_width 	
  Bool	        : override_redirect

%struct : XDestroyWindowEvent : XDestroyWindowEvent $0
  Window	: window

%struct : XGravityEvent : XGravityEvent $0
  Window	: window	
  Position	: x	 	
  Position	: y	 	

%struct : XMapEvent : XMapEvent $0
  Bool	        : override_redirect

%struct : XMappingEvent : XMappingEvent $0
  MappingRequest : request	
  KeyCode	 : first_keycode
  Int		 : count	

%struct : XReparentEvent : XReparentEvent $0
  Window	: window	
  Window	: parent	
  Position	: x	 	
  Position	: y	 	
  Bool	        : override_redirect

%struct : XUnmapEvent : XUnmapEvent $0
  Window	: window	 	
  Bool	        : from_configure	

%struct : XVisibilityEvent : XVisibilityEvent $0
  Visibility	: state

%struct : XCirculateRequestEvent : XCirculateRequestEvent $0
  Place	        : place

# omitted because valuemask looks tricky
# %struct : XConfigureRequestEvent : XConfigureRequestEvent $0
#   Window	 : window	
#   Position	 : x		
#   Position	 : y		
#   Dimension	 : width	
#   Dimension	 : height	
#   Dimension	 : border_width	
#   Window	 : above	
#   StackingMethod : detail	
#   ???	         : valuemask	

%struct : XMapRequestEvent : XMapRequestEvent $0
  Window	: window

%struct : XResizeRequestEvent : XResizeRequestEvent $0
  Dimension	: width	 
  Dimension	: height	

%struct : XColormapEvent : XColormapEvent $0
  Colormap		: colormap
  Bool		        : new	  
  ColormapNotification	: state   

# getClientMessageEvent omitted
# getPropertyEvent omitted
# getSelectionClearEvent omitted
# getSelectionRequestEvent omitted
# getSelectionEvent omitted

# functions

%fun XFlush        :: Display ->               IO ()
%fun XSync         :: Display -> Bool ->       IO ()
%fun XPending      :: Display ->               IO Int
%fun XEventsQueued :: Display -> QueuedMode -> IO Int
%fun XNextEvent    :: Display -> XEventPtr  -> IO ()
%fun XAllowEvents  :: Display -> AllowEvents -> Time -> IO ()

# ToDo: XFree($r0) after constructing result
# %fun XGetMotionEvents :: Display -> Window -> Time -> Time -> IO ListXTimeCoord using $r0 = XGetMotionEvents($0,$1,$2,$3,&$r0_size)

%fun XSelectInput :: Display -> Window -> EventMask -> IO ()
%errfun BadStatus XSendEvent :: Display -> Window -> Bool -> EventMask -> XEventPtr -> IO ()

%fun XWindowEvent :: Display -> Window -> EventMask -> XEventPtr -> IO ()
%fun XCheckWindowEvent :: Display -> Window -> EventMask -> XEventPtr -> IO Bool

%fun XMaskEvent :: Display -> EventMask -> XEventPtr -> IO ()
%fun XCheckMaskEvent :: Display -> EventMask -> XEventPtr -> IO Bool
%fun XCheckTypedEvent :: Display -> EventType -> XEventPtr -> IO Bool
%fun XCheckTypedWindowEvent :: Display -> Window -> EventType -> XEventPtr -> IO Bool
%fun XPutBackEvent :: Display -> XEventPtr -> IO ()
%fun XPeekEvent :: Display -> XEventPtr -> IO ()

# XFilterEvent omitted (can't find documentation)
# XIfEvent omitted (can't pass predicates (yet))
# XCheckIfEvent omitted (can't pass predicates (yet))
# XPeekIfEvent omitted (can't pass predicates (yet))

%fun XRefreshKeyboardMapping :: XMappingEvent -> IO () using XRefreshKeyboardMapping(&$0)

# XSynchronize omitted (returns C function)
# XSetAfterFunction omitted (can't pass functions (yet))

################################################################
# Geometry
################################################################

%fun XGeometry :: Display -> Int -> String -> String -> Dimension -> Dimension -> Dimension -> Int -> Int -> IO (Int, Position, Position, Dimension, Dimension) using $r0 = XGeometry($0,$1,$2,$3,$4,$5,$6,$7,$8,&$r1,&$r2,&$r3,&$r4)

%errfun BadStatus XGetGeometry :: Display -> Int -> Drawable -> IO (Window, Position, Position, Dimension, Dimension, Dimension, Int) using $err = XGetGeometry($0,$1,&$r0,&$r1,&$r2,&$r3,&$r4,&$r5,&$r6)

# XParseGeometry omitted (returned bitset too weird)

################################################################
# Locale
################################################################

%fun XSupportsLocale :: IO Bool
%fun XSetLocaleModifiers :: String -> IO String

################################################################
# Screen Saver
################################################################

%newtype : AllowExposuresMode : Int : (Eq)
	   
%const AllowExposuresMode	DontAllowExposures
%const AllowExposuresMode	AllowExposures
%const AllowExposuresMode	DefaultExposures

%newtype : PreferBlankingMode : Int : (Eq)
	   
%const PreferBlankingMode	DontPreferBlanking
%const PreferBlankingMode	PreferBlanking
%const PreferBlankingMode	DefaultBlanking

%newtype : ScreenSaverMode : Int : (Eq)

%const ScreenSaverMode	ScreenSaverActive
%const ScreenSaverMode	ScreenSaverReset

%fun XGetScreenSaver :: Display -> IO (Int, Int, PreferBlankingMode, AllowExposuresMode) using XGetScreenSaver($0,&$r0,&$r1,&$r2,&$r3)

%fun XSetScreenSaver      :: Display -> Int -> Int -> PreferBlankingMode -> AllowExposuresMode -> IO ()
%fun XActivateScreenSaver :: Display -> IO ()
%fun XResetScreenSaver    :: Display -> IO ()
%fun XForceScreenSaver    :: Display -> ScreenSaverMode -> IO ()


################################################################
# Pointer
################################################################

%fun XGetPointerControl :: Display -> IO (Int, Int, Int) using XGetPointerControl($0,&$r0,&$r1,&$r2)

%fun XWarpPointer :: Display -> Window -> Window -> Position -> Position -> Dimension -> Dimension -> Position -> Position -> IO ()

# XGetPointerMapping omitted
# XSetPointerMapping omitted

################################################################
# Visuals
################################################################

# XVisualIDFromVisual omitted


################################################################
# Threads
################################################################

# XInitThreads omitted (leary of thread stuff)
# XLockDisplay omitted (leary of thread stuff)
# XUnlockDisplay omitted (leary of thread stuff)

################################################################
# Screen
################################################################

# Many flags assumed to be PURE.

%fun XBlackPixelOfScreen      :: Screen -> Pixel
%fun XWhitePixelOfScreen      :: Screen -> Pixel
%fun XCellsOfScreen           :: Screen -> Int
%fun XDefaultColormapOfScreen :: Screen -> Colormap
%fun XDefaultDepthOfScreen    :: Screen -> Int
%fun XDefaultGCOfScreen       :: Screen -> GC
%fun XDefaultVisualOfScreen   :: Screen -> Visual
%fun XDoesBackingStore        :: Screen -> Bool
%fun XDoesSaveUnders          :: Screen -> Bool
%fun DisplayOfScreen         :: Screen -> Display

# event mask at connection setup time - not current event mask!
%fun XEventMaskOfScreen       :: Screen -> EventMask

%fun XMinCmapsOfScreen        :: Screen -> Int
%fun XMaxCmapsOfScreen        :: Screen -> Int
%fun XRootWindowOfScreen      :: Screen -> Window
%fun XWidthOfScreen           :: Screen -> Dimension
%fun XWidthMMOfScreen         :: Screen -> Dimension
%fun XHeightOfScreen          :: Screen -> Dimension
%fun XHeightMMOfScreen        :: Screen -> Dimension
%fun XPlanesOfScreen          :: Screen -> Int
%fun XScreenNumberOfScreen    :: Screen -> ScreenNumber


################################################################
# Graphics contexts
################################################################

################ ArcMode ################

%newtype : ArcMode : Int : (Eq)

%const ArcMode  ArcChord
%const ArcMode	ArcPieSlice

################ SubWindowMode ################

%newtype : SubWindowMode : Int : (Eq)

%const SubWindowMode	ClipByChildren
%const SubWindowMode	IncludeInferiors

################ LineStyle ################

%newtype : LineStyle : Int : (Eq)

%const LineStyle	LineSolid
%const LineStyle	LineDoubleDash
%const LineStyle	LineOnOffDash

################ CapStyle ################

%newtype : CapStyle : Int : (Eq)

%const CapStyle	CapNotLast
%const CapStyle	CapButt
%const CapStyle	CapRound
%const CapStyle	CapProjecting

################ JoinStyle ################

%newtype : JoinStyle : Int : (Eq)

%const JoinStyle	JoinMiter
%const JoinStyle	JoinRound
%const JoinStyle	JoinBevel

################ FillStyle ################

%newtype : FillStyle : Int : (Eq)

%const FillStyle FillSolid
%const FillStyle FillTiled
%const FillStyle FillOpaqueStippled
%const FillStyle FillStippled

################ FillRule ################

%newtype : FillRule : Int : (Eq)

%const FillRule EvenOddRule
%const FillRule WindingRule

################ GXFunction ################

%newtype : GXFunction : Int : (Eq)

%const GXFunction	GXclear
%const GXFunction	GXand
%const GXFunction	GXandReverse
%const GXFunction	GXcopy
%const GXFunction	GXandInverted
%const GXFunction	GXnoop
%const GXFunction	GXxor
%const GXFunction	GXor
%const GXFunction	GXnor
%const GXFunction	GXequiv
%const GXFunction	GXinvert
%const GXFunction	GXorReverse
%const GXFunction	GXcopyInverted
%const GXFunction	GXorInverted
%const GXFunction	GXnand
%const GXFunction	GXset

# Convenience functions

%fun XSetArcMode      	   :: Display -> GC -> ArcMode        	      -> IO ()
%fun XSetBackground   	   :: Display -> GC -> Pixel          	      -> IO ()
%fun XSetForeground   	   :: Display -> GC -> Pixel          	      -> IO ()
%fun XSetFunction     	   :: Display -> GC -> GXFunction     	      -> IO ()
%fun XSetGraphicsExposures :: Display -> GC -> Bool                  -> IO ()
%fun XSetClipMask          :: Display -> GC -> Pixmap                -> IO ()
%fun XSetClipOrigin        :: Display -> GC -> Position -> Position  -> IO ()

# XSetClipRectangles omitted because it's not clear when it's safe to delete the
# array of rectangles

%fun XSetDashes            :: Display -> GC -> Int -> String -> Int  -> IO ()
%fun XSetFillRule          :: Display -> GC -> FillRule              -> IO ()
%fun XSetFillStyle         :: Display -> GC -> FillStyle             -> IO ()
%fun XSetFont              :: Display -> GC -> Font                  -> IO ()
%fun XSetLineAttributes    :: Display -> GC -> Int -> LineStyle -> CapStyle -> JoinStyle -> IO ()
%fun XSetPlaneMask         :: Display -> GC -> Pixel                 -> IO ()
%fun XSetState             :: Display -> GC -> Pixel -> Pixel -> GXFunction -> Pixel -> IO ()
%fun XSetStipple           :: Display -> GC -> Pixmap                -> IO ()
%fun XSetSubwindowMode     :: Display -> GC -> SubWindowMode         -> IO ()
%fun XSetTSOrigin          :: Display -> GC -> Position -> Position  -> IO ()
%fun XSetTile              :: Display -> GC -> Pixmap                -> IO ()

# ToDo: create a real interface to this
%prim XCreateGC :: Display -> Drawable -> IO GC
GC gc = XCreateGC($0,$1,0,0);
%return(gc);

# OLD: 
# %synonym : GCValueSet : Ptr
#   in rtsDummy
# 
# {%
# typedef unsigned long GCMask; /* cf XtGCMask */
# typedef struct _gcvalues {
#     GCMask	mask;
#     XGCValues	values;
# }* GCValueSet;
# %}
#
# IMPURE GCValueSet	emptyGCValueSet()
# RESULT: (RETVAL = (GCValueSet) malloc(sizeof(struct _gcvalues))) ? RETVAL->mask = 0, RETVAL : RETVAL;
# POST: RETVAL != NULL
# 
# IMPURE void	setGCForeground(colour, set)
# IN Pixel	colour
# IN GCValueSet	set
# RESULT: set->mask |= GCForeground; set->values.foreground = colour
# 
# IMPURE void	setGCBackground(colour, set)
# IN Pixel	colour
# IN GCValueSet	set
# RESULT: set->mask |= GCBackground; set->values.background = colour
# 
# IMPURE void	freeGCValueSet(set)
# IN GCValueSet	set
# RESULT: free(set)
# 
# IMPURE GC	XCreateGC(display, d, set->mask, &(set->values))
# NAME: xCreateGC
# IN Display*	display
# IN Drawable	d
# IN GCValueSet	set
# 
# IMPURE void	XChangeGC(display, gc, set->mask, &(set->values))
# NAME: xChangeGC
# IN Display*	display
# IN GC		gc
# IN GCValueSet	set
# 
# STARTH
# -- Code that packages GCValueSets up in a clean monoidic way.
# 
# data GCSetter = GCSetter (GCValueSet -> IO ()) -- should be newtype 
# 
# createGC :: Display -> Drawable -> GCSetter -> IO GC
# createGC display d (GCSetter setter) =
#   emptyGCValueSet        >>= \ set ->
#   setter set             >>
#   xCreateGC display d set >>= \ gc ->
#   freeGCValueSet set     >>
#   return gc
# 
# changeGC :: Display -> Drawable -> GC -> GCSetter -> IO ()
# changeGC display d gc (GCSetter setter) =
#   emptyGCValueSet        >>= \ set ->
#   setter set             >>
#   xChangeGC display d set >>= \ gc ->
#   freeGCValueSet set
# 
# instance Monoid GCSetter where
#   (GCSetter m) >>> (GCSetter k) 
#     = GCSetter (\ settings -> m settings >> k settings)
#   unit = GCSetter (\ _ -> return ())
# 
# set_Background :: Pixel -> GCSetter
# set_Background c = GCSetter (setGCBackground c)
# 
# set_Foreground :: Pixel -> GCSetter
# set_Foreground c = GCSetter (setGCForeground c)
# ENDH

%fun XFreeGC  :: Display -> GC -> IO ()
%fun XFlushGC :: Display -> GC -> IO ()

# XCopyGC omitted
# XGetGCValues omitted
# XGContextFromGC omitted

################################################################
# Pixmaps
################################################################

%fun XCreatePixmap :: Display -> Drawable -> Dimension -> Dimension -> Int -> IO Pixmap
%fun XFreePixmap :: Display -> Pixmap -> IO ()

# XCreatePixmapFromBitmapData omitted (type looks strange)

# %fun XListPixmapFormatValues = $r0 = XListPixmapFormatValues(display, &$r0_size) :: Display -> ListXPixmapFormatValues


################################################################
# Bitmaps
################################################################

# ToDo: do these need to be available to the programmer?
# Maybe I could just wire them into all other operations?

%fun XBitmapBitOrder :: Display -> ByteOrder
%fun XBitmapUnit     :: Display -> Int
%fun XBitmapPad      :: Display -> Int

# ToDo: make sure that initialisation works correctly for x/y_hot
# omitted
# IMPURE void	XWriteBitmapFile(display, filename, bitmap, width, height, x_hot, y_hot) RAISES Either
# RETURNTYPE	BitmapFileStatus
# GLOBAL ERROR BitmapFileStatus	RETVAL
# IN Display*	display
# IN String	filename
# IN Pixmap	bitmap
# IN Dimension	width
# IN Dimension	height
# IN Maybe Int	x_hot = -1
# IN Maybe Int	y_hot = -1
# POST: RETVAL == BitmapSuccess

# omitted
# IMPURE void	XReadBitmapFile(display, d, filename, bitmap, width, height, x_hot, y_hot) RAISES Either
# RETURNTYPE	BitmapFileStatus
# GLOBAL ERROR BitmapFileStatus	RETVAL
# IN Display*	display
# IN Drawable	d
# IN String	filename
# OUT Pixmap	bitmap
# OUT Dimension	width
# OUT Dimension	height
# OUT Int		x_hot RAISES Maybe IF x_hot == -1
# OUT Int		y_hot RAISES Maybe IF x_hot == -1
# POST: RETVAL == BitmapSuccess

# XCreateBitmapFromData omitted (awkward looking type)
# XReadBitmapFileData omitted (awkward looking type)

################################################################
# Color and Colormaps
################################################################

%errfun Zero XLookupColor :: Display -> Colormap -> String -> IO (XColor, XColor)     using $err = XLookupColor($0,$1,$2,&$r0,&$r1)
%errfun Zero XAllocNamedColor :: Display -> Colormap -> String -> IO (XColor, XColor) using $err = XAllocNamedColor($0,$1,$2,&$r0,&$r1)

%errfun Zero XAllocColor :: Display -> Colormap -> XColor -> IO XColor                using $err = XAllocColor($0,$1,&$2) -> ($2)
%errfun Zero XParseColor :: Display -> Colormap -> String -> IO XColor                using $err = XParseColor($0,$1,$2,&$r0)

# ToDo: Can't express relationship between $3 and $r0 properly (or $4, $r1)
# %errfun Zero XAllocColorCells :: Display -> Colormap -> Bool -> Int -> Int -> IO (ListPixel, ListPixel) using $err = XAllocColorCells($0,$1,$2,$3_size,$r0,$4_size,$r1) 

# ToDo: Can't express relationship between $3 and $r0 properly
# %errfun Zero XAllocColorPlanes :: Display -> Colormap -> Bool -> Int -> Int -> Int -> Int IO (ListPixel, Pixel, Pixel, Pixel) using $err = XAllocColorPlanes(...)

%fun XFreeColors :: Display -> Colormap -> ListPixel -> Pixel -> IO () using XFreeColors($0,$1,$2,$2_size,$3)

%fun XStoreColor  :: Display -> Colormap -> XColor -> IO ()             using XStoreColor($0,$1,&$2) 
%fun XStoreColors :: Display -> Colormap -> ListXColor -> IO ()         using XStoreColors($0,$1,$2,$2_size) 
%fun XStoreNamedColor :: Display -> Colormap -> String -> Pixel -> PrimaryMask -> IO ()
%fun XQueryColor  :: Display -> Colormap -> XColor -> IO XColor         using XQueryColor($0,$1,&$2)->($2) 
%fun XQueryColors :: Display -> Colormap -> ListXColor -> IO ListXColor using XQueryColors($0,$1,$2,$2_size) -> ($2)

%fun XInstallColormap     :: Display -> Colormap -> IO ()
%fun XUninstallColormap   :: Display -> Colormap -> IO ()
%fun XCopyColormapAndFree :: Display -> Colormap -> IO Colormap
%fun XCreateColormap      :: Display -> Window   -> Visual -> ColormapAlloc -> IO Colormap
%fun XFreeColormap        :: Display -> Colormap -> IO ()


################################################################
# Fonts
################################################################

# A glyph (or Char2b) is a 16 bit character identification.
# The top 8 bits are zero in many fonts.
%newtype : Glyph : Int : ()

# Disnae exist: %fun LoadFont       :: Display -> String -> IO Font
# Disnae exist: %fun UnloadFont     :: Display -> Font -> IO ()
%fun XQueryFont     :: Display -> Font -> IO XFontStruct
%fun XLoadQueryFont :: Display -> String -> IO XFontStruct
%fun XFreeFont      :: Display -> XFontStruct -> IO ()
#%fun XSetFontPath  :: Display -> ListString  -> IO () using XSetFontPath($0,$1,$1_size)

#%prim XGetFontPath :: Display -> IO ListString
#Int r_size;
#String* r = XGetFontPath($0,&r_size);
#%update(r);
#XFreeFontPath(r);
#return;

#%prim XListFonts :: Display -> String -> Int -> IO ListString
#Int r_size;
#String *r = XListFonts($0,$1,$2,&r_size);
#%update(r);
#XFreeFontNames(r);
#return;

# XListFontsWithInfo omitted (no support for XFontStruct yet)

# XQueryTextExtents omitted (no support for CharStruct yet)
# XQueryTextExtents16 omitted (no support for CharStruct yet)

# XTextExtents omitted
# XTextExtents16 omitted
# XTextWidth omitted
# XTextWidth16 omitted

# XGetFontProperty omitted
# XFreeFontInfo omitted
# XFreeFontNames omitted

# XCreateFontSet omitted (no documentation available)
# XFreeFontSet omitted (no documentation available)
# XFontsOfFontSet omitted (no documentation available)
# XBaseFontNameListOfFontSet omitted (no documentation available)
# XLocaleOfFontSet omitted (no documentation available)
# XExtentsOfFontSet omitted (no documentation available)

# XContextDependentDrawing omitted
# XDirectionalDependentDrawing omitted
# XContextualDrawing omitted

# XmbTextEscapement omitted
# XwcTextEscapement omitted
# XmbTextExtents omitted
# XwcTextExtents omitted
# XmbTextPerCharExtents omitted
# XwcTextPerCharExtents omitted
# XmbDrawText omitted
# XwcDrawText omitted
# XmbDrawString omitted
# XwcDrawString omitted
# XmbDrawImageString omitted
# XwcDrawImageString omitted

# XOpenIM omitted
# XCloseIM omitted
# XGetIMValues omitted
# XSetIMValues omitted
# DisplayOfIM omitted
# XLocaleOfIM omitted

# XCreateIC omitted
# XDestroyIC omitted
# XSetICFocus omitted
# XUnsetICFocus omitted
# XwcResetIC omitted
# XmbResetIC omitted
# XSetICValues omitted
# XGetICValues omitted
# XIMOfIC omitted

# XRegisterIMInstantiateCallback omitted
# XUnregisterIMInstantiateCallback omitted

# XInternalConnectionNumbers omitted
# XProcessInternalConnection omitted
# XAddConnectionWatch omitted
# XRemoveConnectionWatch omitted

# XmbLookupString omitted
# XwcLookupString omitted

################################################################
# Atoms
################################################################

# XInternAtom omitted
# XInternAtoms omitted
# XGetAtomName omitted
# XGetAtomNames omitted
# XConvertSelection omitted
# XListProperties omitted
# XChangeProperty omitted
# XDeleteProperty omitted

################################################################
# Keycodes
################################################################

%fun XDisplayKeycodes :: Display -> (Int,Int) using XDisplayKeycodes($0,&$r0,&$r1) 
%fun XLookupKeysym    :: XKeyEventPtr -> Int -> IO KeySym
%fun XKeycodeToKeysym :: Display -> KeyCode -> Int -> IO KeySym
%fun XKeysymToKeycode :: Display -> KeySym  -> IO KeyCode
%fun XKeysymToString  :: KeySym -> String
%fun XStringToKeysym  :: String -> KeySym


# XQueryKeymap omitted
# XRebindKeysym omitted
# XDeleteModifiermapEntry omitted
# XInsertModifiermapEntry omitted
# XNewModifiermap omitted
# XFreeModifiermap omitted
# XSetModifierMapping omitted
# XGetModifierMapping omitted
# XGetKeyboardMapping omitted

################################################################
# Image
################################################################

# XCreateImage omitted
# XInitImage omitted
# XGetImage omitted
# XPutImage omitted
# XGetSubImage omitted

################################################################
# Icons
################################################################

%errfun BadStatus XGetIconName :: Display -> Window -> IO String using $err = XGetIconName($0,$1,&$r0) 
%fun XSetIconName :: Display -> Window -> String -> IO ()

################################################################
# Cursors
################################################################

%fun XDefineCursor       :: Display -> Window -> Cursor -> IO ()
%fun XUndefineCursor     :: Display -> Window -> IO ()
%fun XCreatePixmapCursor :: Display -> Pixmap -> Pixmap -> XColor -> XColor -> Dimension -> Dimension -> IO Cursor using $r0 = XCreatePixmapCursor($0,$1,$2,&$3,&$4,$5,$6) 
%fun XCreateGlyphCursor  :: Display -> Font   -> Font -> Glyph -> Glyph -> XColor -> XColor -> IO Cursor           using $r0 = XCreateGlyphCursor($0,$1,$2,$3,$4,&$5,&$6) 
%fun XCreateFontCursor   :: Display -> Shape  -> IO Cursor
%fun XFreeCursor         :: Display -> Font   -> IO ()
%fun XRecolorCursor      :: Display -> Cursor -> XColor -> XColor -> IO () using XRecolorCursor($0,$1,&$2,&$3) 

################################################################
# Window Manager stuff
################################################################

# XConfigureWMWindow omitted (can't find documentation)
# XReconfigureWMWindow omitted (can't find documentation)
# XWMGeometry omitted (can't find documentation)
# XGetWMColormapWindows omitted (can't find documentation)
# XSetWMColormapWindows omitted (can't find documentation)
# XGetWMProtocols omitted
# XSetWMProtocols omitted

################################################################
# Set Window Attributes
################################################################

# The following code is based on what you get from the %ptr declaration.
# ToDo: generate this kind of stuff automatically.

{{%
type XSetWindowAttributesPtr = Ptr in
  toXSetWindowAttributesPtr   :: Ptr -> XSetWindowAttributesPtr,
  fromXSetWindowAttributesPtr :: XSetWindowAttributesPtr -> Ptr

toXSetWindowAttributesPtr   x = x 
fromXSetWindowAttributesPtr x = x

instance Pointer XSetWindowAttributesPtr where
  toPtr     = fromXSetWindowAttributesPtr
  fromPtr   = toXSetWindowAttributesPtr
  alloc     = malloc sizeofXSetWindowAttributes
  plus p x  = fromPtr (plusPtr (toPtr p) (x * sizeofXSetWindowAttributes))
  minus p q = (toPtr p `minusPtr` toPtr q) `div` sizeofXSetWindowAttributes
%}}

%type : XSetWindowAttributesPtr : XSetWindowAttributes* $0 : %pack(Ptr,$0);% : %unpack(Ptr,$0,$1);%

%const Int sizeofXSetWindowAttributes = sizeof(XSetWindowAttributes)

################ Access to individual fields ################

%prim set_background_pixmap :: XSetWindowAttributesPtr -> Pixmap -> IO ()
$0->background_pixmap = $1;
%return();

%prim set_background_pixel :: XSetWindowAttributesPtr -> Pixel -> IO ()
$0->background_pixel = $1;
%return();

%prim set_border_pixmap :: XSetWindowAttributesPtr -> Pixmap -> IO ()
$0->border_pixmap = $1;
%return();

%prim set_border_pixmel :: XSetWindowAttributesPtr -> Pixel -> IO ()
$0->border_pixel = $1;
%return();

%prim set_bit_gravity :: XSetWindowAttributesPtr -> BitGravity -> IO ()
$0->bit_gravity = $1;
%return();

%prim set_win_gravity :: XSetWindowAttributesPtr -> WindowGravity -> IO ()
$0->win_gravity = $1;
%return();

%prim set_backing_store :: XSetWindowAttributesPtr -> BackingStore -> IO ()
$0->win_gravity = $1;
%return();

%prim set_backing_planes :: XSetWindowAttributesPtr -> Pixel -> IO ()
$0->backing_planes = $1;
%return();

%prim set_backing_pixel :: XSetWindowAttributesPtr -> Pixel -> IO ()
$0->backing_pixel = $1;
%return();

%prim set_save_under :: XSetWindowAttributesPtr -> Bool -> IO ()
$0->save_under = $1;
%return();

%prim set_event_mask :: XSetWindowAttributesPtr -> EventMask -> IO ()
$0->event_mask = $1;
%return();

%prim set_do_not_propagate_mask :: XSetWindowAttributesPtr -> EventMask -> IO ()
$0->do_not_propagate_mask = $1;
%return();

%prim set_overide_redirect :: XSetWindowAttributesPtr -> Bool -> IO ()
$0->override_redirect = $1;
%return();

%prim set_colormap :: XSetWindowAttributesPtr -> Colormap -> IO ()
$0->colormap = $1;
%return();

%prim set_cursor :: XSetWindowAttributesPtr -> Cursor -> IO ()
$0->cursor = $1;
%return();

################################################################
# Windows
################################################################

%fun XStoreName :: Display -> Window -> String -> IO ()
%fun XCreateSimpleWindow :: Display -> Window -> Position -> Position -> Dimension -> Dimension -> Int -> Pixel -> Pixel -> IO Window

%fun XCreateWindow :: Display -> Window -> Position -> Position -> Dimension -> Dimension -> Int -> Int -> WindowClass -> Visual -> AttributeMask -> XSetWindowAttributesPtr -> IO Window

################################################################

#ToDo: find an effective way to use Maybes
%fun XTranslateCoordinates :: Display -> Window -> Window -> Position -> Position -> IO (Bool,Position,Position,Window) using $r0 = XTranslateCoordinates($0,$1,$2,$3,$4,&$r1,&$r2,&$r3)

%fun XMoveResizeWindow            :: Display -> Window -> Position  -> Position  -> Dimension -> Dimension -> IO ()
%fun XResizeWindow                :: Display -> Window -> Dimension -> Dimension -> IO ()
%fun XMoveWindow                  :: Display -> Window -> Position  -> Position  -> IO ()
%fun XReparentWindow              :: Display -> Window -> Window -> Position -> Position  -> IO ()
%fun XMapSubwindows               :: Display -> Window -> IO ()
%fun XUnmapSubwindows             :: Display -> Window -> IO ()
%fun XMapWindow                   :: Display -> Window -> IO ()
# Disnae exist: %fun XUnmapWindows                :: Display -> Window -> IO ()
# Disnae exist: %fun XMapRaisedWindow             :: Display -> Window -> IO ()
%fun XLowerWindow                 :: Display -> Window -> IO ()
%fun XRaiseWindow                 :: Display -> Window -> IO ()
%fun XCirculateSubwindowsDown     :: Display -> Window -> IO ()
%fun XCirculateSubwindowsUp       :: Display -> Window -> IO ()
%fun XCirculateSubwindows         :: Display -> Window -> CirculationDirection -> IO ()
%errfun BadStatus XIconifyWindow  :: Display -> Window -> ScreenNumber -> IO ()
%errfun BadStatus XWithdrawWindow :: Display -> Window -> ScreenNumber -> IO ()
%fun XDestroyWindow               :: Display -> Window -> IO ()
%fun XDestroySubwindows           :: Display -> Window -> IO ()

%fun XSetWindowBorder             :: Display -> Window -> Pixel     -> IO ()
%fun XSetWindowBorderPixmap       :: Display -> Window -> Pixmap    -> IO ()
%fun XSetWindowBorderWidth        :: Display -> Window -> Dimension -> IO ()
%fun XSetWindowBackground         :: Display -> Window -> Pixel     -> IO ()
%fun XSetWindowBackgroundPixmap   :: Display -> Window -> Pixmap    -> IO ()
%fun XSetWindowColormap           :: Display -> Window -> Colormap  -> IO ()

%fun XAddToSaveSet                :: Display -> Window -> IO ()
%fun XRemoveFromSaveSet           :: Display -> Window -> IO ()
%fun XChangeSaveSet               :: Display -> Window -> ChangeSaveSetMode -> IO ()

%fun XClearWindow                 :: Display -> Window -> IO ()
%fun XClearArea                   :: Display -> Window -> Position -> Position -> Dimension -> Dimension -> Bool -> IO ()

# This is almost good enough - but doesn't call XFree
# %errfun BadStatus XQueryTree :: Display -> Window -> IO (Window, Window, ListWindow) using $err = XQueryTree($0,$1,&$r0,&$r1,&$r2,&$r2_size)
%prim XQueryTree :: Display -> Window -> IO (Window, Window, ListWindow)
Window root_w, parent;
Int children_size;
Window *children;
Status r = XQueryTree($0,$1,&root_w, &parent, &children, &children_size);
if (Success != r) { %failWith(BadStatus,r); }
%update(root_w,parent,children);
XFree(children);
return;

%fun XRestackWindows :: Display -> ListWindow -> IO () using XRestackWindows($0, $1, $1_size)

# ToDo: I want to be able to write this
# %fun XListInstalledColormaps :: Display -> Window -> IO ListColormap using $r0 = XListInstalledColormaps($0,$1,&$r0_size) 
# But I have to write this instead - need to add a notion of cleanup code!
%prim XListInstalledColormaps :: Display -> Window -> IO ListColormap
Int r_size;
Colormap* r = XListInstalledColormaps($0,$1,&r_size);
%update(r);
XFree(r);
return;

# Again, this is almost good enough
# %errfun BadStatus XGetCommand :: Display -> Window -> IO ListString using $err = XGetCommand($0,$1,&$r0,&$r0_size)
# but not quite
#%prim XGetCommand :: Display -> Window -> IO ListString
#Int    argv_size;
#String *argv;
#Status r = XGetCommand($0,$1,&argv,&argv_size);
#if (Success != r) { %failWith(BadStatus, r); }
#%update(argv);
#XFreeStringList(argv);
#return;

#%fun XSetCommand :: Display -> Window -> ListString -> IO ()            using XSetCommand($0,$1,$2,$2_size)

%errfun BadStatus XGetTransientForHint :: Display -> Window -> IO Window using $err = XGetTransientForHint($0,$1,&$r0)

%fun XSetTransientForHint :: Display -> Window -> Window -> IO ()

# XRotateWindowProperties omitted
# XGetWindowProperty omitted

# XGetWindowAttributes omitted
# XChangeWindowAttributes omitted

################################################################
# Drawing
################################################################

%fun XDrawPoint      :: Display -> Drawable -> GC -> Position -> Position -> IO ()
%fun XDrawPoints     :: Display -> Drawable -> GC -> ListXPoint -> CoordinateMode -> IO () using XDrawPoints($0,$1,$2,$3,$3_size,$4) 
%fun XDrawLine       :: Display -> Drawable -> GC -> Position -> Position -> Position -> Position -> IO ()
%fun XDrawLines      :: Display -> Drawable -> GC -> ListXPoint -> CoordinateMode -> IO () using XDrawLines($0,$1,$2,$3,$3_size,$4) 
%fun XDrawSegments   :: Display -> Drawable -> GC -> ListXSegment -> IO ()                 using XDrawSegments($0,$1,$2,$3,$3_size) 
%fun XDrawRectangle  :: Display -> Drawable -> GC -> Position -> Position -> Dimension -> Dimension -> IO ()
%fun XDrawRectangles :: Display -> Drawable -> GC -> ListXRectangle -> IO ()               using XDrawRectangles($0,$1,$2,$3,$3_size) 
%fun XDrawArc        :: Display -> Drawable -> GC -> Position -> Position -> Dimension -> Dimension -> Int -> Int -> IO ()
%fun XDrawArcs       :: Display -> Drawable -> GC -> ListXArc -> IO ()                     using XDrawArcs($0,$1,$2,$3,$3_size) 
%fun XFillRectangle  :: Display -> Drawable -> GC -> Position -> Position -> Dimension -> Dimension -> IO ()
%fun XFillRectangles :: Display -> Drawable -> GC -> ListXRectangle -> IO ()               using XFillRectangles($0,$1,$2,$3,$3_size) 
%fun XFillPolygon    :: Display -> Drawable -> GC -> ListXPoint -> PolygonShape -> CoordinateMode -> IO () using XFillPolygon($0,$1,$2,$3,$3_size,$4,$5) 
%fun XFillArc        :: Display -> Drawable -> GC -> Position -> Position -> Dimension -> Dimension -> Int -> Int -> IO ()
%fun XFillArcs       :: Display -> Drawable -> GC -> ListXArc -> IO ()                     using XFillArcs($0,$1,$2,$3,$3_size) 
%fun XCopyArea       :: Display -> Drawable -> Drawable -> GC -> Position -> Position -> Dimension -> Dimension -> Position -> Position -> IO ()
%fun XCopyPlane      :: Display -> Drawable -> Drawable -> GC -> Position -> Position -> Dimension -> Dimension -> Position -> Position -> Pixel -> IO ()

# draw characters over existing background
%fun XDrawString     :: Display -> Drawable -> GC -> Position -> Position -> String -> IO ()  using XDrawString($0,$1,$2,$3,$4,$5,$5_size) 
# draw characters over a blank rectangle of current background colour
%fun XDrawImageString :: Display -> Drawable -> GC -> Position -> Position -> String -> IO () using XDrawImageString($0,$1,$2,$3,$4,$5,$5_size) 

# XDrawString16 omitted (16bit chars not supported)
# XDrawImageString16 omitted (16bit chars not supported)
# XDrawText omitted (XTextItem not supported)
# XDrawText16 omitted (XTextItem not supported)
