/* This should be #included at the start of every interface file.
 * It #includes the following parts of the Hugs system:
 *   config.h
 *   options.h
 *   prelude.h
 *   storage.h
 *   connect.h
 */
#include "HUGS.h"
typedef char  CHAR;
static Void XSpack_String(ppArray)
CHAR *ppArray;
{
    int ppSize;
    for (ppSize = 0; !(('\0' == ppArray[ppSize])); ppSize++) {}
    hugsNIL;
    while (--ppSize >= 0) {
        hugsCHAR(ppArray[ppSize]);;;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
static Void XSpack_PString(ppArray)
CHAR *ppArray;
{
    int ppSize;
    for (ppSize = 0; !(('\0' == ppArray[ppSize])); ppSize++) {}
    hugsNIL;
    while (--ppSize >= 0) {
        hugsCHAR(ppArray[ppSize]);;;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
typedef void* Ptr;

static Void local mkPtr Args((Ptr));
static Void local mkPtr(n)
Ptr n; {
    hugs_push(hugs->makeInt((Int) n));
}

#define hugs_whnfPtr ((void*) hugs_whnfInt)
typedef Int Word8;
typedef Int Word16;
typedef unsigned long Word32;
typedef unsigned int Word;
typedef Int Int8;
typedef Int Int16;
typedef Int Int32;
typedef Int Int64;
typedef Int Word64;
static Cell hugsRunIO Args((Cell));
static Cell hugsRunIO(x)
Cell x; {
    StackPtr old_sp   = hugs_sp;
    Cell     result   = NIL;
    Cell     temp     = NIL;
    hugs_push(hugs->nameIORun);
    hugs_push(x);
    hugsRAP;
    temp = hugs->evalWithNoError(hugs_pop());
    hugs_assert(isNull(temp));
    if (hugs_whnfHead == hugs->nameRight) {
	result = hugs_pop();
    } else { /* Called "exit" */
	hugs->evalFails(old_sp);
    }
    hugs_assert(hugs_sp == old_sp);
    return result;
}

static Int hugsEvalInt Args((Cell));
static Int hugsEvalInt(x)
Cell x; {
    StackPtr old_sp = hugs_sp;
    Cell     temp = hugs->evalWithNoError(x);
    hugs_assert(isNull(temp));
#if 0
    hugs_assert(isInt(whnfHead)); /* Foo - gets confused by CAFs */
#endif
    hugs_assert(hugs_sp == old_sp);
    return hugs_whnfInt;
}

static Bool hugsEvalBool Args((Cell));
static Bool hugsEvalBool(x)
Cell x; {
    StackPtr old_sp = hugs_sp;
    Cell     temp = hugs->evalWithNoError(x);
    hugs_assert(isNull(temp));
    hugs_assert(hugs_whnfHead == hugs->nameTrue
                || hugs_whnfHead == hugs->nameFalse
                );
    hugs_assert(hugs_sp == old_sp);
    return hugs_whnfInt;
}
Name XSname_HeapExhaustion;

PROTO_PRIM(XStest_isHeapExhaustion);
primFun(XStest_isHeapExhaustion) {
        hugs->eval(hugs_primArg(1));
    if (hugs_whnfHead==XSname_HeapExhaustion) {
	if (1) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;;
    } else {
	if (0) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;
    }
    {
    }
}

PROTO_PRIM(XS_freePtr);
primFun(XS_freePtr) {
    {
    	Ptr pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    free(pparg0);
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_primMalloc);
primFun(XS_primMalloc) {
    {
    	Int 	pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=hugs_whnfInt;
    {
    Ptr p = malloc(pparg0);
    if (!(p)) {hugs_push(XSname_HeapExhaustion); hugsFAIL; hugsUPDAPROOT;; return;} mkPtr((Ptr)p); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_getchar);
primFun(XS_getchar) {
    {
    {
    	Char 	ppret0;
    	ppret0 = getchar();
    	hugsCHAR(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_putchar);
primFun(XS_putchar) {
    {
    	Char 	pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=hugs->CharOf(hugs_whnfHead);
    {
    	putchar(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}
typedef Int ModeT;
typedef Int POSIXHandle;
#include <sys/stat.h>

PROTO_PRIM(XS_or);
primFun(XS_or) {
    {
    	Int 	pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=hugs_whnfInt;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    hugsINT(pparg0|pparg1); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_and);
primFun(XS_and) {
    {
    	Int 	pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=hugs_whnfInt;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    hugsINT(pparg0&pparg1); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_not);
primFun(XS_not) {
    {
    	Int 	pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=hugs_whnfInt;
    {
    hugsINT(~pparg0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}
typedef Int POSIXError;
#include <errno.h>
#include <string.h>

PROTO_PRIM(XS_strerror);
primFun(XS_strerror) {
    {
    	Int 	pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=hugs_whnfInt;
    {
    	int ppret0_size; char* ppret0;
    	ppret0 = strerror(pparg0);
    	XSpack_String(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}
Name XSname_POSIXError;

PROTO_PRIM(XStest_isPOSIXError);
primFun(XStest_isPOSIXError) {
        hugs->eval(hugs_primArg(1));
    if (hugs_whnfHead==XSname_POSIXError) {
	hugs_updapRoot(hugs->nameJust,hugs_pop());;
    } else {
	hugsNOTHING hugsUPDATEROOT;;
    }
    {
    }
}
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

PROTO_PRIM(XS_creat);
primFun(XS_creat) {
    {
    	int pparg0_size; char* pparg0;
    	Int 	pparg1;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(4));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg0_size = ppindex; pparg0 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg0) { hugs_cantReduce(); } pparg0[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg0[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = creat(pparg0,pparg1);
    	if (-1 == ppret0) {hugs_push(XSname_POSIXError); hugsINT(errno);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}
#if HAVE_UNISTD_H
#include <unistd.h>
#endif

PROTO_PRIM(XS_dup);
primFun(XS_dup) {
    {
    	Int 	pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = dup(pparg0);
    	if (-1 == ppret0) {hugs_push(XSname_POSIXError); hugsINT(errno);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_dup2);
primFun(XS_dup2) {
    {
    	Int 	pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	Int pperr;
    	pperr = dup2(pparg0,pparg1);
    	if (-1 == pperr) {hugs_push(XSname_POSIXError); hugsINT(errno);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}
#include <sys/types.h>
#include <time.h>

PROTO_PRIM(XS_difftime);
primFun(XS_difftime) {
    {
    	time_t pparg0;
    	time_t pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=hugs_whnfInt;;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;;
    {
    	Double ppret0;
    	ppret0 = difftime(pparg0,pparg1);
    	hugsFLOAT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}
#if !HAVE_STIME
/* Win32 doesn't support stime - so we define a dummy function
 * (of course, what we Really Want is conditional processing of
 * the .ss script...)
 */
static void stime(t)
time_t *t; {
	printf("Pretending to set time to %d\n", t);
}
#endif

PROTO_PRIM(XS_ctime);
primFun(XS_ctime) {
    {
    	time_t pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=hugs_whnfInt;;
    {
    	int ppret0_size; char* ppret0;
    	ppret0 = ctime(&pparg0);
    	XSpack_String(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_time);
primFun(XS_time) {
    {
    {
    	time_t ppret0;
    	time(&ppret0);
    	hugsINT(ppret0);; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_stime);
primFun(XS_stime) {
    {
    	time_t pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=hugs_whnfInt;;
    {
    	stime(&pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}
#include <time.h>

PROTO_PRIM(XS_localtime);
primFun(XS_localtime) {
    {
    	time_t pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=hugs_whnfInt;;
    {
    struct tm *t = localtime(&pparg0);
    hugsINT((*t).tm_sec); hugsTUPLE(9); hugsAP; hugsINT((*t).tm_min); hugsRAP; hugsINT((*t).tm_hour); hugsRAP; hugsINT((*t).tm_mday); hugsRAP; hugsINT((*t).tm_mon); hugsRAP; hugsINT((*t).tm_year); hugsRAP; hugsINT((*t).tm_wday); hugsRAP; hugsINT((*t).tm_yday); hugsRAP; if ((*t).tm_isdst) {hugsTRUE;} else {hugsFALSE;} hugsRUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_gmtime);
primFun(XS_gmtime) {
    {
    	time_t pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=hugs_whnfInt;;
    {
    struct tm *t = gmtime(&pparg0);
    hugsINT((*t).tm_sec); hugsTUPLE(9); hugsAP; hugsINT((*t).tm_min); hugsRAP; hugsINT((*t).tm_hour); hugsRAP; hugsINT((*t).tm_mday); hugsRAP; hugsINT((*t).tm_mon); hugsRAP; hugsINT((*t).tm_year); hugsRAP; hugsINT((*t).tm_wday); hugsRAP; hugsINT((*t).tm_yday); hugsRAP; if ((*t).tm_isdst) {hugsTRUE;} else {hugsFALSE;} hugsRUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_asctime);
primFun(XS_asctime) {
    {
    	struct tm pparg0;
    	hugs->eval(hugs_primArg(1));
hugs->eval(hugs_pop()); (pparg0).tm_sec=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg0).tm_min=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg0).tm_hour=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg0).tm_mday=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg0).tm_mon=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg0).tm_year=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg0).tm_wday=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg0).tm_yday=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg0).tm_isdst=(hugs_whnfHead==hugs->nameTrue);
    {
    	int ppret0_size; char* ppret0;
    	ppret0 = asctime(&pparg0);
    	XSpack_String(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}
static Void XSpack_ListDouble(ppArray, ppSize)
Double *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsFLOAT(ppArray[ppSize]);;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
#if HAVE_POLY

#include <math.h>

#else

static double poly Args((double, int, double[]));
static double poly(x, degree, coeffs)
double x;
int degree;
double coeffs[];
{
    double r = 0;
    for(; degree >= 0; --degree) r = x*r + coeffs[degree];
    return r;
}

#endif

PROTO_PRIM(XS_poly);
primFun(XS_poly) {
    {
    	Double pparg0;
    	int pparg1_size; double* pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=hugs_whnfFloat;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(1));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg1_size = ppindex; pparg1 = (double *) alloca(ppindex * sizeof(double)); if (!pparg1) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg1[ppindex]=hugs_whnfFloat;
	    }
	};
    {
    	Double ppret0;
    	ppret0 = poly(pparg0,1+pparg1_size,pparg1);
    	hugsFLOAT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}
static Void XSpack_PListDouble(ppArray, ppSize)
Double *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsFLOAT(ppArray[ppSize]);;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
typedef Ptr DoubleArray;

PROTO_PRIM(XS_mkDoubleArray);
primFun(XS_mkDoubleArray) {
    {
    	int pparg0_size; double* pparg0;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg0_size = ppindex; pparg0 = (double *) malloc(ppindex * sizeof(double)); if (!pparg0) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg0[ppindex]=hugs_whnfFloat;
	    }
	};
    {
    mkPtr((Ptr)pparg0); hugsTUPLE(2); hugsAP; hugsINT(pparg0_size); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_freeDoubleArray);
primFun(XS_freeDoubleArray) {
    {
    	Ptr pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    free(pparg0);
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_polyDA);
primFun(XS_polyDA) {
    {
    	Double pparg0;
    	Int 	pparg1;
    	Ptr pparg2;
    	hugs->eval(hugs_primArg(3)); pparg0=hugs_whnfFloat;
    	hugs->eval(hugs_primArg(2)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(1)); pparg2=(Ptr)hugs_whnfPtr;
    {
    	Double ppret0;
    	ppret0 = poly(pparg0,pparg1,(double*)pparg2);
    	hugsFLOAT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}
void freeMDoubleArray Args((void *));

void freeMDoubleArray(m)
void *m;
{
#if 1 || DEBUG
    printf("\nFreeing a MDoubleArray\n");
#endif
    free(m);
}

PROTO_PRIM(XS_mkMDoubleArray);
primFun(XS_mkMDoubleArray) {
    {
    	int pparg0_size; double* pparg0;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg0_size = ppindex; pparg0 = (double *) malloc(ppindex * sizeof(double)); if (!pparg0) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg0[ppindex]=hugs_whnfFloat;
	    }
	};
    {
    hugs_push(hugs->mkMallocPtr(pparg0,freeMDoubleArray)); hugsTUPLE(2); hugsAP; hugsINT(pparg0_size); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_polyMDA);
primFun(XS_polyMDA) {
    {
    	Double pparg0;
    	Int 	pparg1;
    	double *pparg2;
    	hugs->eval(hugs_primArg(3)); pparg0=hugs_whnfFloat;
    	hugs->eval(hugs_primArg(2)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(1)); pparg2=hugs->derefMallocPtr(hugs_whnfHead);
    {
    	Double ppret0;
    	ppret0 = poly(pparg0,pparg1,(double*)pparg2);
    	hugsFLOAT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_garbageCollect);
primFun(XS_garbageCollect) {
    {
    {
    	hugs_garbageCollect();
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}
Int spf = 0;

PROTO_PRIM(XS_saveSPF);
primFun(XS_saveSPF) {
    {
    	Int pparg0;
    	pparg0=hugs->mkStablePtr(hugs_primArg(3));
    {
    spf = pparg0;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_getSPF);
primFun(XS_getSPF) {
    {
    {
    hugsStablePtr(spf); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_apply);
primFun(XS_apply) {
    {
    	Int pparg0;
    	Int pparg1;
    	pparg0=hugs->mkStablePtr(hugs_primArg(2));
    	pparg1=hugs->mkStablePtr(hugs_primArg(1));
    {
    hugsStablePtr(pparg0);
    hugsStablePtr(pparg1);
    hugsRAP;
    hugs->eval(hugs_pop());
    hugsFLOAT(hugs_whnfFloat); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XSconsts_ModeT);
primFun(XSconsts_ModeT) {
        static ModeT consts[] = {
    	S_IWRITE,
    	S_IREAD,
    	S_IWRITE,
    	S_IREAD
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_Int);
primFun(XSconsts_Int) {
        static Int consts[] = {
    	0
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_POSIXError);
primFun(XSconsts_POSIXError) {
        static POSIXError consts[] = {
    	EACCES,
    	ENOENT,
    	EMFILE
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

struct primitive primTable[] = {
	    {"XStest_isHeapExhaustion", 1, XStest_isHeapExhaustion},
	    {"XS_freePtr", 3, XS_freePtr},
	    {"XS_primMalloc", 3, XS_primMalloc},
	    {"XS_getchar", 2, XS_getchar},
	    {"XS_putchar", 3, XS_putchar},
	    {"XS_or", 2, XS_or},
	    {"XS_and", 2, XS_and},
	    {"XS_not", 1, XS_not},
	    {"XS_strerror", 1, XS_strerror},
	    {"XStest_isPOSIXError", 1, XStest_isPOSIXError},
	    {"XS_creat", 4, XS_creat},
	    {"XS_dup", 3, XS_dup},
	    {"XS_dup2", 4, XS_dup2},
	    {"XS_difftime", 2, XS_difftime},
	    {"XS_ctime", 1, XS_ctime},
	    {"XS_time", 2, XS_time},
	    {"XS_stime", 3, XS_stime},
	    {"XS_localtime", 1, XS_localtime},
	    {"XS_gmtime", 1, XS_gmtime},
	    {"XS_asctime", 1, XS_asctime},
	    {"XS_poly", 2, XS_poly},
	    {"XS_mkDoubleArray", 3, XS_mkDoubleArray},
	    {"XS_freeDoubleArray", 3, XS_freeDoubleArray},
	    {"XS_polyDA", 3, XS_polyDA},
	    {"XS_mkMDoubleArray", 3, XS_mkMDoubleArray},
	    {"XS_polyMDA", 3, XS_polyMDA},
	    {"XS_garbageCollect", 2, XS_garbageCollect},
	    {"XS_saveSPF", 3, XS_saveSPF},
	    {"XS_getSPF", 2, XS_getSPF},
	    {"XS_apply", 2, XS_apply},
	    {"XSconsts_ModeT", 1, XSconsts_ModeT},
	    {"XSconsts_Int", 1, XSconsts_Int},
	    {"XSconsts_POSIXError", 1, XSconsts_POSIXError},

	    {0,0,0}
};

static Void controlexterns Args((Int));
static Void local controlexterns(what)
Int what; {
    switch (what) {
	case INSTALL : 
		XSname_HeapExhaustion = hugs->addPrimCfun(hugs->inventText(),0,0,NIL);
		XSname_POSIXError = hugs->addPrimCfun(hugs->inventText(),1,0,NIL);

                break;
    }
}
static struct primInfo prims = { controlexterns, primTable, 0 };

/* After dynamically loading a module, Hugs looks up this symbol and
 * calls it with a "virtual function table" containing all necessary
 * parts of the Hugs API.  
 * (Much painful experimentation established that this was the most
 *  portable way for a DLL/shared object to access parts of Hugs.)
 *
 * This should be the only symbol exported from this module.
 */
DLLEXPORT(void) initModule(HugsAPI *);
DLLEXPORT(void) initModule(HugsAPI *hugsAPI) {
    hugs = hugsAPI;
    hugs->registerPrims(&prims);
    controlexterns(INSTALL);
}



