/* --------------------------------------------------------------------------
 * Statically linked plugins
 *
 * Copyright (c) The University of Nottingham and Yale University, 1994-1997.
 * All rights reserved. See NOTICE for details and conditions of use etc...
 * Hugs version 1.4, July 1997
 *
 * $RCSfile: plugin.c,v $
 * $Revision: 1.6 $
 * $Date: 1997/07/17 20:52:42 $
 * ------------------------------------------------------------------------*/

#include "prelude.h"
#include "storage.h"
#include "connect.h"
#include "errors.h"

/* This file is often compiled with a command-line argument such as
 *   '-DPLUGINS={Xlib,&initXlib},'
 * default to empty if not present.
 */
#ifndef PLUGINS
# define PLUGINS
#endif

struct pluginInfo {
    String         nm;            /* Name of plugin module                 */
    InitModuleFun  initModule;    /* Initialisation code for the plugin    */
};

extern InitModuleFun initModule;

static struct pluginInfo pluginList[] = { /* hardwired list of all plugins */
  /* {"Test",  initTest},  */
  /* {"Xlib",  initXlib},  */
  /* {"Win32", initWin32}, */
  PLUGINS
  {0,0}
};

Bool havePlugin(mod)                /* did we statically link this plugin? */
String mod; {
    Int i;
    for(i=0; pluginList[i].nm; ++i) {
        if (0 == strcmp(mod, pluginList[i].nm)) {
            return TRUE;
        }
    }
    return FALSE;
}

/* --------------------------------------------------------------------------
 * Plugins control:
 * ------------------------------------------------------------------------*/

Void plugins(what)
Int what; {
    Int i;
    switch (what) {
        case INSTALL : for (i=0; pluginList[i].initModule; i++) {
#if GREENCARD_2
			   (*pluginList[i].initModule)(hugsAPI2());
#else
			   (*pluginList[i].initModule)(hugsAPI());
#endif
		       }
                       break;
    }
}

/*-------------------------------------------------------------------------*/
