/* Standard X imports */
#include <X11/X.h>
#include <X11/Xlib.h>

/* Standard HUGS imports - these come second so's we can overcome
 * duplicate definitions.
 */
#include "HUGS.h"
typedef char  CHAR;
static Void XSpack_String(ppArray)
CHAR *ppArray;
{
    int ppSize;
    for (ppSize = 0; !(('\0' == ppArray[ppSize])); ppSize++) {}
    hugsNIL;
    while (--ppSize >= 0) {
        hugsCHAR(ppArray[ppSize]);;;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
static Void XSpack_PString(ppArray)
CHAR *ppArray;
{
    int ppSize;
    for (ppSize = 0; !(('\0' == ppArray[ppSize])); ppSize++) {}
    hugsNIL;
    while (--ppSize >= 0) {
        hugsCHAR(ppArray[ppSize]);;;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
typedef void* Ptr;

static Void local mkPtr Args((Ptr));
static Void local mkPtr(n)
Ptr n; {
    hugs_push(hugs->makeInt((Int) n));
}

#define hugs_whnfPtr ((void*) hugs_whnfInt)
typedef Int Word8;
typedef Int Word16;
typedef unsigned long Word32;
typedef unsigned int Word;
typedef Int Int8;
typedef Int Int16;
typedef Int Int32;
typedef Int Int64;
typedef Int Word64;
static Cell hugsRunIO Args((Cell));
static Cell hugsRunIO(x)
Cell x; {
    StackPtr old_sp   = hugs_sp;
    Cell     result   = NIL;
    Cell     temp     = NIL;
    hugs_push(hugs->nameIORun);
    hugs_push(x);
    hugsRAP;
    temp = hugs->evalWithNoError(hugs_pop());
    hugs_assert(isNull(temp));
    if (hugs_whnfHead == hugs->nameRight) {
	result = hugs_pop();
    } else { /* Called "exit" */
	hugs->evalFails(old_sp);
    }
    hugs_assert(hugs_sp == old_sp);
    return result;
}

static Int hugsEvalInt Args((Cell));
static Int hugsEvalInt(x)
Cell x; {
    StackPtr old_sp = hugs_sp;
    Cell     temp = hugs->evalWithNoError(x);
    hugs_assert(isNull(temp));
#if 0
    hugs_assert(isInt(whnfHead)); /* Foo - gets confused by CAFs */
#endif
    hugs_assert(hugs_sp == old_sp);
    return hugs_whnfInt;
}

static Bool hugsEvalBool Args((Cell));
static Bool hugsEvalBool(x)
Cell x; {
    StackPtr old_sp = hugs_sp;
    Cell     temp = hugs->evalWithNoError(x);
    hugs_assert(isNull(temp));
    hugs_assert(hugs_whnfHead == hugs->nameTrue
                || hugs_whnfHead == hugs->nameFalse
                );
    hugs_assert(hugs_sp == old_sp);
    return hugs_whnfInt;
}
Name XSname_HeapExhaustion;

PROTO_PRIM(XStest_isHeapExhaustion);
primFun(XStest_isHeapExhaustion) {
        hugs->eval(hugs_primArg(1));
    if (hugs_whnfHead==XSname_HeapExhaustion) {
	if (1) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;;
    } else {
	if (0) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;
    }
    {
    }
}

PROTO_PRIM(XS_freePtr);
primFun(XS_freePtr) {
    {
    	Ptr pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    free(pparg0);
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_primMalloc);
primFun(XS_primMalloc) {
    {
    	Int 	pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=hugs_whnfInt;
    {
    Ptr p = malloc(pparg0);
    if (!(p)) {hugs_push(XSname_HeapExhaustion); hugsFAIL; hugsUPDAPROOT;; return;} mkPtr((Ptr)p); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}
typedef String MbString;
static Void XSpack_ListInt(ppArray, ppSize)
Int *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsINT(ppArray[ppSize]);;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}

PROTO_PRIM(XS_orMask);
primFun(XS_orMask) {
    {
    	Int 	pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=hugs_whnfInt;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    hugsINT(pparg0|pparg1); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_andMask);
primFun(XS_andMask) {
    {
    	Int 	pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=hugs_whnfInt;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    hugsINT(pparg0&pparg1); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_notMask);
primFun(XS_notMask) {
    {
    	Int 	pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=hugs_whnfInt;
    {
    hugsINT(~pparg0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}
typedef Mask EventMask;
typedef Int EventType;
typedef Mask Modifier;
typedef Modifier KeyMask;
typedef Modifier ButtonMask;
typedef Int Button;
typedef Int NotifyMode;
typedef Int NotifyDetail;
typedef Int Visibility;
typedef Int Place;
typedef Int Protocol;
typedef Int PropertyNotification;
typedef Int ColormapNotification;
typedef Int GrabMode;
typedef Int GrabStatus;
typedef Int AllowEvents;
typedef Int FocusMode;
typedef Int WindowClass;
typedef Mask AttributeMask;
typedef Int Gravity;
typedef Gravity BitGravity;
typedef Gravity WindowGravity;
typedef Int BackingStore;
typedef Int CoordinateMode;
typedef Int PolygonShape;
typedef Int QueryBestSizeClass;
typedef Int ColormapAlloc;
typedef Int Access;
typedef Int CloseDownMode;
typedef Int ChangeSaveSetMode;
typedef Int WindowStackingMethod;
typedef Int CirculationDirection;
typedef Int RectangleOrdering;
typedef Int ImageFormat;
typedef Int AutoRepeatMode;
typedef Int LedMode;
typedef Int ByteOrder;
typedef Int VisualClass;
typedef Int MappingRequest;
typedef Mask PrimaryMask;
typedef Word32 Pixel;
typedef Int32 Position;
typedef Word Dimension;
typedef Word32 ScreenNumber;
typedef Int Buffer;
static Void XSpack_ListXPoint(ppArray, ppSize)
XPoint *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsINT((ppArray[ppSize]).x); hugsTUPLE(2); hugsAP; hugsINT((ppArray[ppSize]).y); hugsRAP;;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
static Void XSpack_ListXSegment(ppArray, ppSize)
XSegment *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsINT((ppArray[ppSize]).x1); hugsTUPLE(4); hugsAP; hugsINT((ppArray[ppSize]).y1); hugsRAP; hugsINT((ppArray[ppSize]).x2); hugsRAP; hugsINT((ppArray[ppSize]).y2); hugsRAP;;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
static Void XSpack_ListXRectangle(ppArray, ppSize)
XRectangle *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsINT((ppArray[ppSize]).x); hugsTUPLE(4); hugsAP; hugsINT((ppArray[ppSize]).y); hugsRAP; hugsINT((ppArray[ppSize]).width); hugsRAP; hugsINT((ppArray[ppSize]).height); hugsRAP;;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
static Void XSpack_ListXArc(ppArray, ppSize)
XArc *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsINT((ppArray[ppSize]).x); hugsTUPLE(6); hugsAP; hugsINT((ppArray[ppSize]).y); hugsRAP; hugsINT((ppArray[ppSize]).width); hugsRAP; hugsINT((ppArray[ppSize]).height); hugsRAP; hugsINT((ppArray[ppSize]).angle1); hugsRAP; hugsINT((ppArray[ppSize]).angle2); hugsRAP;;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
static Void XSpack_ListWindow(ppArray, ppSize)
Window *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsINT(ppArray[ppSize]);;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
static Void XSpack_ListColormap(ppArray, ppSize)
Colormap *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsINT(ppArray[ppSize]);;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
static Void XSpack_ListPixel(ppArray, ppSize)
Pixel *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsINT(ppArray[ppSize]);;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
static Void XSpack_ListXColor(ppArray, ppSize)
XColor *ppArray;
Int       ppSize;
{
    hugsNIL;
    while (--ppSize >= 0) {
        hugsINT((ppArray[ppSize]).pixel); hugsTUPLE(5); hugsAP; hugsINT((ppArray[ppSize]).red); hugsRAP; hugsINT((ppArray[ppSize]).green); hugsRAP; hugsINT((ppArray[ppSize]).blue); hugsRAP; hugsINT((ppArray[ppSize]).flags); hugsRAP;;
        hugsCONS;
        hugsAP;
        hugsAP;
    }
}
typedef Int Shape;
Name XSname_NullPtr;

PROTO_PRIM(XStest_isNullPtr);
primFun(XStest_isNullPtr) {
        hugs->eval(hugs_primArg(1));
    if (hugs_whnfHead==XSname_NullPtr) {
	if (1) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;;
    } else {
	if (0) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;
    }
    {
    }
}
Name XSname_BadStatus;

PROTO_PRIM(XStest_isBadStatus);
primFun(XStest_isBadStatus) {
        hugs->eval(hugs_primArg(1));
    if (hugs_whnfHead==XSname_BadStatus) {
	hugs_updapRoot(hugs->nameJust,hugs_pop());;
    } else {
	hugsNOTHING hugsUPDATEROOT;;
    }
    {
    }
}
Name XSname_Zero;

PROTO_PRIM(XStest_isZero);
primFun(XStest_isZero) {
        hugs->eval(hugs_primArg(1));
    if (hugs_whnfHead==XSname_Zero) {
	if (1) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;;
    } else {
	if (0) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;
    }
    {
    }
}
Name XSname_False;

PROTO_PRIM(XStest_isFalse);
primFun(XStest_isFalse) {
        hugs->eval(hugs_primArg(1));
    if (hugs_whnfHead==XSname_False) {
	if (1) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;;
    } else {
	if (0) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;
    }
    {
    }
}

PROTO_PRIM(XS_XAllPlanes);
primFun(XS_XAllPlanes) {
    {
    {
    	Word32 ppret0;
    	ppret0 = XAllPlanes();
    	hugsINT(ppret0);; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XBlackPixel);
primFun(XS_XBlackPixel) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XBlackPixel(pparg0,pparg1);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XWhitePixel);
primFun(XS_XWhitePixel) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XWhitePixel(pparg0,pparg1);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_ConnectionNumber);
primFun(XS_ConnectionNumber) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = ConnectionNumber(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultColormap);
primFun(XS_XDefaultColormap) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XDefaultColormap(pparg0,pparg1);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XListDepths);
primFun(XS_XListDepths) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	int ppret0_size; int* ppret0;
    	ppret0 = XListDepths(pparg0,pparg1,&ppret0_size);
    	XSpack_ListInt(ppret0,ppret0_size); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultGC);
primFun(XS_XDefaultGC) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Ptr ppret0;
    	ppret0 = XDefaultGC(pparg0,pparg1);
    	mkPtr((Ptr)ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultDepth);
primFun(XS_XDefaultDepth) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = XDefaultDepth(pparg0,pparg1);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultScreen);
primFun(XS_XDefaultScreen) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word32 ppret0;
    	ppret0 = XDefaultScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultScreenOfDisplay);
primFun(XS_XDefaultScreenOfDisplay) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Screen      *ppret0;
    	ppret0 = XDefaultScreenOfDisplay(pparg0);
    	mkPtr((Ptr)ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_DisplayHeight);
primFun(XS_DisplayHeight) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = DisplayHeight(pparg0,pparg1);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_DisplayHeightMM);
primFun(XS_DisplayHeightMM) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = DisplayHeightMM(pparg0,pparg1);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_DisplayWidth);
primFun(XS_DisplayWidth) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = DisplayWidth(pparg0,pparg1);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_DisplayWidthMM);
primFun(XS_DisplayWidthMM) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = DisplayWidthMM(pparg0,pparg1);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XMaxRequestSize);
primFun(XS_XMaxRequestSize) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XMaxRequestSize(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDisplayMotionBufferSize);
primFun(XS_XDisplayMotionBufferSize) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XDisplayMotionBufferSize(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XResourceManagerString);
primFun(XS_XResourceManagerString) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	int ppret0_size; char* ppret0;
    	ppret0 = XResourceManagerString(pparg0);
    	XSpack_String(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XScreenResourceString);
primFun(XS_XScreenResourceString) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	int ppret0_size; char* ppret0;
    	ppret0 = XScreenResourceString(pparg0);
    	XSpack_String(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_DisplayString);
primFun(XS_DisplayString) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	int ppret0_size; char* ppret0;
    	ppret0 = DisplayString(pparg0);
    	XSpack_String(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XImageByteOrder);
primFun(XS_XImageByteOrder) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XImageByteOrder(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XProtocolRevision);
primFun(XS_XProtocolRevision) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XProtocolRevision(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XProtocolVersion);
primFun(XS_XProtocolVersion) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XProtocolVersion(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XServerVendor);
primFun(XS_XServerVendor) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	int ppret0_size; char* ppret0;
    	ppret0 = XServerVendor(pparg0);
    	XSpack_String(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XScreenCount);
primFun(XS_XScreenCount) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XScreenCount(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultVisual);
primFun(XS_XDefaultVisual) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Visual      *ppret0;
    	ppret0 = XDefaultVisual(pparg0,pparg1);
    	mkPtr((Ptr)ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_DisplayCells);
primFun(XS_DisplayCells) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = DisplayCells(pparg0,pparg1);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_DisplayPlanes);
primFun(XS_DisplayPlanes) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = DisplayPlanes(pparg0,pparg1);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XScreenOfDisplay);
primFun(XS_XScreenOfDisplay) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(2)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(1)); pparg1=hugs_whnfInt;
    {
    	Screen      *ppret0;
    	ppret0 = XScreenOfDisplay(pparg0,pparg1);
    	mkPtr((Ptr)ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultRootWindow);
primFun(XS_XDefaultRootWindow) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word32 ppret0;
    	ppret0 = XDefaultRootWindow(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XRootWindow);
primFun(XS_XRootWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XRootWindow(pparg0,pparg1);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XQLength);
primFun(XS_XQLength) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XQLength(pparg0);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XNoOp);
primFun(XS_XNoOp) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XNoOp(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XOpenDisplay);
primFun(XS_XOpenDisplay) {
    {
    	int pparg0_size; char* pparg0;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg0_size = ppindex; pparg0 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg0) { hugs_cantReduce(); } pparg0[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg0[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	Display     *ppret0;
    	ppret0 = XOpenDisplay(pparg0);
    	if (!(ppret0)) {hugs_push(XSname_NullPtr);; hugsFAIL; hugsUPDAPROOT;; return;} mkPtr((Ptr)ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCloseDisplay);
primFun(XS_XCloseDisplay) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XCloseDisplay(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XrmInitialize);
primFun(XS_XrmInitialize) {
    {
    {
    	XrmInitialize();
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XAutoRepeatOff);
primFun(XS_XAutoRepeatOff) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XAutoRepeatOff(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XAutoRepeatOn);
primFun(XS_XAutoRepeatOn) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XAutoRepeatOn(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XBell);
primFun(XS_XBell) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XBell(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetCloseDownMode);
primFun(XS_XSetCloseDownMode) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XSetCloseDownMode(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XLastKnownRequestProcessed);
primFun(XS_XLastKnownRequestProcessed) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XLastKnownRequestProcessed(pparg0);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGetInputFocus);
primFun(XS_XGetInputFocus) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word32 ppret0;
    	Int 	ppret1;
    	XGetInputFocus(pparg0,&ppret0,&ppret1);
    	hugsINT(ppret0); hugsTUPLE(2); hugsAP; hugsINT(ppret1); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetInputFocus);
primFun(XS_XSetInputFocus) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	Int 	pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	XSetInputFocus(pparg0,pparg1,pparg2,pparg3);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGrabButton);
primFun(XS_XGrabButton) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	Int 	pparg2;
    	Word32 pparg3;
    	Bool 	pparg4;
    	Int 	pparg5;
    	Int 	pparg6;
    	Int 	pparg7;
    	Word32 pparg8;
    	Word32 pparg9;
    	hugs->eval(hugs_primArg(12)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(11)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(10)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(9)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(8)); pparg4=(hugs_whnfHead==hugs->nameTrue);
    	hugs->eval(hugs_primArg(7)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg6=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg7=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg8=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg9=hugs_whnfInt;
    {
    	XGrabButton(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6,pparg7,pparg8,pparg9);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XUngrabButton);
primFun(XS_XUngrabButton) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	Int 	pparg2;
    	Word32 pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	XUngrabButton(pparg0,pparg1,pparg2,pparg3);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGrabPointer);
primFun(XS_XGrabPointer) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Bool 	pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	Int 	pparg5;
    	Word32 pparg6;
    	Word32 pparg7;
    	Int 	pparg8;
    	hugs->eval(hugs_primArg(11)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(10)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(9)); pparg2=(hugs_whnfHead==hugs->nameTrue);
    	hugs->eval(hugs_primArg(8)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg6=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg7=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg8=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = XGrabPointer(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6,pparg7,pparg8);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XUngrabPointer);
primFun(XS_XUngrabPointer) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XUngrabPointer(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGrabKey);
primFun(XS_XGrabKey) {
    {
    	Display     *pparg0;
    	char 	pparg1;
    	Int 	pparg2;
    	Word32 pparg3;
    	Bool 	pparg4;
    	Int 	pparg5;
    	Int 	pparg6;
    	hugs->eval(hugs_primArg(9)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(8)); pparg1=hugs->CharOf(hugs_whnfHead);
    	hugs->eval(hugs_primArg(7)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg4=(hugs_whnfHead==hugs->nameTrue);
    	hugs->eval(hugs_primArg(4)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg6=hugs_whnfInt;
    {
    	XGrabKey(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XUngrabKey);
primFun(XS_XUngrabKey) {
    {
    	Display     *pparg0;
    	char 	pparg1;
    	Int 	pparg2;
    	Word32 pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs->CharOf(hugs_whnfHead);
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	XUngrabKey(pparg0,pparg1,pparg2,pparg3);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGrabKeyboard);
primFun(XS_XGrabKeyboard) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Bool 	pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	Int 	pparg5;
    	hugs->eval(hugs_primArg(8)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(7)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg2=(hugs_whnfHead==hugs->nameTrue);
    	hugs->eval(hugs_primArg(5)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg5=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = XGrabKeyboard(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XUngrabKeyboard);
primFun(XS_XUngrabKeyboard) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XUngrabKeyboard(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGrabServer);
primFun(XS_XGrabServer) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XGrabServer(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XUngrabServer);
primFun(XS_XUngrabServer) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XUngrabServer(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XQueryBestTile);
primFun(XS_XQueryBestTile) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word pparg2;
    	Word pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	Word ppret0;
    	Word ppret1;
    	Status pperr;
    	pperr = XQueryBestTile(pparg0,pparg1,pparg2,pparg3,&ppret0,&ppret1);
    	if ((Success != (pperr))) {hugs_push(XSname_BadStatus); hugsINT(pperr);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT(ppret0); hugsTUPLE(2); hugsAP; hugsINT(ppret1); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XQueryBestStipple);
primFun(XS_XQueryBestStipple) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word pparg2;
    	Word pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	Word ppret0;
    	Word ppret1;
    	Status pperr;
    	pperr = XQueryBestStipple(pparg0,pparg1,pparg2,pparg3,&ppret0,&ppret1);
    	if ((Success != (pperr))) {hugs_push(XSname_BadStatus); hugsINT(pperr);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT(ppret0); hugsTUPLE(2); hugsAP; hugsINT(ppret1); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XQueryBestCursor);
primFun(XS_XQueryBestCursor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word pparg2;
    	Word pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	Word ppret0;
    	Word ppret1;
    	Status pperr;
    	pperr = XQueryBestCursor(pparg0,pparg1,pparg2,pparg3,&ppret0,&ppret1);
    	if ((Success != (pperr))) {hugs_push(XSname_BadStatus); hugsINT(pperr);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT(ppret0); hugsTUPLE(2); hugsAP; hugsINT(ppret1); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XQueryBestSize);
primFun(XS_XQueryBestSize) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	Word pparg3;
    	Word pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg4=hugs_whnfInt;
    {
    	Word ppret0;
    	Word ppret1;
    	Status pperr;
    	pperr = XQueryBestSize(pparg0,pparg1,pparg2,pparg3,pparg4,&ppret0,&ppret1);
    	if ((Success != (pperr))) {hugs_push(XSname_BadStatus); hugsINT(pperr);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT(ppret0); hugsTUPLE(2); hugsAP; hugsINT(ppret1); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XQueryPointer);
primFun(XS_XQueryPointer) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	Bool 	ppret0;
    	Word32 ppret1;
    	Word32 ppret2;
    	Int 	ppret3;
    	Int 	ppret4;
    	Int 	ppret5;
    	Int 	ppret6;
    	Int 	ppret7;
    	ppret0 = XQueryPointer(pparg0,pparg1,&ppret1,&ppret2,&ppret3,&ppret4,&ppret5,&ppret6,&ppret7);
    	if (ppret0) {hugsTRUE;} else {hugsFALSE;} hugsTUPLE(8); hugsAP; hugsINT(ppret1); hugsRAP; hugsINT(ppret2); hugsRAP; hugsINT(ppret3); hugsRAP; hugsINT(ppret4); hugsRAP; hugsINT(ppret5); hugsRAP; hugsINT(ppret6); hugsRAP; hugsINT(ppret7); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDisplayName);
primFun(XS_XDisplayName) {
    {
    	int pparg0_size; char* pparg0;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(1));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg0_size = ppindex; pparg0 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg0) { hugs_cantReduce(); } pparg0[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg0[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	int ppret0_size; char* ppret0;
    	ppret0 = XDisplayName(pparg0);
    	XSpack_String(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XEnableAccessControl);
primFun(XS_XEnableAccessControl) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XEnableAccessControl(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDisableAccessControl);
primFun(XS_XDisableAccessControl) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XDisableAccessControl(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetAccessControl);
primFun(XS_XSetAccessControl) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XSetAccessControl(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}
typedef Int QueuedMode;
typedef XEvent* XEventPtr;

PROTO_PRIM(XS_get_XEventPtr);
primFun(XS_get_XEventPtr) {
    XEventPtr p;
    hugs->eval(hugs_primArg(3)); p=(Ptr)hugs_whnfPtr;
    hugsINT((*p).type); hugsSUCC; hugsUPDAPROOT;; return;
    
    {
    }
}

PROTO_PRIM(XS_set_XEventPtr);
primFun(XS_set_XEventPtr) {
    XEvent* p;
    hugs->eval(hugs_primArg(4)); p=(Ptr)hugs_whnfPtr;
    hugs->eval(hugs_primArg(3));
hugs->eval(hugs_pop()); (*p).type=hugs_whnfInt;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    
    {
    }
}
typedef XKeyEvent* XKeyEventPtr;

PROTO_PRIM(XS_get_XKeyEventPtr);
primFun(XS_get_XKeyEventPtr) {
    XKeyEventPtr p;
    hugs->eval(hugs_primArg(3)); p=(Ptr)hugs_whnfPtr;
    hugsINT((*p).root); hugsTUPLE(10); hugsAP; hugsINT((*p).subwindow); hugsRAP; hugsINT((*p).time); hugsRAP; hugsINT((*p).x); hugsRAP; hugsINT((*p).y); hugsRAP; hugsINT((*p).x_root); hugsRAP; hugsINT((*p).y_root); hugsRAP; hugsINT((*p).state); hugsRAP; hugsCHAR((*p).keycode); hugsRAP; if ((*p).same_screen) {hugsTRUE;} else {hugsFALSE;} hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    
    {
    }
}

PROTO_PRIM(XS_set_XKeyEventPtr);
primFun(XS_set_XKeyEventPtr) {
    XKeyEvent* p;
    hugs->eval(hugs_primArg(4)); p=(Ptr)hugs_whnfPtr;
    hugs->eval(hugs_primArg(3));
hugs->eval(hugs_pop()); (*p).root=hugs_whnfInt;
hugs->eval(hugs_pop()); (*p).subwindow=hugs_whnfInt;
hugs->eval(hugs_pop()); (*p).time=hugs_whnfInt;
hugs->eval(hugs_pop()); (*p).x=hugs_whnfInt;
hugs->eval(hugs_pop()); (*p).y=hugs_whnfInt;
hugs->eval(hugs_pop()); (*p).x_root=hugs_whnfInt;
hugs->eval(hugs_pop()); (*p).y_root=hugs_whnfInt;
hugs->eval(hugs_pop()); (*p).state=hugs_whnfInt;
hugs->eval(hugs_pop()); (*p).keycode=hugs->CharOf(hugs_whnfHead);
hugs->eval(hugs_pop()); (*p).same_screen=(hugs_whnfHead==hugs->nameTrue);
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    
    {
    }
}

PROTO_PRIM(XS_XFlush);
primFun(XS_XFlush) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XFlush(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSync);
primFun(XS_XSync) {
    {
    	Display     *pparg0;
    	Bool 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=(hugs_whnfHead==hugs->nameTrue);
    {
    	XSync(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XPending);
primFun(XS_XPending) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XPending(pparg0);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XEventsQueued);
primFun(XS_XEventsQueued) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	Int 	ppret0;
    	ppret0 = XEventsQueued(pparg0,pparg1);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XNextEvent);
primFun(XS_XNextEvent) {
    {
    	Display     *pparg0;
    	XEventPtr pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=(Ptr)hugs_whnfPtr;
    {
    	XNextEvent(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XAllowEvents);
primFun(XS_XAllowEvents) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	Int 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XAllowEvents(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSelectInput);
primFun(XS_XSelectInput) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSelectInput(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSendEvent);
primFun(XS_XSendEvent) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Bool 	pparg2;
    	Int 	pparg3;
    	XEventPtr pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg2=(hugs_whnfHead==hugs->nameTrue);
    	hugs->eval(hugs_primArg(4)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg4=(Ptr)hugs_whnfPtr;
    {
    	Status pperr;
    	pperr = XSendEvent(pparg0,pparg1,pparg2,pparg3,pparg4);
    	if ((Success != (pperr))) {hugs_push(XSname_BadStatus); hugsINT(pperr);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XWindowEvent);
primFun(XS_XWindowEvent) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	XEventPtr pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=(Ptr)hugs_whnfPtr;
    {
    	XWindowEvent(pparg0,pparg1,pparg2,pparg3);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCheckWindowEvent);
primFun(XS_XCheckWindowEvent) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	XEventPtr pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=(Ptr)hugs_whnfPtr;
    {
    	Bool 	ppret0;
    	ppret0 = XCheckWindowEvent(pparg0,pparg1,pparg2,pparg3);
    	if (ppret0) {hugsTRUE;} else {hugsFALSE;} hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XMaskEvent);
primFun(XS_XMaskEvent) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	XEventPtr pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=(Ptr)hugs_whnfPtr;
    {
    	XMaskEvent(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCheckMaskEvent);
primFun(XS_XCheckMaskEvent) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	XEventPtr pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=(Ptr)hugs_whnfPtr;
    {
    	Bool 	ppret0;
    	ppret0 = XCheckMaskEvent(pparg0,pparg1,pparg2);
    	if (ppret0) {hugsTRUE;} else {hugsFALSE;} hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCheckTypedEvent);
primFun(XS_XCheckTypedEvent) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	XEventPtr pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=(Ptr)hugs_whnfPtr;
    {
    	Bool 	ppret0;
    	ppret0 = XCheckTypedEvent(pparg0,pparg1,pparg2);
    	if (ppret0) {hugsTRUE;} else {hugsFALSE;} hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCheckTypedWindowEvent);
primFun(XS_XCheckTypedWindowEvent) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	XEventPtr pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=(Ptr)hugs_whnfPtr;
    {
    	Bool 	ppret0;
    	ppret0 = XCheckTypedWindowEvent(pparg0,pparg1,pparg2,pparg3);
    	if (ppret0) {hugsTRUE;} else {hugsFALSE;} hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XPutBackEvent);
primFun(XS_XPutBackEvent) {
    {
    	Display     *pparg0;
    	XEventPtr pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=(Ptr)hugs_whnfPtr;
    {
    	XPutBackEvent(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XPeekEvent);
primFun(XS_XPeekEvent) {
    {
    	Display     *pparg0;
    	XEventPtr pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=(Ptr)hugs_whnfPtr;
    {
    	XPeekEvent(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XRefreshKeyboardMapping);
primFun(XS_XRefreshKeyboardMapping) {
    {
    	XMappingEvent pparg0;
    	hugs->eval(hugs_primArg(3));
hugs->eval(hugs_pop()); (pparg0).request=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg0).first_keycode=hugs->CharOf(hugs_whnfHead);
hugs->eval(hugs_pop()); (pparg0).count=hugs_whnfInt;
    {
    	XRefreshKeyboardMapping(&pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGeometry);
primFun(XS_XGeometry) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	int pparg2_size; char* pparg2;
    	int pparg3_size; char* pparg3;
    	Word pparg4;
    	Word pparg5;
    	Word pparg6;
    	Int 	pparg7;
    	Int 	pparg8;
    	hugs->eval(hugs_primArg(11)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(10)); pparg1=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(9));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg2_size = ppindex; pparg2 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg2) { hugs_cantReduce(); } pparg2[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg2[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(8));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg3_size = ppindex; pparg3 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg3) { hugs_cantReduce(); } pparg3[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg3[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    	hugs->eval(hugs_primArg(7)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg6=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg7=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg8=hugs_whnfInt;
    {
    	Int 	ppret0;
    	Int 	ppret1;
    	Int 	ppret2;
    	Word ppret3;
    	Word ppret4;
    	ppret0 = XGeometry(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6,pparg7,pparg8,&ppret1,&ppret2,&ppret3,&ppret4);
    	hugsINT(ppret0); hugsTUPLE(5); hugsAP; hugsINT(ppret1); hugsRAP; hugsINT(ppret2); hugsRAP; hugsINT(ppret3); hugsRAP; hugsINT(ppret4); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGetGeometry);
primFun(XS_XGetGeometry) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	Word32 ppret0;
    	Int 	ppret1;
    	Int 	ppret2;
    	Word ppret3;
    	Word ppret4;
    	Word ppret5;
    	Int 	ppret6;
    	Status pperr;
    	pperr = XGetGeometry(pparg0,pparg1,&ppret0,&ppret1,&ppret2,&ppret3,&ppret4,&ppret5,&ppret6);
    	if ((Success != (pperr))) {hugs_push(XSname_BadStatus); hugsINT(pperr);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT(ppret0); hugsTUPLE(7); hugsAP; hugsINT(ppret1); hugsRAP; hugsINT(ppret2); hugsRAP; hugsINT(ppret3); hugsRAP; hugsINT(ppret4); hugsRAP; hugsINT(ppret5); hugsRAP; hugsINT(ppret6); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSupportsLocale);
primFun(XS_XSupportsLocale) {
    {
    {
    	Bool 	ppret0;
    	ppret0 = XSupportsLocale();
    	if (ppret0) {hugsTRUE;} else {hugsFALSE;} hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetLocaleModifiers);
primFun(XS_XSetLocaleModifiers) {
    {
    	int pparg0_size; char* pparg0;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg0_size = ppindex; pparg0 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg0) { hugs_cantReduce(); } pparg0[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg0[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	int ppret0_size; char* ppret0;
    	ppret0 = XSetLocaleModifiers(pparg0);
    	XSpack_String(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}
typedef Int AllowExposuresMode;
typedef Int PreferBlankingMode;
typedef Int ScreenSaverMode;

PROTO_PRIM(XS_XGetScreenSaver);
primFun(XS_XGetScreenSaver) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	Int 	ppret1;
    	Int 	ppret2;
    	Int 	ppret3;
    	XGetScreenSaver(pparg0,&ppret0,&ppret1,&ppret2,&ppret3);
    	hugsINT(ppret0); hugsTUPLE(4); hugsAP; hugsINT(ppret1); hugsRAP; hugsINT(ppret2); hugsRAP; hugsINT(ppret3); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetScreenSaver);
primFun(XS_XSetScreenSaver) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	Int 	pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg4=hugs_whnfInt;
    {
    	XSetScreenSaver(pparg0,pparg1,pparg2,pparg3,pparg4);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XActivateScreenSaver);
primFun(XS_XActivateScreenSaver) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XActivateScreenSaver(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XResetScreenSaver);
primFun(XS_XResetScreenSaver) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	XResetScreenSaver(pparg0);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XForceScreenSaver);
primFun(XS_XForceScreenSaver) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XForceScreenSaver(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGetPointerControl);
primFun(XS_XGetPointerControl) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(3)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	Int 	ppret1;
    	Int 	ppret2;
    	XGetPointerControl(pparg0,&ppret0,&ppret1,&ppret2);
    	hugsINT(ppret0); hugsTUPLE(3); hugsAP; hugsINT(ppret1); hugsRAP; hugsINT(ppret2); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XWarpPointer);
primFun(XS_XWarpPointer) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	Word pparg5;
    	Word pparg6;
    	Int 	pparg7;
    	Int 	pparg8;
    	hugs->eval(hugs_primArg(11)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(10)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(9)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(8)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg6=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg7=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg8=hugs_whnfInt;
    {
    	XWarpPointer(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6,pparg7,pparg8);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XBlackPixelOfScreen);
primFun(XS_XBlackPixelOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word32 ppret0;
    	ppret0 = XBlackPixelOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XWhitePixelOfScreen);
primFun(XS_XWhitePixelOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word32 ppret0;
    	ppret0 = XWhitePixelOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCellsOfScreen);
primFun(XS_XCellsOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XCellsOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultColormapOfScreen);
primFun(XS_XDefaultColormapOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word32 ppret0;
    	ppret0 = XDefaultColormapOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultDepthOfScreen);
primFun(XS_XDefaultDepthOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XDefaultDepthOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultGCOfScreen);
primFun(XS_XDefaultGCOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Ptr ppret0;
    	ppret0 = XDefaultGCOfScreen(pparg0);
    	mkPtr((Ptr)ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefaultVisualOfScreen);
primFun(XS_XDefaultVisualOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Visual      *ppret0;
    	ppret0 = XDefaultVisualOfScreen(pparg0);
    	mkPtr((Ptr)ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDoesBackingStore);
primFun(XS_XDoesBackingStore) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Bool 	ppret0;
    	ppret0 = XDoesBackingStore(pparg0);
    	if (ppret0) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDoesSaveUnders);
primFun(XS_XDoesSaveUnders) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Bool 	ppret0;
    	ppret0 = XDoesSaveUnders(pparg0);
    	if (ppret0) {hugsTRUE;} else {hugsFALSE;} hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_DisplayOfScreen);
primFun(XS_DisplayOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Display     *ppret0;
    	ppret0 = DisplayOfScreen(pparg0);
    	mkPtr((Ptr)ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XEventMaskOfScreen);
primFun(XS_XEventMaskOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XEventMaskOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XMinCmapsOfScreen);
primFun(XS_XMinCmapsOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XMinCmapsOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XMaxCmapsOfScreen);
primFun(XS_XMaxCmapsOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XMaxCmapsOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XRootWindowOfScreen);
primFun(XS_XRootWindowOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word32 ppret0;
    	ppret0 = XRootWindowOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XWidthOfScreen);
primFun(XS_XWidthOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word ppret0;
    	ppret0 = XWidthOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XWidthMMOfScreen);
primFun(XS_XWidthMMOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word ppret0;
    	ppret0 = XWidthMMOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XHeightOfScreen);
primFun(XS_XHeightOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word ppret0;
    	ppret0 = XHeightOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XHeightMMOfScreen);
primFun(XS_XHeightMMOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word ppret0;
    	ppret0 = XHeightMMOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XPlanesOfScreen);
primFun(XS_XPlanesOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XPlanesOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XScreenNumberOfScreen);
primFun(XS_XScreenNumberOfScreen) {
    {
    	Screen      *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Word32 ppret0;
    	ppret0 = XScreenNumberOfScreen(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}
typedef Int ArcMode;
typedef Int SubWindowMode;
typedef Int LineStyle;
typedef Int CapStyle;
typedef Int JoinStyle;
typedef Int FillStyle;
typedef Int FillRule;
typedef Int GXFunction;

PROTO_PRIM(XS_XSetArcMode);
primFun(XS_XSetArcMode) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Int 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetArcMode(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetBackground);
primFun(XS_XSetBackground) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetBackground(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetForeground);
primFun(XS_XSetForeground) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetForeground(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetFunction);
primFun(XS_XSetFunction) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Int 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetFunction(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetGraphicsExposures);
primFun(XS_XSetGraphicsExposures) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Bool 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=(hugs_whnfHead==hugs->nameTrue);
    {
    	XSetGraphicsExposures(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetClipMask);
primFun(XS_XSetClipMask) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetClipMask(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetClipOrigin);
primFun(XS_XSetClipOrigin) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Int 	pparg2;
    	Int 	pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	XSetClipOrigin(pparg0,pparg1,pparg2,pparg3);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetDashes);
primFun(XS_XSetDashes) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Int 	pparg2;
    	int pparg3_size; char* pparg3;
    	Int 	pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg2=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(4));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg3_size = ppindex; pparg3 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg3) { hugs_cantReduce(); } pparg3[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg3[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    	hugs->eval(hugs_primArg(3)); pparg4=hugs_whnfInt;
    {
    	XSetDashes(pparg0,pparg1,pparg2,pparg3,pparg4);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetFillRule);
primFun(XS_XSetFillRule) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Int 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetFillRule(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetFillStyle);
primFun(XS_XSetFillStyle) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Int 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetFillStyle(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetFont);
primFun(XS_XSetFont) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetFont(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetLineAttributes);
primFun(XS_XSetLineAttributes) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Int 	pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	Int 	pparg5;
    	hugs->eval(hugs_primArg(8)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(7)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg5=hugs_whnfInt;
    {
    	XSetLineAttributes(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetPlaneMask);
primFun(XS_XSetPlaneMask) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetPlaneMask(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetState);
primFun(XS_XSetState) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Word32 pparg2;
    	Word32 pparg3;
    	Int 	pparg4;
    	Word32 pparg5;
    	hugs->eval(hugs_primArg(8)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(7)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg5=hugs_whnfInt;
    {
    	XSetState(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetStipple);
primFun(XS_XSetStipple) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetStipple(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetSubwindowMode);
primFun(XS_XSetSubwindowMode) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Int 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetSubwindowMode(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetTSOrigin);
primFun(XS_XSetTSOrigin) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Int 	pparg2;
    	Int 	pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	XSetTSOrigin(pparg0,pparg1,pparg2,pparg3);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetTile);
primFun(XS_XSetTile) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetTile(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCreateGC);
primFun(XS_XCreateGC) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    GC gc = XCreateGC(pparg0,pparg1,0,0);
    mkPtr((Ptr)gc); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFreeGC);
primFun(XS_XFreeGC) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=(Ptr)hugs_whnfPtr;
    {
    	XFreeGC(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFlushGC);
primFun(XS_XFlushGC) {
    {
    	Display     *pparg0;
    	Ptr pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=(Ptr)hugs_whnfPtr;
    {
    	XFlushGC(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCreatePixmap);
primFun(XS_XCreatePixmap) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word pparg2;
    	Word pparg3;
    	Int 	pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg4=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XCreatePixmap(pparg0,pparg1,pparg2,pparg3,pparg4);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFreePixmap);
primFun(XS_XFreePixmap) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XFreePixmap(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XBitmapBitOrder);
primFun(XS_XBitmapBitOrder) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XBitmapBitOrder(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XBitmapUnit);
primFun(XS_XBitmapUnit) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XBitmapUnit(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XBitmapPad);
primFun(XS_XBitmapPad) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	ppret0 = XBitmapPad(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XLookupColor);
primFun(XS_XLookupColor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	int pparg2_size; char* pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg2_size = ppindex; pparg2 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg2) { hugs_cantReduce(); } pparg2[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg2[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	XColor ppret0;
    	XColor ppret1;
    	Status pperr;
    	pperr = XLookupColor(pparg0,pparg1,pparg2,&ppret0,&ppret1);
    	if (!(pperr)) {hugs_push(XSname_Zero);; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT((ppret0).pixel); hugsTUPLE(5); hugsAP; hugsINT((ppret0).red); hugsRAP; hugsINT((ppret0).green); hugsRAP; hugsINT((ppret0).blue); hugsRAP; hugsINT((ppret0).flags); hugsRAP; hugsTUPLE(2); hugsAP; hugsINT((ppret1).pixel); hugsTUPLE(5); hugsAP; hugsINT((ppret1).red); hugsRAP; hugsINT((ppret1).green); hugsRAP; hugsINT((ppret1).blue); hugsRAP; hugsINT((ppret1).flags); hugsRAP; hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XAllocNamedColor);
primFun(XS_XAllocNamedColor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	int pparg2_size; char* pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg2_size = ppindex; pparg2 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg2) { hugs_cantReduce(); } pparg2[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg2[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	XColor ppret0;
    	XColor ppret1;
    	Status pperr;
    	pperr = XAllocNamedColor(pparg0,pparg1,pparg2,&ppret0,&ppret1);
    	if (!(pperr)) {hugs_push(XSname_Zero);; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT((ppret0).pixel); hugsTUPLE(5); hugsAP; hugsINT((ppret0).red); hugsRAP; hugsINT((ppret0).green); hugsRAP; hugsINT((ppret0).blue); hugsRAP; hugsINT((ppret0).flags); hugsRAP; hugsTUPLE(2); hugsAP; hugsINT((ppret1).pixel); hugsTUPLE(5); hugsAP; hugsINT((ppret1).red); hugsRAP; hugsINT((ppret1).green); hugsRAP; hugsINT((ppret1).blue); hugsRAP; hugsINT((ppret1).flags); hugsRAP; hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XAllocColor);
primFun(XS_XAllocColor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	XColor pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3));
hugs->eval(hugs_pop()); (pparg2).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).flags=hugs_whnfInt;
    {
    	Status pperr;
    	pperr = XAllocColor(pparg0,pparg1,&pparg2) ;
    	if (!(pperr)) {hugs_push(XSname_Zero);; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT((pparg2).pixel); hugsTUPLE(5); hugsAP; hugsINT((pparg2).red); hugsRAP; hugsINT((pparg2).green); hugsRAP; hugsINT((pparg2).blue); hugsRAP; hugsINT((pparg2).flags); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XParseColor);
primFun(XS_XParseColor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	int pparg2_size; char* pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg2_size = ppindex; pparg2 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg2) { hugs_cantReduce(); } pparg2[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg2[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	XColor ppret0;
    	Status pperr;
    	pperr = XParseColor(pparg0,pparg1,pparg2,&ppret0);
    	if (!(pperr)) {hugs_push(XSname_Zero);; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT((ppret0).pixel); hugsTUPLE(5); hugsAP; hugsINT((ppret0).red); hugsRAP; hugsINT((ppret0).green); hugsRAP; hugsINT((ppret0).blue); hugsRAP; hugsINT((ppret0).flags); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFreeColors);
primFun(XS_XFreeColors) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	int pparg2_size; Pixel* pparg2;
    	Word32 pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(4));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg2_size = ppindex; pparg2 = (Pixel *) alloca(ppindex * sizeof(Pixel)); if (!pparg2) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg2[ppindex]=hugs_whnfInt;
	    }
	};
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	XFreeColors(pparg0,pparg1,pparg2,pparg2_size,pparg3);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XStoreColor);
primFun(XS_XStoreColor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	XColor pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3));
hugs->eval(hugs_pop()); (pparg2).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).flags=hugs_whnfInt;
    {
    	XStoreColor(pparg0,pparg1,&pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XStoreColors);
primFun(XS_XStoreColors) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	int pparg2_size; XColor* pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg2_size = ppindex; pparg2 = (XColor *) alloca(ppindex * sizeof(XColor)); if (!pparg2) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop());
hugs->eval(hugs_pop()); (pparg2[ppindex]).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2[ppindex]).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2[ppindex]).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2[ppindex]).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2[ppindex]).flags=hugs_whnfInt;
	    }
	};
    {
    	XStoreColors(pparg0,pparg1,pparg2,pparg2_size);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XStoreNamedColor);
primFun(XS_XStoreNamedColor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	int pparg2_size; char* pparg2;
    	Word32 pparg3;
    	Int 	pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(5));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg2_size = ppindex; pparg2 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg2) { hugs_cantReduce(); } pparg2[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg2[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    	hugs->eval(hugs_primArg(4)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg4=hugs_whnfInt;
    {
    	XStoreNamedColor(pparg0,pparg1,pparg2,pparg3,pparg4);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XQueryColor);
primFun(XS_XQueryColor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	XColor pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3));
hugs->eval(hugs_pop()); (pparg2).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).flags=hugs_whnfInt;
    {
    	XQueryColor(pparg0,pparg1,&pparg2);
    	hugsINT((pparg2).pixel); hugsTUPLE(5); hugsAP; hugsINT((pparg2).red); hugsRAP; hugsINT((pparg2).green); hugsRAP; hugsINT((pparg2).blue); hugsRAP; hugsINT((pparg2).flags); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XQueryColors);
primFun(XS_XQueryColors) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	int pparg2_size; XColor* pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg2_size = ppindex; pparg2 = (XColor *) alloca(ppindex * sizeof(XColor)); if (!pparg2) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop());
hugs->eval(hugs_pop()); (pparg2[ppindex]).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2[ppindex]).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2[ppindex]).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2[ppindex]).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2[ppindex]).flags=hugs_whnfInt;
	    }
	};
    {
    	XQueryColors(pparg0,pparg1,pparg2,pparg2_size) ;
    	XSpack_ListXColor(pparg2,pparg2_size); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XInstallColormap);
primFun(XS_XInstallColormap) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XInstallColormap(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XUninstallColormap);
primFun(XS_XUninstallColormap) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XUninstallColormap(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCopyColormapAndFree);
primFun(XS_XCopyColormapAndFree) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XCopyColormapAndFree(pparg0,pparg1);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCreateColormap);
primFun(XS_XCreateColormap) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Visual      *pparg2;
    	Int 	pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XCreateColormap(pparg0,pparg1,pparg2,pparg3);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFreeColormap);
primFun(XS_XFreeColormap) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XFreeColormap(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}
typedef Int Glyph;

PROTO_PRIM(XS_XQueryFont);
primFun(XS_XQueryFont) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XFontStruct *ppret0;
    	ppret0 = XQueryFont(pparg0,pparg1);
    	mkPtr((Ptr)ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XLoadQueryFont);
primFun(XS_XLoadQueryFont) {
    {
    	Display     *pparg0;
    	int pparg1_size; char* pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg1_size = ppindex; pparg1 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg1) { hugs_cantReduce(); } pparg1[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg1[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	XFontStruct *ppret0;
    	ppret0 = XLoadQueryFont(pparg0,pparg1);
    	mkPtr((Ptr)ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFreeFont);
primFun(XS_XFreeFont) {
    {
    	Display     *pparg0;
    	XFontStruct *pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=(Ptr)hugs_whnfPtr;
    {
    	XFreeFont(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDisplayKeycodes);
primFun(XS_XDisplayKeycodes) {
    {
    	Display     *pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=(Ptr)hugs_whnfPtr;
    {
    	Int 	ppret0;
    	Int 	ppret1;
    	XDisplayKeycodes(pparg0,&ppret0,&ppret1);
    	hugsINT(ppret0); hugsTUPLE(2); hugsAP; hugsINT(ppret1); hugsRUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XLookupKeysym);
primFun(XS_XLookupKeysym) {
    {
    	XKeyEventPtr pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XLookupKeysym(pparg0,pparg1);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XKeycodeToKeysym);
primFun(XS_XKeycodeToKeysym) {
    {
    	Display     *pparg0;
    	char 	pparg1;
    	Int 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs->CharOf(hugs_whnfHead);
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XKeycodeToKeysym(pparg0,pparg1,pparg2);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XKeysymToKeycode);
primFun(XS_XKeysymToKeycode) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	char 	ppret0;
    	ppret0 = XKeysymToKeycode(pparg0,pparg1);
    	hugsCHAR(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XKeysymToString);
primFun(XS_XKeysymToString) {
    {
    	Word32 pparg0;
    	hugs->eval(hugs_primArg(1)); pparg0=hugs_whnfInt;
    {
    	int ppret0_size; char* ppret0;
    	ppret0 = XKeysymToString(pparg0);
    	XSpack_String(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XStringToKeysym);
primFun(XS_XStringToKeysym) {
    {
    	int pparg0_size; char* pparg0;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(1));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg0_size = ppindex; pparg0 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg0) { hugs_cantReduce(); } pparg0[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg0[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	Word32 ppret0;
    	ppret0 = XStringToKeysym(pparg0);
    	hugsINT(ppret0); hugsUPDATEROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGetIconName);
primFun(XS_XGetIconName) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	int ppret0_size; char* ppret0;
    	Status pperr;
    	pperr = XGetIconName(pparg0,pparg1,&ppret0);
    	if ((Success != (pperr))) {hugs_push(XSname_BadStatus); hugsINT(pperr);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} XSpack_String(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetIconName);
primFun(XS_XSetIconName) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	int pparg2_size; char* pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg2_size = ppindex; pparg2 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg2) { hugs_cantReduce(); } pparg2[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg2[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	XSetIconName(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDefineCursor);
primFun(XS_XDefineCursor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XDefineCursor(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XUndefineCursor);
primFun(XS_XUndefineCursor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XUndefineCursor(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCreatePixmapCursor);
primFun(XS_XCreatePixmapCursor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	XColor pparg3;
    	XColor pparg4;
    	Word pparg5;
    	Word pparg6;
    	hugs->eval(hugs_primArg(9)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(8)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6));
hugs->eval(hugs_pop()); (pparg3).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3).flags=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5));
hugs->eval(hugs_pop()); (pparg4).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg4).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg4).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg4).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg4).flags=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg6=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XCreatePixmapCursor(pparg0,pparg1,pparg2,&pparg3,&pparg4,pparg5,pparg6);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCreateGlyphCursor);
primFun(XS_XCreateGlyphCursor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	XColor pparg5;
    	XColor pparg6;
    	hugs->eval(hugs_primArg(9)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(8)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4));
hugs->eval(hugs_pop()); (pparg5).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg5).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg5).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg5).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg5).flags=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3));
hugs->eval(hugs_pop()); (pparg6).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg6).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg6).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg6).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg6).flags=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XCreateGlyphCursor(pparg0,pparg1,pparg2,pparg3,pparg4,&pparg5,&pparg6);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCreateFontCursor);
primFun(XS_XCreateFontCursor) {
    {
    	Display     *pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XCreateFontCursor(pparg0,pparg1);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFreeCursor);
primFun(XS_XFreeCursor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XFreeCursor(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XRecolorCursor);
primFun(XS_XRecolorCursor) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	XColor pparg2;
    	XColor pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4));
hugs->eval(hugs_pop()); (pparg2).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg2).flags=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3));
hugs->eval(hugs_pop()); (pparg3).pixel=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3).red=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3).green=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3).blue=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3).flags=hugs_whnfInt;
    {
    	XRecolorCursor(pparg0,pparg1,&pparg2,&pparg3);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_background_pixmap);
primFun(XS_set_background_pixmap) {
    {
    	XSetWindowAttributes* pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->background_pixmap = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_background_pixel);
primFun(XS_set_background_pixel) {
    {
    	XSetWindowAttributes* pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->background_pixel = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_border_pixmap);
primFun(XS_set_border_pixmap) {
    {
    	XSetWindowAttributes* pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->border_pixmap = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_border_pixmel);
primFun(XS_set_border_pixmel) {
    {
    	XSetWindowAttributes* pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->border_pixel = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_bit_gravity);
primFun(XS_set_bit_gravity) {
    {
    	XSetWindowAttributes* pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->bit_gravity = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_win_gravity);
primFun(XS_set_win_gravity) {
    {
    	XSetWindowAttributes* pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->win_gravity = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_backing_store);
primFun(XS_set_backing_store) {
    {
    	XSetWindowAttributes* pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->win_gravity = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_backing_planes);
primFun(XS_set_backing_planes) {
    {
    	XSetWindowAttributes* pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->backing_planes = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_backing_pixel);
primFun(XS_set_backing_pixel) {
    {
    	XSetWindowAttributes* pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->backing_pixel = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_save_under);
primFun(XS_set_save_under) {
    {
    	XSetWindowAttributes* pparg0;
    	Bool 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=(hugs_whnfHead==hugs->nameTrue);
    {
    pparg0->save_under = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_event_mask);
primFun(XS_set_event_mask) {
    {
    	XSetWindowAttributes* pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->event_mask = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_do_not_propagate_mask);
primFun(XS_set_do_not_propagate_mask) {
    {
    	XSetWindowAttributes* pparg0;
    	Int 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->do_not_propagate_mask = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_overide_redirect);
primFun(XS_set_overide_redirect) {
    {
    	XSetWindowAttributes* pparg0;
    	Bool 	pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=(hugs_whnfHead==hugs->nameTrue);
    {
    pparg0->override_redirect = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_colormap);
primFun(XS_set_colormap) {
    {
    	XSetWindowAttributes* pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->colormap = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_set_cursor);
primFun(XS_set_cursor) {
    {
    	XSetWindowAttributes* pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    pparg0->cursor = pparg1;
    hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XStoreName);
primFun(XS_XStoreName) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	int pparg2_size; char* pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg2_size = ppindex; pparg2 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg2) { hugs_cantReduce(); } pparg2[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg2[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	XStoreName(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCreateSimpleWindow);
primFun(XS_XCreateSimpleWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	Int 	pparg3;
    	Word pparg4;
    	Word pparg5;
    	Int 	pparg6;
    	Word32 pparg7;
    	Word32 pparg8;
    	hugs->eval(hugs_primArg(11)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(10)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(9)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(8)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg6=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg7=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg8=hugs_whnfInt;
    {
    	Word32 ppret0;
    	ppret0 = XCreateSimpleWindow(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6,pparg7,pparg8);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCreateWindow);
primFun(XS_XCreateWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	Int 	pparg3;
    	Word pparg4;
    	Word pparg5;
    	Int 	pparg6;
    	Int 	pparg7;
    	Int 	pparg8;
    	Visual      *pparg9;
    	Int 	pparg10;
    	XSetWindowAttributes* pparg11;
    	hugs->eval(hugs_primArg(14)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(13)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(12)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(11)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(10)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(9)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(8)); pparg6=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg7=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg8=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg9=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg10=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg11=(Ptr)hugs_whnfPtr;
    {
    	Word32 ppret0;
    	ppret0 = XCreateWindow(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6,pparg7,pparg8,pparg9,pparg10,pparg11);
    	hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XTranslateCoordinates);
primFun(XS_XTranslateCoordinates) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg4=hugs_whnfInt;
    {
    	Bool 	ppret0;
    	Int 	ppret1;
    	Int 	ppret2;
    	Word32 ppret3;
    	ppret0 = XTranslateCoordinates(pparg0,pparg1,pparg2,pparg3,pparg4,&ppret1,&ppret2,&ppret3);
    	if (ppret0) {hugsTRUE;} else {hugsFALSE;} hugsTUPLE(4); hugsAP; hugsINT(ppret1); hugsRAP; hugsINT(ppret2); hugsRAP; hugsINT(ppret3); hugsRAP; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XMoveResizeWindow);
primFun(XS_XMoveResizeWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	Int 	pparg3;
    	Word pparg4;
    	Word pparg5;
    	hugs->eval(hugs_primArg(8)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(7)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg5=hugs_whnfInt;
    {
    	XMoveResizeWindow(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XResizeWindow);
primFun(XS_XResizeWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word pparg2;
    	Word pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	XResizeWindow(pparg0,pparg1,pparg2,pparg3);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XMoveWindow);
primFun(XS_XMoveWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	Int 	pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg3=hugs_whnfInt;
    {
    	XMoveWindow(pparg0,pparg1,pparg2,pparg3);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XReparentWindow);
primFun(XS_XReparentWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg4=hugs_whnfInt;
    {
    	XReparentWindow(pparg0,pparg1,pparg2,pparg3,pparg4);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XMapSubwindows);
primFun(XS_XMapSubwindows) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XMapSubwindows(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XUnmapSubwindows);
primFun(XS_XUnmapSubwindows) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XUnmapSubwindows(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XMapWindow);
primFun(XS_XMapWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XMapWindow(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XLowerWindow);
primFun(XS_XLowerWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XLowerWindow(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XRaiseWindow);
primFun(XS_XRaiseWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XRaiseWindow(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCirculateSubwindowsDown);
primFun(XS_XCirculateSubwindowsDown) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XCirculateSubwindowsDown(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCirculateSubwindowsUp);
primFun(XS_XCirculateSubwindowsUp) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XCirculateSubwindowsUp(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCirculateSubwindows);
primFun(XS_XCirculateSubwindows) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XCirculateSubwindows(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XIconifyWindow);
primFun(XS_XIconifyWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	Status pperr;
    	pperr = XIconifyWindow(pparg0,pparg1,pparg2);
    	if ((Success != (pperr))) {hugs_push(XSname_BadStatus); hugsINT(pperr);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XWithdrawWindow);
primFun(XS_XWithdrawWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	Status pperr;
    	pperr = XWithdrawWindow(pparg0,pparg1,pparg2);
    	if ((Success != (pperr))) {hugs_push(XSname_BadStatus); hugsINT(pperr);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDestroyWindow);
primFun(XS_XDestroyWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XDestroyWindow(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDestroySubwindows);
primFun(XS_XDestroySubwindows) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XDestroySubwindows(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetWindowBorder);
primFun(XS_XSetWindowBorder) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetWindowBorder(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetWindowBorderPixmap);
primFun(XS_XSetWindowBorderPixmap) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetWindowBorderPixmap(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetWindowBorderWidth);
primFun(XS_XSetWindowBorderWidth) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetWindowBorderWidth(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetWindowBackground);
primFun(XS_XSetWindowBackground) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetWindowBackground(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetWindowBackgroundPixmap);
primFun(XS_XSetWindowBackgroundPixmap) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetWindowBackgroundPixmap(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetWindowColormap);
primFun(XS_XSetWindowColormap) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetWindowColormap(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XAddToSaveSet);
primFun(XS_XAddToSaveSet) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XAddToSaveSet(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XRemoveFromSaveSet);
primFun(XS_XRemoveFromSaveSet) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XRemoveFromSaveSet(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XChangeSaveSet);
primFun(XS_XChangeSaveSet) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XChangeSaveSet(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XClearWindow);
primFun(XS_XClearWindow) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	XClearWindow(pparg0,pparg1);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XClearArea);
primFun(XS_XClearArea) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Int 	pparg2;
    	Int 	pparg3;
    	Word pparg4;
    	Word pparg5;
    	Bool 	pparg6;
    	hugs->eval(hugs_primArg(9)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(8)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg6=(hugs_whnfHead==hugs->nameTrue);
    {
    	XClearArea(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XQueryTree);
primFun(XS_XQueryTree) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    Window root_w, parent;
    Int children_size;
    Window *children;
    Status r = XQueryTree(pparg0,pparg1,&root_w, &parent, &children, &children_size);
    if (Success != r) { hugs_push(XSname_BadStatus); hugsINT(r);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return; }
    hugsINT(root_w); hugsTUPLE(3); hugsAP; hugsINT(parent); hugsRAP; XSpack_ListWindow(children,children_size); hugsRAP; hugsSUCC; hugsUPDAPROOT;;
    XFree(children);
    return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XRestackWindows);
primFun(XS_XRestackWindows) {
    {
    	Display     *pparg0;
    	int pparg1_size; Window* pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg1_size = ppindex; pparg1 = (Window *) alloca(ppindex * sizeof(Window)); if (!pparg1) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg1[ppindex]=hugs_whnfInt;
	    }
	};
    {
    	XRestackWindows(pparg0, pparg1, pparg1_size);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XListInstalledColormaps);
primFun(XS_XListInstalledColormaps) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    Int r_size;
    Colormap* r = XListInstalledColormaps(pparg0,pparg1,&r_size);
    XSpack_ListColormap(r,r_size); hugsSUCC; hugsUPDAPROOT;;
    XFree(r);
    return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XGetTransientForHint);
primFun(XS_XGetTransientForHint) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	hugs->eval(hugs_primArg(4)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(3)); pparg1=hugs_whnfInt;
    {
    	Word32 ppret0;
    	Status pperr;
    	pperr = XGetTransientForHint(pparg0,pparg1,&ppret0);
    	if ((Success != (pperr))) {hugs_push(XSname_BadStatus); hugsINT(pperr);; hugsRAP;; hugsFAIL; hugsUPDAPROOT;; return;} hugsINT(ppret0); hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XSetTransientForHint);
primFun(XS_XSetTransientForHint) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	hugs->eval(hugs_primArg(5)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg2=hugs_whnfInt;
    {
    	XSetTransientForHint(pparg0,pparg1,pparg2);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawPoint);
primFun(XS_XDrawPoint) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg2=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(4)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg4=hugs_whnfInt;
    {
    	XDrawPoint(pparg0,pparg1,pparg2,pparg3,pparg4);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawPoints);
primFun(XS_XDrawPoints) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	int pparg3_size; XPoint* pparg3;
    	Int 	pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg2=(Ptr)hugs_whnfPtr;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(4));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg3_size = ppindex; pparg3 = (XPoint *) alloca(ppindex * sizeof(XPoint)); if (!pparg3) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop());
hugs->eval(hugs_pop()); (pparg3[ppindex]).x=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).y=hugs_whnfInt;
	    }
	};
    	hugs->eval(hugs_primArg(3)); pparg4=hugs_whnfInt;
    {
    	XDrawPoints(pparg0,pparg1,pparg2,pparg3,pparg3_size,pparg4);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawLine);
primFun(XS_XDrawLine) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	Int 	pparg5;
    	Int 	pparg6;
    	hugs->eval(hugs_primArg(9)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(8)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg2=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg6=hugs_whnfInt;
    {
    	XDrawLine(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawLines);
primFun(XS_XDrawLines) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	int pparg3_size; XPoint* pparg3;
    	Int 	pparg4;
    	hugs->eval(hugs_primArg(7)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg2=(Ptr)hugs_whnfPtr;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(4));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg3_size = ppindex; pparg3 = (XPoint *) alloca(ppindex * sizeof(XPoint)); if (!pparg3) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop());
hugs->eval(hugs_pop()); (pparg3[ppindex]).x=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).y=hugs_whnfInt;
	    }
	};
    	hugs->eval(hugs_primArg(3)); pparg4=hugs_whnfInt;
    {
    	XDrawLines(pparg0,pparg1,pparg2,pparg3,pparg3_size,pparg4);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawSegments);
primFun(XS_XDrawSegments) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	int pparg3_size; XSegment* pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=(Ptr)hugs_whnfPtr;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg3_size = ppindex; pparg3 = (XSegment *) alloca(ppindex * sizeof(XSegment)); if (!pparg3) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop());
hugs->eval(hugs_pop()); (pparg3[ppindex]).x1=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).y1=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).x2=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).y2=hugs_whnfInt;
	    }
	};
    {
    	XDrawSegments(pparg0,pparg1,pparg2,pparg3,pparg3_size);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawRectangle);
primFun(XS_XDrawRectangle) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	Word pparg5;
    	Word pparg6;
    	hugs->eval(hugs_primArg(9)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(8)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg2=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg6=hugs_whnfInt;
    {
    	XDrawRectangle(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawRectangles);
primFun(XS_XDrawRectangles) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	int pparg3_size; XRectangle* pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=(Ptr)hugs_whnfPtr;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg3_size = ppindex; pparg3 = (XRectangle *) alloca(ppindex * sizeof(XRectangle)); if (!pparg3) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop());
hugs->eval(hugs_pop()); (pparg3[ppindex]).x=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).y=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).width=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).height=hugs_whnfInt;
	    }
	};
    {
    	XDrawRectangles(pparg0,pparg1,pparg2,pparg3,pparg3_size);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawArc);
primFun(XS_XDrawArc) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	Word pparg5;
    	Word pparg6;
    	Int 	pparg7;
    	Int 	pparg8;
    	hugs->eval(hugs_primArg(11)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(10)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(9)); pparg2=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(8)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg6=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg7=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg8=hugs_whnfInt;
    {
    	XDrawArc(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6,pparg7,pparg8);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawArcs);
primFun(XS_XDrawArcs) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	int pparg3_size; XArc* pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=(Ptr)hugs_whnfPtr;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg3_size = ppindex; pparg3 = (XArc *) alloca(ppindex * sizeof(XArc)); if (!pparg3) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop());
hugs->eval(hugs_pop()); (pparg3[ppindex]).x=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).y=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).width=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).height=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).angle1=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).angle2=hugs_whnfInt;
	    }
	};
    {
    	XDrawArcs(pparg0,pparg1,pparg2,pparg3,pparg3_size);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFillRectangle);
primFun(XS_XFillRectangle) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	Word pparg5;
    	Word pparg6;
    	hugs->eval(hugs_primArg(9)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(8)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg2=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(6)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg6=hugs_whnfInt;
    {
    	XFillRectangle(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFillRectangles);
primFun(XS_XFillRectangles) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	int pparg3_size; XRectangle* pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=(Ptr)hugs_whnfPtr;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg3_size = ppindex; pparg3 = (XRectangle *) alloca(ppindex * sizeof(XRectangle)); if (!pparg3) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop());
hugs->eval(hugs_pop()); (pparg3[ppindex]).x=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).y=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).width=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).height=hugs_whnfInt;
	    }
	};
    {
    	XFillRectangles(pparg0,pparg1,pparg2,pparg3,pparg3_size);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFillPolygon);
primFun(XS_XFillPolygon) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	int pparg3_size; XPoint* pparg3;
    	Int 	pparg4;
    	Int 	pparg5;
    	hugs->eval(hugs_primArg(8)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(7)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg2=(Ptr)hugs_whnfPtr;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(5));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg3_size = ppindex; pparg3 = (XPoint *) alloca(ppindex * sizeof(XPoint)); if (!pparg3) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop());
hugs->eval(hugs_pop()); (pparg3[ppindex]).x=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).y=hugs_whnfInt;
	    }
	};
    	hugs->eval(hugs_primArg(4)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg5=hugs_whnfInt;
    {
    	XFillPolygon(pparg0,pparg1,pparg2,pparg3,pparg3_size,pparg4,pparg5);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFillArc);
primFun(XS_XFillArc) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	Word pparg5;
    	Word pparg6;
    	Int 	pparg7;
    	Int 	pparg8;
    	hugs->eval(hugs_primArg(11)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(10)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(9)); pparg2=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(8)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg6=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg7=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg8=hugs_whnfInt;
    {
    	XFillArc(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6,pparg7,pparg8);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XFillArcs);
primFun(XS_XFillArcs) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	int pparg3_size; XArc* pparg3;
    	hugs->eval(hugs_primArg(6)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg2=(Ptr)hugs_whnfPtr;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg3_size = ppindex; pparg3 = (XArc *) alloca(ppindex * sizeof(XArc)); if (!pparg3) { hugs_cantReduce(); }
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop());
hugs->eval(hugs_pop()); (pparg3[ppindex]).x=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).y=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).width=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).height=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).angle1=hugs_whnfInt;
hugs->eval(hugs_pop()); (pparg3[ppindex]).angle2=hugs_whnfInt;
	    }
	};
    {
    	XFillArcs(pparg0,pparg1,pparg2,pparg3,pparg3_size);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCopyArea);
primFun(XS_XCopyArea) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	Ptr pparg3;
    	Int 	pparg4;
    	Int 	pparg5;
    	Word pparg6;
    	Word pparg7;
    	Int 	pparg8;
    	Int 	pparg9;
    	hugs->eval(hugs_primArg(12)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(11)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(10)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(9)); pparg3=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(8)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg6=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg7=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg8=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg9=hugs_whnfInt;
    {
    	XCopyArea(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6,pparg7,pparg8,pparg9);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XCopyPlane);
primFun(XS_XCopyPlane) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Word32 pparg2;
    	Ptr pparg3;
    	Int 	pparg4;
    	Int 	pparg5;
    	Word pparg6;
    	Word pparg7;
    	Int 	pparg8;
    	Int 	pparg9;
    	Word32 pparg10;
    	hugs->eval(hugs_primArg(13)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(12)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(11)); pparg2=hugs_whnfInt;
    	hugs->eval(hugs_primArg(10)); pparg3=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(9)); pparg4=hugs_whnfInt;
    	hugs->eval(hugs_primArg(8)); pparg5=hugs_whnfInt;
    	hugs->eval(hugs_primArg(7)); pparg6=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg7=hugs_whnfInt;
    	hugs->eval(hugs_primArg(5)); pparg8=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg9=hugs_whnfInt;
    	hugs->eval(hugs_primArg(3)); pparg10=hugs_whnfInt;
    {
    	XCopyPlane(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg6,pparg7,pparg8,pparg9,pparg10);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawString);
primFun(XS_XDrawString) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	int pparg5_size; char* pparg5;
    	hugs->eval(hugs_primArg(8)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(7)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg2=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg4=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg5_size = ppindex; pparg5 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg5) { hugs_cantReduce(); } pparg5[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg5[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	XDrawString(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg5_size);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XS_XDrawImageString);
primFun(XS_XDrawImageString) {
    {
    	Display     *pparg0;
    	Word32 pparg1;
    	Ptr pparg2;
    	Int 	pparg3;
    	Int 	pparg4;
    	int pparg5_size; char* pparg5;
    	hugs->eval(hugs_primArg(8)); pparg0=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(7)); pparg1=hugs_whnfInt;
    	hugs->eval(hugs_primArg(6)); pparg2=(Ptr)hugs_whnfPtr;
    	hugs->eval(hugs_primArg(5)); pparg3=hugs_whnfInt;
    	hugs->eval(hugs_primArg(4)); pparg4=hugs_whnfInt;
    		{  int ppindex; 
	    hugs->eval(hugs_primArg(3));
	    for (ppindex = 0; hugs_whnfHead == hugs->nameCons; ++ppindex) {
		Cell ppHead = hugs_pop(); 
		Cell ppTail = hugs_pop(); 
		hugs_push(ppHead);
	        hugs->eval(ppTail);
	    }
           pparg5_size = ppindex; pparg5 = (char *) malloc((ppindex+1) * sizeof(char)); if (!pparg5) { hugs_cantReduce(); } pparg5[ppindex] = '\0';
	    while (--ppindex >= 0) {
               hugs->eval(hugs_pop()); pparg5[ppindex]=hugs->CharOf(hugs_whnfHead);
	    }
	};
    {
    	XDrawImageString(pparg0,pparg1,pparg2,pparg3,pparg4,pparg5,pparg5_size);
    	hugsUNIT; hugsSUCC; hugsUPDAPROOT;; return;
    }}
    
    {
    }
}

PROTO_PRIM(XSconsts_AttributeMask);
primFun(XSconsts_AttributeMask) {
        static AttributeMask consts[] = {
    	CWBackPixmap,
    	CWBackPixel,
    	CWBorderPixmap,
    	CWBorderPixel,
    	CWBitGravity,
    	CWWinGravity,
    	CWBackingStore,
    	CWBackingPlanes,
    	CWBackingPixel,
    	CWOverrideRedirect,
    	CWSaveUnder,
    	CWEventMask,
    	CWDontPropagate,
    	CWColormap,
    	CWCursor
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_JoinStyle);
primFun(XSconsts_JoinStyle) {
        static JoinStyle consts[] = {
    	JoinMiter,
    	JoinRound,
    	JoinBevel
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_CapStyle);
primFun(XSconsts_CapStyle) {
        static CapStyle consts[] = {
    	CapNotLast,
    	CapButt,
    	CapRound,
    	CapProjecting
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_BitGravity);
primFun(XSconsts_BitGravity) {
        static BitGravity consts[] = {
    	ForgetGravity
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_Place);
primFun(XSconsts_Place) {
        static Place consts[] = {
    	PlaceOnTop,
    	PlaceOnBottom
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_ScreenSaverMode);
primFun(XSconsts_ScreenSaverMode) {
        static ScreenSaverMode consts[] = {
    	ScreenSaverActive,
    	ScreenSaverReset
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_Visibility);
primFun(XSconsts_Visibility) {
        static Visibility consts[] = {
    	VisibilityUnobscured,
    	VisibilityPartiallyObscured,
    	VisibilityFullyObscured
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_VisualClass);
primFun(XSconsts_VisualClass) {
        static VisualClass consts[] = {
    	StaticGray,
    	GrayScale,
    	StaticColor,
    	PseudoColor,
    	TrueColor,
    	DirectColor
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_PropertyNotification);
primFun(XSconsts_PropertyNotification) {
        static PropertyNotification consts[] = {
    	PropertyNewValue,
    	PropertyDelete
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_WindowClass);
primFun(XSconsts_WindowClass) {
        static WindowClass consts[] = {
    	CopyFromParent,
    	InputOutput,
    	InputOnly
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_EventMask);
primFun(XSconsts_EventMask) {
        static EventMask consts[] = {
    	0,
    	NoEventMask,
    	KeyPressMask,
    	KeyReleaseMask,
    	ButtonPressMask,
    	ButtonReleaseMask,
    	EnterWindowMask,
    	LeaveWindowMask,
    	PointerMotionMask,
    	PointerMotionHintMask,
    	Button1MotionMask,
    	Button2MotionMask,
    	Button3MotionMask,
    	Button4MotionMask,
    	Button5MotionMask,
    	ButtonMotionMask,
    	KeymapStateMask,
    	ExposureMask,
    	VisibilityChangeMask,
    	StructureNotifyMask,
    	ResizeRedirectMask,
    	SubstructureNotifyMask,
    	SubstructureRedirectMask,
    	FocusChangeMask,
    	PropertyChangeMask,
    	ColormapChangeMask,
    	OwnerGrabButtonMask
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_RectangleOrdering);
primFun(XSconsts_RectangleOrdering) {
        static RectangleOrdering consts[] = {
    	Unsorted,
    	YSorted,
    	YXSorted,
    	YXBanded
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_PrimaryMask);
primFun(XSconsts_PrimaryMask) {
        static PrimaryMask consts[] = {
    	DoRed,
    	DoGreen,
    	DoBlue
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_AllowExposuresMode);
primFun(XSconsts_AllowExposuresMode) {
        static AllowExposuresMode consts[] = {
    	DontAllowExposures,
    	AllowExposures,
    	DefaultExposures
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_AllowEvents);
primFun(XSconsts_AllowEvents) {
        static AllowEvents consts[] = {
    	AsyncPointer,
    	SyncPointer,
    	ReplayPointer,
    	AsyncKeyboard,
    	SyncKeyboard,
    	ReplayKeyboard,
    	AsyncBoth,
    	SyncBoth
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_QueryBestSizeClass);
primFun(XSconsts_QueryBestSizeClass) {
        static QueryBestSizeClass consts[] = {
    	CursorShape,
    	TileShape,
    	StippleShape
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_KeyMask);
primFun(XSconsts_KeyMask) {
        static KeyMask consts[] = {
    	ShiftMask,
    	LockMask,
    	ControlMask,
    	Mod1Mask,
    	Mod2Mask,
    	Mod3Mask,
    	Mod4Mask,
    	Mod5Mask
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_LineStyle);
primFun(XSconsts_LineStyle) {
        static LineStyle consts[] = {
    	LineSolid,
    	LineDoubleDash,
    	LineOnOffDash
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_LedMode);
primFun(XSconsts_LedMode) {
        static LedMode consts[] = {
    	LedModeOff,
    	LedModeOn
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_BackingStore);
primFun(XSconsts_BackingStore) {
        static BackingStore consts[] = {
    	NotUseful,
    	WhenMapped,
    	Always
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_Button);
primFun(XSconsts_Button) {
        static Button consts[] = {
    	Button1,
    	Button2,
    	Button3,
    	Button4,
    	Button5
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_NotifyMode);
primFun(XSconsts_NotifyMode) {
        static NotifyMode consts[] = {
    	NotifyNormal,
    	NotifyGrab,
    	NotifyUngrab,
    	NotifyWhileGrabbed,
    	NotifyHint
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_WindowGravity);
primFun(XSconsts_WindowGravity) {
        static WindowGravity consts[] = {
    	UnmapGravity
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_FillRule);
primFun(XSconsts_FillRule) {
        static FillRule consts[] = {
    	EvenOddRule,
    	WindingRule
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_AutoRepeatMode);
primFun(XSconsts_AutoRepeatMode) {
        static AutoRepeatMode consts[] = {
    	AutoRepeatModeOff,
    	AutoRepeatModeOn,
    	AutoRepeatModeDefault
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_GrabStatus);
primFun(XSconsts_GrabStatus) {
        static GrabStatus consts[] = {
    	GrabSuccess,
    	AlreadyGrabbed,
    	GrabInvalidTime,
    	GrabNotViewable,
    	GrabFrozen
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_GrabMode);
primFun(XSconsts_GrabMode) {
        static GrabMode consts[] = {
    	GrabModeSync,
    	GrabModeAsync
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_EventType);
primFun(XSconsts_EventType) {
        static EventType consts[] = {
    	KeyPress,
    	KeyRelease,
    	ButtonPress,
    	ButtonRelease,
    	MotionNotify,
    	EnterNotify,
    	LeaveNotify,
    	FocusIn,
    	FocusOut,
    	KeymapNotify,
    	Expose,
    	GraphicsExpose,
    	NoExpose,
    	VisibilityNotify,
    	CreateNotify,
    	DestroyNotify,
    	UnmapNotify,
    	MapNotify,
    	MapRequest,
    	ReparentNotify,
    	ConfigureNotify,
    	ConfigureRequest,
    	GravityNotify,
    	ResizeRequest,
    	CirculateNotify,
    	CirculateRequest,
    	PropertyNotify,
    	SelectionClear,
    	SelectionRequest,
    	SelectionNotify,
    	ColormapNotify,
    	ClientMessage,
    	MappingNotify,
    	LASTEvent
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_ColormapNotification);
primFun(XSconsts_ColormapNotification) {
        static ColormapNotification consts[] = {
    	ColormapUninstalled,
    	ColormapInstalled
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_Status);
primFun(XSconsts_Status) {
        static Status consts[] = {
    	Success,
    	BadRequest,
    	BadValue,
    	BadWindow,
    	BadPixmap,
    	BadAtom,
    	BadCursor,
    	BadFont,
    	BadMatch,
    	BadDrawable,
    	BadAccess,
    	BadAlloc,
    	BadColor,
    	BadGC,
    	BadIDChoice,
    	BadName,
    	BadLength,
    	BadImplementation,
    	FirstExtensionError,
    	LastExtensionError
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_GXFunction);
primFun(XSconsts_GXFunction) {
        static GXFunction consts[] = {
    	GXclear,
    	GXand,
    	GXandReverse,
    	GXcopy,
    	GXandInverted,
    	GXnoop,
    	GXxor,
    	GXor,
    	GXnor,
    	GXequiv,
    	GXinvert,
    	GXorReverse,
    	GXcopyInverted,
    	GXorInverted,
    	GXnand,
    	GXset
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_FocusMode);
primFun(XSconsts_FocusMode) {
        static FocusMode consts[] = {
    	RevertToNone,
    	RevertToPointerRoot,
    	RevertToParent
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_Gravity);
primFun(XSconsts_Gravity) {
        static Gravity consts[] = {
    	NorthWestGravity,
    	NorthGravity,
    	NorthEastGravity,
    	WestGravity,
    	CenterGravity,
    	EastGravity,
    	SouthWestGravity,
    	SouthGravity,
    	SouthEastGravity,
    	StaticGravity
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_ChangeSaveSetMode);
primFun(XSconsts_ChangeSaveSetMode) {
        static ChangeSaveSetMode consts[] = {
    	SetModeInsert,
    	SetModeDelete
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_SubWindowMode);
primFun(XSconsts_SubWindowMode) {
        static SubWindowMode consts[] = {
    	ClipByChildren,
    	IncludeInferiors
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_ButtonMask);
primFun(XSconsts_ButtonMask) {
        static ButtonMask consts[] = {
    	Button1Mask,
    	Button2Mask,
    	Button3Mask,
    	Button4Mask,
    	Button5Mask
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_ColormapAlloc);
primFun(XSconsts_ColormapAlloc) {
        static ColormapAlloc consts[] = {
    	AllocNone,
    	AllocAll
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_Int);
primFun(XSconsts_Int) {
        static Int consts[] = {
    	sizeof(XEvent),
    	sizeof(XKeyEvent),
    	sizeof(XSetWindowAttributes)
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_NotifyDetail);
primFun(XSconsts_NotifyDetail) {
        static NotifyDetail consts[] = {
    	NotifyAncestor,
    	NotifyVirtual,
    	NotifyInferior,
    	NotifyNonlinear,
    	NotifyNonlinearVirtual,
    	NotifyPointer,
    	NotifyPointerRoot,
    	NotifyDetailNone
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_ImageFormat);
primFun(XSconsts_ImageFormat) {
        static ImageFormat consts[] = {
    	XYBitmap,
    	XYPixmap,
    	ZPixmap
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_CoordinateMode);
primFun(XSconsts_CoordinateMode) {
        static CoordinateMode consts[] = {
    	CoordModeOrigin,
    	CoordModePrevious
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_WindowStackingMethod);
primFun(XSconsts_WindowStackingMethod) {
        static WindowStackingMethod consts[] = {
    	Above,
    	Below,
    	TopIf,
    	BottomIf,
    	Opposite
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_QueuedMode);
primFun(XSconsts_QueuedMode) {
        static QueuedMode consts[] = {
    	QueuedAlready,
    	QueuedAfterFlush,
    	QueuedAfterReading
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_PreferBlankingMode);
primFun(XSconsts_PreferBlankingMode) {
        static PreferBlankingMode consts[] = {
    	DontPreferBlanking,
    	PreferBlanking,
    	DefaultBlanking
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_Modifier);
primFun(XSconsts_Modifier) {
        static Modifier consts[] = {
    	ShiftMapIndex,
    	LockMapIndex,
    	ControlMapIndex,
    	Mod1MapIndex,
    	Mod2MapIndex,
    	Mod3MapIndex,
    	Mod4MapIndex,
    	Mod5MapIndex,
    	AnyModifier
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_ByteOrder);
primFun(XSconsts_ByteOrder) {
        static ByteOrder consts[] = {
    	LSBFirst,
    	MSBFirst
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_Protocol);
primFun(XSconsts_Protocol) {
        static Protocol consts[] = {
    	FamilyInternet,
    	FamilyDECnet,
    	FamilyChaos
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_Access);
primFun(XSconsts_Access) {
        static Access consts[] = {
    	EnableAccess,
    	DisableAccess
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_CloseDownMode);
primFun(XSconsts_CloseDownMode) {
        static CloseDownMode consts[] = {
    	DestroyAll,
    	RetainPermanent,
    	RetainTemporary
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_MappingRequest);
primFun(XSconsts_MappingRequest) {
        static MappingRequest consts[] = {
    	MappingModifier,
    	MappingKeyboard,
    	MappingPointer
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_FillStyle);
primFun(XSconsts_FillStyle) {
        static FillStyle consts[] = {
    	FillSolid,
    	FillTiled,
    	FillOpaqueStippled,
    	FillStippled
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_PolygonShape);
primFun(XSconsts_PolygonShape) {
        static PolygonShape consts[] = {
    	Complex,
    	Nonconvex,
    	Convex
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_ArcMode);
primFun(XSconsts_ArcMode) {
        static ArcMode consts[] = {
    	ArcChord,
    	ArcPieSlice
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

PROTO_PRIM(XSconsts_CirculationDirection);
primFun(XSconsts_CirculationDirection) {
        static CirculationDirection consts[] = {
    	RaiseLowest,
    	LowerHighest
    	};
        int i;
        hugs->eval(hugs_primArg(1)); i=hugs_whnfInt;
        hugsINT(consts[i]); hugsUPDATEROOT;; return;
    
    {
    }
}

struct primitive primTable[] = {
	    {"XStest_isHeapExhaustion", 1, XStest_isHeapExhaustion},
	    {"XS_freePtr", 3, XS_freePtr},
	    {"XS_primMalloc", 3, XS_primMalloc},
	    {"XS_orMask", 2, XS_orMask},
	    {"XS_andMask", 2, XS_andMask},
	    {"XS_notMask", 1, XS_notMask},
	    {"XStest_isNullPtr", 1, XStest_isNullPtr},
	    {"XStest_isBadStatus", 1, XStest_isBadStatus},
	    {"XStest_isZero", 1, XStest_isZero},
	    {"XStest_isFalse", 1, XStest_isFalse},
	    {"XS_XAllPlanes", 0, XS_XAllPlanes},
	    {"XS_XBlackPixel", 2, XS_XBlackPixel},
	    {"XS_XWhitePixel", 2, XS_XWhitePixel},
	    {"XS_ConnectionNumber", 1, XS_ConnectionNumber},
	    {"XS_XDefaultColormap", 2, XS_XDefaultColormap},
	    {"XS_XListDepths", 2, XS_XListDepths},
	    {"XS_XDefaultGC", 2, XS_XDefaultGC},
	    {"XS_XDefaultDepth", 2, XS_XDefaultDepth},
	    {"XS_XDefaultScreen", 1, XS_XDefaultScreen},
	    {"XS_XDefaultScreenOfDisplay", 1, XS_XDefaultScreenOfDisplay},
	    {"XS_DisplayHeight", 2, XS_DisplayHeight},
	    {"XS_DisplayHeightMM", 2, XS_DisplayHeightMM},
	    {"XS_DisplayWidth", 2, XS_DisplayWidth},
	    {"XS_DisplayWidthMM", 2, XS_DisplayWidthMM},
	    {"XS_XMaxRequestSize", 1, XS_XMaxRequestSize},
	    {"XS_XDisplayMotionBufferSize", 1, XS_XDisplayMotionBufferSize},
	    {"XS_XResourceManagerString", 1, XS_XResourceManagerString},
	    {"XS_XScreenResourceString", 1, XS_XScreenResourceString},
	    {"XS_DisplayString", 1, XS_DisplayString},
	    {"XS_XImageByteOrder", 1, XS_XImageByteOrder},
	    {"XS_XProtocolRevision", 1, XS_XProtocolRevision},
	    {"XS_XProtocolVersion", 1, XS_XProtocolVersion},
	    {"XS_XServerVendor", 1, XS_XServerVendor},
	    {"XS_XScreenCount", 1, XS_XScreenCount},
	    {"XS_XDefaultVisual", 2, XS_XDefaultVisual},
	    {"XS_DisplayCells", 2, XS_DisplayCells},
	    {"XS_DisplayPlanes", 2, XS_DisplayPlanes},
	    {"XS_XScreenOfDisplay", 2, XS_XScreenOfDisplay},
	    {"XS_XDefaultRootWindow", 1, XS_XDefaultRootWindow},
	    {"XS_XRootWindow", 4, XS_XRootWindow},
	    {"XS_XQLength", 3, XS_XQLength},
	    {"XS_XNoOp", 3, XS_XNoOp},
	    {"XS_XOpenDisplay", 3, XS_XOpenDisplay},
	    {"XS_XCloseDisplay", 3, XS_XCloseDisplay},
	    {"XS_XrmInitialize", 2, XS_XrmInitialize},
	    {"XS_XAutoRepeatOff", 3, XS_XAutoRepeatOff},
	    {"XS_XAutoRepeatOn", 3, XS_XAutoRepeatOn},
	    {"XS_XBell", 4, XS_XBell},
	    {"XS_XSetCloseDownMode", 4, XS_XSetCloseDownMode},
	    {"XS_XLastKnownRequestProcessed", 3, XS_XLastKnownRequestProcessed},
	    {"XS_XGetInputFocus", 3, XS_XGetInputFocus},
	    {"XS_XSetInputFocus", 6, XS_XSetInputFocus},
	    {"XS_XGrabButton", 12, XS_XGrabButton},
	    {"XS_XUngrabButton", 6, XS_XUngrabButton},
	    {"XS_XGrabPointer", 11, XS_XGrabPointer},
	    {"XS_XUngrabPointer", 4, XS_XUngrabPointer},
	    {"XS_XGrabKey", 9, XS_XGrabKey},
	    {"XS_XUngrabKey", 6, XS_XUngrabKey},
	    {"XS_XGrabKeyboard", 8, XS_XGrabKeyboard},
	    {"XS_XUngrabKeyboard", 4, XS_XUngrabKeyboard},
	    {"XS_XGrabServer", 3, XS_XGrabServer},
	    {"XS_XUngrabServer", 3, XS_XUngrabServer},
	    {"XS_XQueryBestTile", 6, XS_XQueryBestTile},
	    {"XS_XQueryBestStipple", 6, XS_XQueryBestStipple},
	    {"XS_XQueryBestCursor", 6, XS_XQueryBestCursor},
	    {"XS_XQueryBestSize", 7, XS_XQueryBestSize},
	    {"XS_XQueryPointer", 4, XS_XQueryPointer},
	    {"XS_XDisplayName", 1, XS_XDisplayName},
	    {"XS_XEnableAccessControl", 3, XS_XEnableAccessControl},
	    {"XS_XDisableAccessControl", 3, XS_XDisableAccessControl},
	    {"XS_XSetAccessControl", 4, XS_XSetAccessControl},
	    {"XS_get_XEventPtr", 3, XS_get_XEventPtr},
	    {"XS_set_XEventPtr", 4, XS_set_XEventPtr},
	    {"XS_get_XKeyEventPtr", 3, XS_get_XKeyEventPtr},
	    {"XS_set_XKeyEventPtr", 4, XS_set_XKeyEventPtr},
	    {"XS_XFlush", 3, XS_XFlush},
	    {"XS_XSync", 4, XS_XSync},
	    {"XS_XPending", 3, XS_XPending},
	    {"XS_XEventsQueued", 4, XS_XEventsQueued},
	    {"XS_XNextEvent", 4, XS_XNextEvent},
	    {"XS_XAllowEvents", 5, XS_XAllowEvents},
	    {"XS_XSelectInput", 5, XS_XSelectInput},
	    {"XS_XSendEvent", 7, XS_XSendEvent},
	    {"XS_XWindowEvent", 6, XS_XWindowEvent},
	    {"XS_XCheckWindowEvent", 6, XS_XCheckWindowEvent},
	    {"XS_XMaskEvent", 5, XS_XMaskEvent},
	    {"XS_XCheckMaskEvent", 5, XS_XCheckMaskEvent},
	    {"XS_XCheckTypedEvent", 5, XS_XCheckTypedEvent},
	    {"XS_XCheckTypedWindowEvent", 6, XS_XCheckTypedWindowEvent},
	    {"XS_XPutBackEvent", 4, XS_XPutBackEvent},
	    {"XS_XPeekEvent", 4, XS_XPeekEvent},
	    {"XS_XRefreshKeyboardMapping", 3, XS_XRefreshKeyboardMapping},
	    {"XS_XGeometry", 11, XS_XGeometry},
	    {"XS_XGetGeometry", 5, XS_XGetGeometry},
	    {"XS_XSupportsLocale", 2, XS_XSupportsLocale},
	    {"XS_XSetLocaleModifiers", 3, XS_XSetLocaleModifiers},
	    {"XS_XGetScreenSaver", 3, XS_XGetScreenSaver},
	    {"XS_XSetScreenSaver", 7, XS_XSetScreenSaver},
	    {"XS_XActivateScreenSaver", 3, XS_XActivateScreenSaver},
	    {"XS_XResetScreenSaver", 3, XS_XResetScreenSaver},
	    {"XS_XForceScreenSaver", 4, XS_XForceScreenSaver},
	    {"XS_XGetPointerControl", 3, XS_XGetPointerControl},
	    {"XS_XWarpPointer", 11, XS_XWarpPointer},
	    {"XS_XBlackPixelOfScreen", 1, XS_XBlackPixelOfScreen},
	    {"XS_XWhitePixelOfScreen", 1, XS_XWhitePixelOfScreen},
	    {"XS_XCellsOfScreen", 1, XS_XCellsOfScreen},
	    {"XS_XDefaultColormapOfScreen", 1, XS_XDefaultColormapOfScreen},
	    {"XS_XDefaultDepthOfScreen", 1, XS_XDefaultDepthOfScreen},
	    {"XS_XDefaultGCOfScreen", 1, XS_XDefaultGCOfScreen},
	    {"XS_XDefaultVisualOfScreen", 1, XS_XDefaultVisualOfScreen},
	    {"XS_XDoesBackingStore", 1, XS_XDoesBackingStore},
	    {"XS_XDoesSaveUnders", 1, XS_XDoesSaveUnders},
	    {"XS_DisplayOfScreen", 1, XS_DisplayOfScreen},
	    {"XS_XEventMaskOfScreen", 1, XS_XEventMaskOfScreen},
	    {"XS_XMinCmapsOfScreen", 1, XS_XMinCmapsOfScreen},
	    {"XS_XMaxCmapsOfScreen", 1, XS_XMaxCmapsOfScreen},
	    {"XS_XRootWindowOfScreen", 1, XS_XRootWindowOfScreen},
	    {"XS_XWidthOfScreen", 1, XS_XWidthOfScreen},
	    {"XS_XWidthMMOfScreen", 1, XS_XWidthMMOfScreen},
	    {"XS_XHeightOfScreen", 1, XS_XHeightOfScreen},
	    {"XS_XHeightMMOfScreen", 1, XS_XHeightMMOfScreen},
	    {"XS_XPlanesOfScreen", 1, XS_XPlanesOfScreen},
	    {"XS_XScreenNumberOfScreen", 1, XS_XScreenNumberOfScreen},
	    {"XS_XSetArcMode", 5, XS_XSetArcMode},
	    {"XS_XSetBackground", 5, XS_XSetBackground},
	    {"XS_XSetForeground", 5, XS_XSetForeground},
	    {"XS_XSetFunction", 5, XS_XSetFunction},
	    {"XS_XSetGraphicsExposures", 5, XS_XSetGraphicsExposures},
	    {"XS_XSetClipMask", 5, XS_XSetClipMask},
	    {"XS_XSetClipOrigin", 6, XS_XSetClipOrigin},
	    {"XS_XSetDashes", 7, XS_XSetDashes},
	    {"XS_XSetFillRule", 5, XS_XSetFillRule},
	    {"XS_XSetFillStyle", 5, XS_XSetFillStyle},
	    {"XS_XSetFont", 5, XS_XSetFont},
	    {"XS_XSetLineAttributes", 8, XS_XSetLineAttributes},
	    {"XS_XSetPlaneMask", 5, XS_XSetPlaneMask},
	    {"XS_XSetState", 8, XS_XSetState},
	    {"XS_XSetStipple", 5, XS_XSetStipple},
	    {"XS_XSetSubwindowMode", 5, XS_XSetSubwindowMode},
	    {"XS_XSetTSOrigin", 6, XS_XSetTSOrigin},
	    {"XS_XSetTile", 5, XS_XSetTile},
	    {"XS_XCreateGC", 4, XS_XCreateGC},
	    {"XS_XFreeGC", 4, XS_XFreeGC},
	    {"XS_XFlushGC", 4, XS_XFlushGC},
	    {"XS_XCreatePixmap", 7, XS_XCreatePixmap},
	    {"XS_XFreePixmap", 4, XS_XFreePixmap},
	    {"XS_XBitmapBitOrder", 1, XS_XBitmapBitOrder},
	    {"XS_XBitmapUnit", 1, XS_XBitmapUnit},
	    {"XS_XBitmapPad", 1, XS_XBitmapPad},
	    {"XS_XLookupColor", 5, XS_XLookupColor},
	    {"XS_XAllocNamedColor", 5, XS_XAllocNamedColor},
	    {"XS_XAllocColor", 5, XS_XAllocColor},
	    {"XS_XParseColor", 5, XS_XParseColor},
	    {"XS_XFreeColors", 6, XS_XFreeColors},
	    {"XS_XStoreColor", 5, XS_XStoreColor},
	    {"XS_XStoreColors", 5, XS_XStoreColors},
	    {"XS_XStoreNamedColor", 7, XS_XStoreNamedColor},
	    {"XS_XQueryColor", 5, XS_XQueryColor},
	    {"XS_XQueryColors", 5, XS_XQueryColors},
	    {"XS_XInstallColormap", 4, XS_XInstallColormap},
	    {"XS_XUninstallColormap", 4, XS_XUninstallColormap},
	    {"XS_XCopyColormapAndFree", 4, XS_XCopyColormapAndFree},
	    {"XS_XCreateColormap", 6, XS_XCreateColormap},
	    {"XS_XFreeColormap", 4, XS_XFreeColormap},
	    {"XS_XQueryFont", 4, XS_XQueryFont},
	    {"XS_XLoadQueryFont", 4, XS_XLoadQueryFont},
	    {"XS_XFreeFont", 4, XS_XFreeFont},
	    {"XS_XDisplayKeycodes", 1, XS_XDisplayKeycodes},
	    {"XS_XLookupKeysym", 4, XS_XLookupKeysym},
	    {"XS_XKeycodeToKeysym", 5, XS_XKeycodeToKeysym},
	    {"XS_XKeysymToKeycode", 4, XS_XKeysymToKeycode},
	    {"XS_XKeysymToString", 1, XS_XKeysymToString},
	    {"XS_XStringToKeysym", 1, XS_XStringToKeysym},
	    {"XS_XGetIconName", 4, XS_XGetIconName},
	    {"XS_XSetIconName", 5, XS_XSetIconName},
	    {"XS_XDefineCursor", 5, XS_XDefineCursor},
	    {"XS_XUndefineCursor", 4, XS_XUndefineCursor},
	    {"XS_XCreatePixmapCursor", 9, XS_XCreatePixmapCursor},
	    {"XS_XCreateGlyphCursor", 9, XS_XCreateGlyphCursor},
	    {"XS_XCreateFontCursor", 4, XS_XCreateFontCursor},
	    {"XS_XFreeCursor", 4, XS_XFreeCursor},
	    {"XS_XRecolorCursor", 6, XS_XRecolorCursor},
	    {"XS_set_background_pixmap", 4, XS_set_background_pixmap},
	    {"XS_set_background_pixel", 4, XS_set_background_pixel},
	    {"XS_set_border_pixmap", 4, XS_set_border_pixmap},
	    {"XS_set_border_pixmel", 4, XS_set_border_pixmel},
	    {"XS_set_bit_gravity", 4, XS_set_bit_gravity},
	    {"XS_set_win_gravity", 4, XS_set_win_gravity},
	    {"XS_set_backing_store", 4, XS_set_backing_store},
	    {"XS_set_backing_planes", 4, XS_set_backing_planes},
	    {"XS_set_backing_pixel", 4, XS_set_backing_pixel},
	    {"XS_set_save_under", 4, XS_set_save_under},
	    {"XS_set_event_mask", 4, XS_set_event_mask},
	    {"XS_set_do_not_propagate_mask", 4, XS_set_do_not_propagate_mask},
	    {"XS_set_overide_redirect", 4, XS_set_overide_redirect},
	    {"XS_set_colormap", 4, XS_set_colormap},
	    {"XS_set_cursor", 4, XS_set_cursor},
	    {"XS_XStoreName", 5, XS_XStoreName},
	    {"XS_XCreateSimpleWindow", 11, XS_XCreateSimpleWindow},
	    {"XS_XCreateWindow", 14, XS_XCreateWindow},
	    {"XS_XTranslateCoordinates", 7, XS_XTranslateCoordinates},
	    {"XS_XMoveResizeWindow", 8, XS_XMoveResizeWindow},
	    {"XS_XResizeWindow", 6, XS_XResizeWindow},
	    {"XS_XMoveWindow", 6, XS_XMoveWindow},
	    {"XS_XReparentWindow", 7, XS_XReparentWindow},
	    {"XS_XMapSubwindows", 4, XS_XMapSubwindows},
	    {"XS_XUnmapSubwindows", 4, XS_XUnmapSubwindows},
	    {"XS_XMapWindow", 4, XS_XMapWindow},
	    {"XS_XLowerWindow", 4, XS_XLowerWindow},
	    {"XS_XRaiseWindow", 4, XS_XRaiseWindow},
	    {"XS_XCirculateSubwindowsDown", 4, XS_XCirculateSubwindowsDown},
	    {"XS_XCirculateSubwindowsUp", 4, XS_XCirculateSubwindowsUp},
	    {"XS_XCirculateSubwindows", 5, XS_XCirculateSubwindows},
	    {"XS_XIconifyWindow", 5, XS_XIconifyWindow},
	    {"XS_XWithdrawWindow", 5, XS_XWithdrawWindow},
	    {"XS_XDestroyWindow", 4, XS_XDestroyWindow},
	    {"XS_XDestroySubwindows", 4, XS_XDestroySubwindows},
	    {"XS_XSetWindowBorder", 5, XS_XSetWindowBorder},
	    {"XS_XSetWindowBorderPixmap", 5, XS_XSetWindowBorderPixmap},
	    {"XS_XSetWindowBorderWidth", 5, XS_XSetWindowBorderWidth},
	    {"XS_XSetWindowBackground", 5, XS_XSetWindowBackground},
	    {"XS_XSetWindowBackgroundPixmap", 5, XS_XSetWindowBackgroundPixmap},
	    {"XS_XSetWindowColormap", 5, XS_XSetWindowColormap},
	    {"XS_XAddToSaveSet", 4, XS_XAddToSaveSet},
	    {"XS_XRemoveFromSaveSet", 4, XS_XRemoveFromSaveSet},
	    {"XS_XChangeSaveSet", 5, XS_XChangeSaveSet},
	    {"XS_XClearWindow", 4, XS_XClearWindow},
	    {"XS_XClearArea", 9, XS_XClearArea},
	    {"XS_XQueryTree", 4, XS_XQueryTree},
	    {"XS_XRestackWindows", 4, XS_XRestackWindows},
	    {"XS_XListInstalledColormaps", 4, XS_XListInstalledColormaps},
	    {"XS_XGetTransientForHint", 4, XS_XGetTransientForHint},
	    {"XS_XSetTransientForHint", 5, XS_XSetTransientForHint},
	    {"XS_XDrawPoint", 7, XS_XDrawPoint},
	    {"XS_XDrawPoints", 7, XS_XDrawPoints},
	    {"XS_XDrawLine", 9, XS_XDrawLine},
	    {"XS_XDrawLines", 7, XS_XDrawLines},
	    {"XS_XDrawSegments", 6, XS_XDrawSegments},
	    {"XS_XDrawRectangle", 9, XS_XDrawRectangle},
	    {"XS_XDrawRectangles", 6, XS_XDrawRectangles},
	    {"XS_XDrawArc", 11, XS_XDrawArc},
	    {"XS_XDrawArcs", 6, XS_XDrawArcs},
	    {"XS_XFillRectangle", 9, XS_XFillRectangle},
	    {"XS_XFillRectangles", 6, XS_XFillRectangles},
	    {"XS_XFillPolygon", 8, XS_XFillPolygon},
	    {"XS_XFillArc", 11, XS_XFillArc},
	    {"XS_XFillArcs", 6, XS_XFillArcs},
	    {"XS_XCopyArea", 12, XS_XCopyArea},
	    {"XS_XCopyPlane", 13, XS_XCopyPlane},
	    {"XS_XDrawString", 8, XS_XDrawString},
	    {"XS_XDrawImageString", 8, XS_XDrawImageString},
	    {"XSconsts_AttributeMask", 1, XSconsts_AttributeMask},
	    {"XSconsts_JoinStyle", 1, XSconsts_JoinStyle},
	    {"XSconsts_CapStyle", 1, XSconsts_CapStyle},
	    {"XSconsts_BitGravity", 1, XSconsts_BitGravity},
	    {"XSconsts_Place", 1, XSconsts_Place},
	    {"XSconsts_ScreenSaverMode", 1, XSconsts_ScreenSaverMode},
	    {"XSconsts_Visibility", 1, XSconsts_Visibility},
	    {"XSconsts_VisualClass", 1, XSconsts_VisualClass},
	    {"XSconsts_PropertyNotification", 1, XSconsts_PropertyNotification},
	    {"XSconsts_WindowClass", 1, XSconsts_WindowClass},
	    {"XSconsts_EventMask", 1, XSconsts_EventMask},
	    {"XSconsts_RectangleOrdering", 1, XSconsts_RectangleOrdering},
	    {"XSconsts_PrimaryMask", 1, XSconsts_PrimaryMask},
	    {"XSconsts_AllowExposuresMode", 1, XSconsts_AllowExposuresMode},
	    {"XSconsts_AllowEvents", 1, XSconsts_AllowEvents},
	    {"XSconsts_QueryBestSizeClass", 1, XSconsts_QueryBestSizeClass},
	    {"XSconsts_KeyMask", 1, XSconsts_KeyMask},
	    {"XSconsts_LineStyle", 1, XSconsts_LineStyle},
	    {"XSconsts_LedMode", 1, XSconsts_LedMode},
	    {"XSconsts_BackingStore", 1, XSconsts_BackingStore},
	    {"XSconsts_Button", 1, XSconsts_Button},
	    {"XSconsts_NotifyMode", 1, XSconsts_NotifyMode},
	    {"XSconsts_WindowGravity", 1, XSconsts_WindowGravity},
	    {"XSconsts_FillRule", 1, XSconsts_FillRule},
	    {"XSconsts_AutoRepeatMode", 1, XSconsts_AutoRepeatMode},
	    {"XSconsts_GrabStatus", 1, XSconsts_GrabStatus},
	    {"XSconsts_GrabMode", 1, XSconsts_GrabMode},
	    {"XSconsts_EventType", 1, XSconsts_EventType},
	    {"XSconsts_ColormapNotification", 1, XSconsts_ColormapNotification},
	    {"XSconsts_Status", 1, XSconsts_Status},
	    {"XSconsts_GXFunction", 1, XSconsts_GXFunction},
	    {"XSconsts_FocusMode", 1, XSconsts_FocusMode},
	    {"XSconsts_Gravity", 1, XSconsts_Gravity},
	    {"XSconsts_ChangeSaveSetMode", 1, XSconsts_ChangeSaveSetMode},
	    {"XSconsts_SubWindowMode", 1, XSconsts_SubWindowMode},
	    {"XSconsts_ButtonMask", 1, XSconsts_ButtonMask},
	    {"XSconsts_ColormapAlloc", 1, XSconsts_ColormapAlloc},
	    {"XSconsts_Int", 1, XSconsts_Int},
	    {"XSconsts_NotifyDetail", 1, XSconsts_NotifyDetail},
	    {"XSconsts_ImageFormat", 1, XSconsts_ImageFormat},
	    {"XSconsts_CoordinateMode", 1, XSconsts_CoordinateMode},
	    {"XSconsts_WindowStackingMethod", 1, XSconsts_WindowStackingMethod},
	    {"XSconsts_QueuedMode", 1, XSconsts_QueuedMode},
	    {"XSconsts_PreferBlankingMode", 1, XSconsts_PreferBlankingMode},
	    {"XSconsts_Modifier", 1, XSconsts_Modifier},
	    {"XSconsts_ByteOrder", 1, XSconsts_ByteOrder},
	    {"XSconsts_Protocol", 1, XSconsts_Protocol},
	    {"XSconsts_Access", 1, XSconsts_Access},
	    {"XSconsts_CloseDownMode", 1, XSconsts_CloseDownMode},
	    {"XSconsts_MappingRequest", 1, XSconsts_MappingRequest},
	    {"XSconsts_FillStyle", 1, XSconsts_FillStyle},
	    {"XSconsts_PolygonShape", 1, XSconsts_PolygonShape},
	    {"XSconsts_ArcMode", 1, XSconsts_ArcMode},
	    {"XSconsts_CirculationDirection", 1, XSconsts_CirculationDirection},

	    {0,0,0}
};

static Void controlexterns Args((Int));
static Void local controlexterns(what)
Int what; {
    switch (what) {
	case INSTALL : 
		XSname_HeapExhaustion = hugs->addPrimCfun(hugs->inventText(),0,0,NIL);
		XSname_NullPtr = hugs->addPrimCfun(hugs->inventText(),0,0,NIL);
		XSname_BadStatus = hugs->addPrimCfun(hugs->inventText(),1,0,NIL);
		XSname_Zero = hugs->addPrimCfun(hugs->inventText(),0,0,NIL);
		XSname_False = hugs->addPrimCfun(hugs->inventText(),0,0,NIL);

                break;
    }
}
static struct primInfo prims = { controlexterns, primTable, 0 };

/* After dynamically loading a module, Hugs looks up this symbol and
 * calls it with a "virtual function table" containing all necessary
 * parts of the Hugs API.  
 * (Much painful experimentation established that this was the most
 *  portable way for a DLL/shared object to access parts of Hugs.)
 *
 * This should be the only symbol exported from this module.
 */
DLLEXPORT(void) initModule(HugsAPI *);
DLLEXPORT(void) initModule(HugsAPI *hugsAPI) {
    hugs = hugsAPI;
    hugs->registerPrims(&prims);
    controlexterns(INSTALL);
}
